History starts at first public release. The history order has been
reversed so that new features are at the top.

This history is "historical".  See "history.txt" for more recent entries.

30-Dec-2003
	- Eric Sunshine applied patch from Bjorn Hansen
	  <holomorph@users.sourceforge.net> which adds csParseMouseDef() to
	  'inpnames'.  His patch also fixes csParseKeyDef() so that invalid key
	  names don't just take the first character and return true.  Instead
	  it returns false as it should.  Eric also applied a few bug fixes and
	  improvements to Bjorn's patch.
	- Jorrit fixed a compile error introduced with the latest patch
	  from Bjorn. The fix is incorrect (just commented out the line
	  that doesn't compile) so a real fix is needed.
	- Eric Sunshine applied a fix to csParseMouseDef() instead of merely
	  commenting out the code.
	- Steven Geens probably fixed an out-of-sync hierarchical meshing
	  problem in spr3d.
29-Dec-2003
	- Eric Sunshine changed user.mak so the old OpenGL renderer is not
	  built when USE_NEW_RENDERER is 'yes'.
	- Eric Sunshine applied patch from Bjorn Hansen
	  <holomorph@users.sourceforge.net> for csInputBinder::HandleEvent().
	  It was completely ignoring key down events and mis-interpreting key
	  up events as key down events.
	- Steven Geens added sockets to sprcal3d. The PositionChild method
	  hasn't been implemented yet. Steven Geens also fixed some minor
	  bugs in sprcal3d.h and configure.ac.
	- Steven Geens implemented the PositionChild method of sprcal3d.
	  The socket system should now be completely ready.
28-Dec-2003
	- Philip Wyett fixed a few config files so Freetype2 could again be
	  invoked.
	- Steven Geens added iMeshObject::PositionChild(iMeshObject*
	  child, csTicks time) and an empty implementation for each of its
	  subclasses. He also added code to the OR to place hierarchical
	  children with this method.
	- Steven Geens changed spr3d so it now uses PositionChild() and not
	  DrawTest() to place hierarchical children.
27-Dec-2003
	- Philip Wyett continued a general cleanup of CS code formatting.
	- Philip Wyett added 'docconv' to the root CS directory .cvsignore.
26-Dec-2003
	- Philip Wyett continued a general cleanup of CS code formatting.
25-Dec-2003
	- Philip Wyett performed some cleanup of CS code formatting.
	- Eric Sunshine applied patch from Bruce Williams
	  <midnightcoder@midnightcoder.com> to cs_world.xsd (XML schema) which
	  fixes a couple typographical errors (rotx,roty,rotx), etc.
24-Dec-2003
	- Eric Sunshine fixed linking problem with csjoywin.  It was using
	  #define INITGUID before #including windows.h, and was also linking
	  against dbguid.lib.  It needs to do one of these, but not both.
23-Dec-2003
	- Jorrit fixed a problem in iLoader->LoadTexture(). It would register
	  the texture twice resuling in two texture handles. For the OR this
	  is actually not a real problem (except for wasting resources) but
	  the NR could not cope with this.
	- Luca fixed a bug in the csEventQueue::CreateEvent(uint8 type)
	  method. The method was not setting the flag CSEF_BROADCAST when the
	  the event's Type is csevBroadcast.
21-Dec-2003
	- res added a shader, or_lighting.xml, which mimics the old renderer.
	- res fixed genmesh to provide the lighting as vertex colors on NR as
	  well.
	- res augmented xmlshader to report a warning when an unknown buffer
	  destination was specified.
	- Philipp Aumayr added 3 functions to iWin32Assitant so that it's now
	  less of a pain to use an external message loop.  2 of those functions
	  are for setting/getting a state wether CS should use its MSG loop,
	  the third function is to send Win32 messages to CS.
	- Anders Stenberg removed a ; in Fixed fP the kept it from compiling;
	- Anders Stenberg made a better "draw the last pixel of the line"-fix
	  in the 2D renderer.
	- Anders Stenberg re-enabled DrawPixmap in NR, since it by some reason
	  was disabled. (Probably my fault. :)
	- res fixed drawing of unlit Thing polys in NR.
	- res fixed a non-virtual destructor in terrfunc.
	- Eric sunshine renamed the following macros in order to avoid
	  pollution of the global namespace.  (The old names are still
	  recognized, though deprecated.)
	    STATIC_CAST()      --> CS_STATIC_CAST()
	    DYNAMIC_CAST()     --> CS_DYNAMIC_CAST()
	    REINTERPRET_CAST() --> CS_REINTERPRET_CAST()
	    CONST_CAST()       --> CS_CONST_CAST()
	- Eric Sunshine corrected order of libraries in DEP.RENDSTEP_STENCIL to
	  fix linking problem on Cygwin (hopefully).
	- Eric Sunshine fixed bug in cspace.i.	Was using bogus %ignoren rather
	  than %ignore.
	- Anders Stenberg made the following changes to NR to
	  bring it closer to OR:
	    - Made or_lighting the default shader, with a renderloop to fit it.
	    - Added a "zmesh" z-mode for renderloop passes, that uses the
	      z-mode set by the mesh.
	    - Moved the adding of a default shader to materials from loader to
	      engine, so that materials created from code also will get it.
	  These changes mean that all the simp* applications should work
	  pretty good. There still is a problem with textures on the sprites in
	  simple2 and simpcd. This seems to be caused by engine->Prepare being
	  called _before_ all textures are created/loaded. Is that behaviour
	  allowed?
20-Dec-2003
	- Andreas Busch added Yield() to csThread for posix and win32.
	- res made some changes to GL proc texes and the GL canvas to work
	  around flipping issues.
	- res fixed compiling in Win32 after recent Yield() addition: Yield
	  is #defined empty in winbase.h, causing trouble. #undefined in
	  win32/csosdefs.h now.
	- res updated the "cal3d sufficiently recent" configure test.
	- res fixed the remaining plugins in plugins/mesh to utilize the
	  SCF_DESTRUCT_* macros.
	- res fixed a compile error on odedynam on gcc 3.3, reported by andres
	  from IRC.
	- res commented out some #ifdefs in the light loading code
	  distinguishing between NR and OR, causing incorrect lighting with NR
	  in some cases.
	- Eric Sunshine added a bunch of missing SCF_DESTRUCT_IBASE() and
	  SCF_DESTRUCT_EMBEDDED_IBASE() invocations which Frank missed when he
	  updated the CS/plugins/mesh directory to invoke these macros.
	- Eric Sunshine added a bunch of missing SCF_DESTRUCT_IBASE() and
	  SCF_DESTRUCT_EMBEDDED_IBASE() invocations to classes in
	  CS/plugins/video/render3d/shader which had been added to the project
	  after Eric had added these macros to all classes in the
	  CS/plugins/video directory.
19-Dec-2003
	- Eric Sunshine added the new method
	  csInitializer::RequestPlugins(csArray<csPluginRequest> const&) to
	  complement the existing variable-argument RequestPlugins(...).  The
	  new method allows the list of plugins to be composed at run-time,
	  whereas the old method required the list to be known at compile-time,
	  which was not always convenient or possible.	For example, the
	  scripting interfaces can not know the list of plugins at
	  compile-time, so they have been forced to invoke RequestPlugins()
	  once per plugin, which is semantically incorrect and causes plugin
	  dependency logic to fail.  The new method will allow scripting
	  interfaces to correctly invoke RequestPlugins() once only with the
	  full list of requested plugins.
	- Jorrit removed some old callback code from the generic renderloop
	  plugin.
	- Jorrit removed some warnings from stdrep and also fixed a wrong
	  printf statement (%0.77s is not valid).
	- Eric Sunshine changed csArray<> and csBlockAllocator<> to perform
	  explicit object destruction via p->~T() rather than p->T::~T() in
	  order to pacify the Borland compiler which seems to be inexplicably
	  buggy and which "randomly" emits bogus error messages about
	  "destructor not matching class name" in a few cases where csArray<>
	  and csBlockAllocator<> are used.  The reason we were using p->T::~T()
	  in the first place was that some older (buggy) C++ compilers disliked
	  p->~T(), however I think that we no longer support those compilers,
	  thus p->~T() should be safe.	If, however, we find that some
	  compilers still complain about this notation, then we will have to
	  pursue a more complicated solution.
	- Eric Sunshine added a lot of missing Doxygen comments to csMutex,
	  csSemaphore, and csCondition.
	- Eric Sunshine fixed an historical anomaly in csEventQueue where it
	  was creating a single stack-based csEvent for broadcast of the
	  cscmdPreProcess, cscmdProcess, cscmdPostProcess, and
	  cscmdFinalProcess pseudo-events.  This was problematic for two
	  reasons.  First, the event would be destroyed out from under
	  receivers of the event even if they claimed co-ownership of the event
	  via IncRef().	 Second, the event object mutated from cscmdPreProcess
	  to cscmdProcess to cscmdPostProcess to cscmdFinalProcess.  This could
	  cause grief for a module which claimed co-ownership of an event.  For
	  instance, what a module thought was a cscmdPreProcess event at the
	  time that it invoked IncRef(), might suddenly become a
	  cscmdFinalProcess a short time later.	 This broke the
	  event-is-immutable invariant.	 To fix, these pseudo-events are now
	  reclaimed from the event pool just like any other event.
	- Eric Sunshine replaced csEventQueue's unsafe spin-lock with a csMutex
	  in order to ensure proper thread-safety.
	- Eric Sunshine changed csEventQueue's ListenerVector to a simple
	  csArray<> rather than a csDirtyAccessArray<>, since the "special"
	  functionality of csDirtyAccessArray<> was neither required nor used.
	- Eric Sunshine applied patch from Randall Foreman
	  <eidpers@comcast.net> which fixes a number of cases where classes
	  were accidentally inheriting SCF interfaces privately, rather than
	  publicly.
	- Eric Sunshine applied patch from Randall Foreman
	  <eidpers@comcast.net> which fixes a number of const versus non-const
	  conflicts from the return value of strchr().	Eric also re-wrote some
	  of the code to avoid these conflicts altogether.
	- Eric Sunshine fixed bug in csGraphics3DOGLCommon::DebugCommand()
	  where it was incorrectly parsing the the incoming command string with
	  the result that it failed to recognize commands with arguments.
	- Eric Sunshine fixed bugs in csLoader::ParseHeightgenValue().	Was
	  returning boolean values even though function is declared as
	  returning csGenerateImageValue*.  Reported by Randall Foreman
	  <eidpers@comcast.net>
	- Eric Sunshine updated awsEmbeddedComponent to reflect Jorrit's
	  addition yesterday of iAwsComponent::setPreferredSize() and
	  clearPreferredSize().
18-Dec-2003
	- Jorrit added two new methods to iAwsComponent. One to set the
	  preferred size and one to clear it again. This way one can forcibly
	  set the preferred size of some component. This is useful for
	  some layout managers like BorderLayout so you can have better
	  control over the layout.
	- Eric Sunshine fixed bugs in glshader_fixed.mak and softshader.mak
	  where header files (.h) were being listed in SRC.GLSHADER_FIXED and
	  SRC.SOFTSHADER.  This resulted in the values of OBJ.GLSHADER_FIXED
	  and OBJ.SOFTSHADER becoming corrupted, which caused the build to
	  fail.
	- Jorrit added 'xmlread' to Jamrules for the static compile of
	  walktest.
	- Anders Stenberg fixed static LOD in new renderer.
	- Anders Stenberg (hopefully) fixed some off-by-one problems in NR GL
	  coordinate systems. No idea why they were setup as they were. Hope
	  it didn't have some ingenious significance and I botched it up.
	- Anders Stenberg made GL extension manager only print extension info
	  when verbose mode is enabled.
	- Philip Wyett added missing newline at the end of the file to
	  shadermgr.cpp and xmlshader.h.
	- Anders Stenberg modified standard reporter to give a more easy to
	  read output to the console and to the yellow popup.
	- Anders Stenberg fixed one more off-by-one problem in GL canvas with
	  NR. Blit was off one pixel along Y.
	- res added GL_ARB_shading_language_100 and GL_ARB_shader_objects
	  extensions to the GL extension manager.
17-Dec-2003
	- Jorrit fixed an initialition bug in the xmlshader compiler.
	  It would not initialize the writemask which means that you could
	  get random color effects in the new renderer.
	- Jorrit fixed waterdemo.cfg which was depending on the font
	  multiplexer for some reason.
	- Jorrit fixed a crash bug in the OpenGL renderer introduced
	  yesterday. This would cause walktest to crash at exit.
	- Jorrit fixed various problems with lights caused by not
	  initializing the influence radius properly in the constructor.
	- Jorrit fixed the thing plugin so that the 'clear' in
	  InitializeDefault actually clears the lightmaps. This should fix
	  engine->ForceRelight() but it doesn't so more bug hunting is
	  needed.
	- Jorrit removed some left-over old code from the thing plugin
	  to prepare lightmaps. It was doing a loop over all polygons
	  and doing nothing in that loop.
	- Jorrit added some debug code to scan for big memory allocations
	  in memdebug.cpp.
	- Anders Stenberg fixed procedural textures in NR.
	- Eric Sunshine fixed problem in cspython.mak from 14-Dec-2003 where it
	  was using raw library names (such as "gdi") from
	  PYTHMOD.LIBS.PLATFORM when trying to link cspython.dll, rather than
	  using proper library references (such as "-lgdi") in the link
	  command.
16-Dec-2003
	- Jorrit fixed a warning in shadervar.h with initializers given in
	  the wrong order.
	- Jorrit fixed another similar warning in shadervar.cpp.
	- Jorrit fixed memdebug.cpp so that it now includes platform.h
	  before testing for CS_EXTENSIVE_MEMDEBUG. That flag is set in
	  volatile.h but since memdebug.cpp needs to test for that flag
	  BEFORE loading cssysdef.h we have to include volatile.h (through
	  platform.h) manually.
	- Jorrit removed the rest of r3dtest. Marten apparently only
	  removed the .cpp file.
	- Jorrit fixed the 'nrall' target that was removed because it
	  was part of the r3dtest Jamfile. Now nrall is a compile group
	  to which every relevant target adds itself.
	- Jorrit also fixed 'walkall' target and 'walktest_static' for new
	  renderer.
	- Jorrit fixed some bugs in the jamfiles related to the new renderer.
	- Jorrit fixed ball jamfile so it links with csgfx library now.
	- Jorrit fixed a problem in the generic renderstep plugin. It is
	  possible that when rendersteps are created the shader manager
	  was not yet loaded by the GL renderer. This happens in particular
	  when the engine creates the default render loops in its
	  Initialize() function. Solved this by testing if shaderManager
	  is not 0 in the RenderMeshes() call and querying it from the
	  object registry if 0.
	- Jorrit fixed a bug in the OpenGL renderer which was not clearing
	  the texture cache when g3d->ClearCache() is called. Unfortunatelly
	  this doesn't fix engine->ForceRelight() so more debugging is
	  needed.
	- Jorrit fixed a bug in the thing plugin. PrepareLighting() wasn't
	  updating the super lightmap data really. This fixes ForceRelight()
	  in the sense that something happens now but it appears to be too
	  bright.
	- Eric Sunshine added iSCF::GetInterfaceName() to complement the
	  existing iSCF::GetInterfaceID().
	- Eric Sunshine added missing 'const' qualifiers to csStringSet.
15-Dec-2003
	- Matze reworked some jam rules so that subdirs are more robust now.
	  This should also fix some msvcgen problems on jam.
	- Marten commited the merged branch NEW_SHADERSYS back into HEAD.
	- Anders Stenberg fixed some problems with Marten's branch merge.
	  (Ball & Genmesh wouldn't compile in OR.)
14-Dec-2003
	- Eric Sunshine added --with[out]-python and --with[out]-perl options
	  to configure.ac to allow users to disable these modules if desired.
	- Eric Sunshine fixed configure.ac so that the "Python SDK usable"
	  check is run only if the Python SDK is detected.  (Previously the
	  "SDK usable" check was run even if the SDK was not detected.)
	- Eric Sunshine enabled the "Perl SDK usable" check in configure.ac.
	- Eric Sunshine renamed configure.ac output variable
	  PERL5.SDK.AVAILABLE to PERL5.AVAILABLE to be consistent with
	  PYTHON.AVAILABLE.  (Also deprecated the old meaning of
	  PERL5.AVAILABLE which was "yes" when the perl program itself was
	  detected, but which was not used by either build system.)
	- Eric Sunshine eliminated ugly quadrigraphs in configure.ac by
	  properly quoting arguments in which they were used.  For instance,
	  [[#include <foo.h>]] rather than [@%:@include <foo.h>].
	- Eric Sunshine added #include <sys/ioctl.h> to Linux Joystick test in
	  configure.ac and to csjoylin.cpp.  Reported as necessary for Linux
	  2.2 by Dariusz Dawidowski <chfsoft@interia.pl>.
	- Luca fixed a bug in awsTextBox class: in fact it was not possible to
	  delete with the 'Del' key the first character contained in the text
	  box.
	- Luca added a 'friend' declaration to make the physics ode plugin
	  compile properly on VisualC++ 6.
	- Eric Sunshine fixed bug in cspython.mak where platform-specific
	  Python libraries were not being used when building cspython, thus
	  resulting in unresolved _CreateSolidBrush@4 symbol (which exists in
	  gdi.lib).
	- Eric Sunshine fixed bug in csLoadLibrary() on Windows.  When looking
	  up "plugin_compiler" symbol in DLL, it was calling GetProcAddress()
	  rather than csGetLibrarySymbol().  This caused lookup of
	  "plugin_compiler" to fail with Borland since GetProcAddress() is not
	  smart enough to try both "plugin_compiler" and "_plugin_compiler",
	  whereas csGetLibrarySymbol() is.
	- Wouter Wijngaards fixed an off-by-one bug in csconin, where if
	  you pressed the up arrow you would get the line before the previous
	  line instead of the previous line.
	- Marten removed String shadervariabletype.
	- Marten added accessors to shadervariable system. Currently they
	  are only implemented for genmesh buffers, but they should be
	  implemented in all meshtypes.
13-Dec-2003
	- Eric Sunshine applied patch from Randall Foreman
	  <eidpers@comcast.net>.  csModelConverterASE was accidentally
	  inheriting iModelConverter privately, rather than publicly.
12-Dec-2003
	- res added a 'console control handler' for Win32.  It handles proper
	  shutdown of the app in case the 'Close' button on the console window
	  is pressed, the user logs off or the system shuts down.
	- James Thompson extended swig wraper to provide overloaded
	  iAws::SetupCanvas (iGraphics2D *g2d=0, iGraphics3D *g3d=0) The
	  default C++ usage of SetupCanvas expects a NULL pointer to an
	  iAwsCanvas.  The swig wrappers won't allow a NULL/0 to be used.
	- Eric Sunshine changed configure.ac to check for a usable FreeType2
	  installation by testing for features actually required by Crystal
	  Space, rather than simply checking the library's version number since
	  the version number check was unreliable.  (For instance, one might
	  install FreeType 2.1.3, yet "freetype-config --version" will report
	  9.0.2 or some such.)
	- Eric Sunshine augmented configure.ac so that it prefers "ranlib -s"
	  on MacOS/X, since Panther emits a warning if the -s is omitted.
	- Eric Sunshine augmented configure.ac so that the Carbon.h check is
	  performed only by the compiler (and not by the preprocessor).	 At
	  least one MacOS/X user switches between gcc 2.95 and gcc 3.3 via a
	  script which toggles the values of CC, CXX, and CPP in the
	  environment, but the script uses "cpp" for CPP, rather than "gcc -E".
	  This causes the Carbon.h check to fail when performed by the
	  preprocessor since __APPLE__ and __GNUC__ are not defined.  By only
	  performing the check via the compiler, we side-step this issue.
	- Eric Sunshine applied a very ugly hack to the existing very ugly hack
	  in csperl5.mak to prevent it from trying to link the non-existent
	  cspace-rsrc.o into the generated cspace.dll Perl extension module.
	  (The correct solution, which we should apply in the future, is to use
	  Perl's own extension building facility to build this extension,
	  instead of trying to coerce the CS makefile system into doing so;
	  just as cspython utilizes Python's distutils to build the Python
	  extension module.)
	- res updated the terrain-related shaders.
	- res fixed the distorted 2D with the GL NR.
	- res fixed csLight::SetInfluenceRadius() to work as expected.
	- res fixed an uninitialized member of csKDTree.
	- res fixed the uninitialized dynDomain in the ball plugin.
	- res made the XML shader compiler more verbose in case of errors.
	- res updated the stencil makefile/Jamfile to link against csgfx.
11-Dec-2003
	- Philipp Aumayr fixed a bug in AWS where a masked textbox raised an
	  assert if the input was reactivated by clicking on the far right of
	  the string.
	- Eric Sunshine augmented configure.ac to check if the compiler/linker
	  recognize the -shared flag.  Consequently, this flag is no longer
	  hard-coded in unix.mak, unix.jam, and win32.jam.
	- Eric Sunshine augmented configure.ac to check if the linker
	  recognizes the -soname flag.	Consequently, this flag is no longer
	  hard-coded in unix.mak and unix.jam.	This change also fixes bug
	  #748023 ("-soname not recognized on Solaris").
	- Eric Sunshine augmented compiler.m4, which is used by external
	  projects, to also check for -shared and -soname.
	- Eric Sunshine fixed the CS_PROG_CC, CS_PROG_CXX, CS_PROG_LINK checks
	  in compiler.m4, which is used by external projects, so that they
	  append results to the existing values of COMPILER.CFLAGS,
	  COMPILER.C++FLAGS, and COMPILER.LFLAGS, respectively, rather than
	  setting the values exclusively.
	- Eric Sunshine agumented CS_BUILD_IFELSE() and CS_CHECK_BUILD() in
	  checkbuild.m4 to accept an optional INHIBIT-OTHER-FLAGS argument.
	  This argument, if provided, inhibits the normal behavior of appending
	  OTHER-CFLAGS, OTHER-LFLAGS, and OTHER-LIBS to the values of the
	  output variables (though the "other" flags are still used for the
	  check itself).
	- Eric Sunshine augmented CS_CHECK_BUILD_FLAGS() in checkbuild.m4 to
	  accept optional OTHER-CFLAGS, OTHER-LFLAGS, and OTHER-LIBS arguments.
	  These may be useful in special cases where the check for one build
	  flag might depend upon the presence of other build flags, yet the
	  output variable should reflect only the build flag under actual
	  scrutiny, and not the additional supporting flags.  As a practical
	  example, some build flags cause the compiler to emit a warning
	  message because it does not like the flag, yet the compiler still
	  exits with a "success" result, which makes it difficult to determine
	  that the compiler complained about the test flag.  To work around
	  this problem, -Werror can be sent in via OTHER-CFLAGS to cause the
	  compiler to treat the warning as an error and exit with a proper and
	  detectable "failure" result.
	- Eric Sunshine simplified the -Werror and CS_CHECK_LOCAL_INCLUDE tests
	  in configure.ac by using the (relatively) new CS_CHECK_BUILD_FLAGS()
	  macro, rather than the lower-level CS_BUILD_IFELSE() macro.
	- Eric Sunshine fixed an #include in cstool/proctex.h in order to
	  support the Borland compiler which can't deal with csRef<iFoo> when
	  iFoo is only a forward declaration.  This was supposed to have been
	  fixed on 25-Nov-2003, but a typographical error resulted in inclusion
	  of iutil/event.h rather than the needed iutil/eventh.h.
	- Eric Sunshine fixed bug in cpsace.i.	It failed to export iReporter,
	  iReporterIterator, and iReporterListener.
	- Eric Sunshine fixed csperl5.mak so that it adds `swigperl5gen' and
	  `swigperl5inst' targets to the output of "make help".
	- Eric Sunshine fixed failure of `-shared' check in compiler.m4, which
	  is used by external projects.	 Problem was that in replacement for
	  AC_TRY_EVAL(), "$1" was incorrectly being evaluated in the context of
	  CS_PROG_LINK, rather than in the context of AC_TRY_EVAL().  Also
	  upgraded `-soname' check to mirror the one from CS/configure.ac which
	  emits a more aesthetically pleasing answer.
	- Duhprey commited a patch from Leandro Motta Barros to expose some
	  ode specific parameters for joints (Done via iODEJointState)
	- Duhprey commited a patch from Troy Chard for motor and bounce
	  parameters on joints.
	- Eric Sunshine committed a new custom cursor plugin from Neil Mosafi
	  <nmosafi@totalise.co.uk> which allows use of arbitary iImages as
	  mouse cursors.  If the platform-specific driver does not support
	  iImage as a cursor, then the plugin emulates the cursor by rendering
	  it manually via iGraphics2D.	He also added iImage cursor support to
	  the software X-windows canvas (however, it presently converts colored
	  cursors to black and white).
	- Eric Sunshine eliminated compilation warnings in some canvases.
	- Eric Sunshine fixed bugs in csTerrFuncLoader::Parse().  Was returning
	  boolean values even though function is declared as returning
	  csPtr<iBase>.
10-Dec-2003
	- Eric Sunshine fixed bug in unix.mak where it was incorrectly
	  exporting the hard-coded "-ldl -lm" to cs-config's --libs option even
	  if the target platform did not supply those libraries.  Furthermore,
	  it was adding these flags to the normal CS build as an accidental and
	  incorrect side-effect (even when the target did not supply those
	  libraries).
09-Dec-2003
	- Marten fixed stencil shadow renderloop plugin.
	- Marten fixed so CLOD and ballmesh compiles, not tested yet though.
	- Marten made isoengine compile.
8-Dec-2003
	- Jorrit added a disabled optimization in the OpenGL canvas to Blit().
	  It is disabled because it makes procedural textures upside down.
	  So I need to find a way to either change the coordinate system
	  or else specify a negative stride. Who can help me with this?
	- Jorrit managed to enable the optimization in Blit() by disabling
	  a correction in the GL renderer for this clumsy way Blit() works.
	  It turns out that the GL renderer was specifically inverting
	  texture space for procedural textures ONLY because Blit() was also
	  inverting it. This optimization gives a 10% speedup approximatelly.
	  It is possible that other procedural textures will now be inverted
	  though.
7-Dec-2003
	- Eric Sunshine changed configure.ac's "mkdir -p" check so that it uses
	  the more conservative "rmdir", rather than "rm -rf", to remove the
	  potentially bogus directory named "-p" which older versions of
	  "mkdir" create.
	- jamest changed swig wrapper to better support csBox* objects
	- Keith updated sprcal3d and sprcal3dldr to use VFS and vfs paths.
	  CVS of cal3d as of *today* is required to use this.
	- Luca fixed 2 compilation errors in the joystick plugin for windows.
6-Dec-2003
	- Eric Sunshine augmented checks for cslibs-config, nasm, and
	  sdl-config to use AC_CHECK_TOOLS() rather than AC_CHECK_PROGS() in
	  order to better support cross-building.
	- Eric Sunshine augmented crystal.m4 (which is used by external
	  projects) to locate cs-config using AC_CHECK_TOOLS() rather than
	  AC_CHECK_PROGS() in order to better support cross-building.
	- Eric Sunshine added `ranlib' check to jamtemplate/configure.template
	  (which is used by external projects) since some platforms require
	  ranlib when installing libraries.
5-Dec-2003
	- res fixed the iEvent::Find() renaming in cspace.i after his recent
	  constness changes.
	- Eric sunshine changed configure.ac so that it no longer invokes
	  AC_PREFIX_DEFAULT(["/usr/local/crystal"]).  This fixes problem where
	  'jam install' was installing into /usr/local/crystal/share/crystal,
	  etc., by default rather than /usr/local/share/crystal, etc., if user
	  did not specify --prefix.  ('make install' still correctly installs
	  into /usr/local/crystal, by default.)
	- Eric Sunshine augmented installdir.m4 so that it now keeps its
	  Jam-specific modifications to "prefix" and "exec_prefix" local to
	  itself, rather than polluting the global $prefix and $exec_prefix
	  variables, which might be needed unmolested elsewhere.
	- Eric Sunshine augmented crystal.m4 so that it also exports
	  CRYSTAL_INCLUDE_DIR (make) and CRYSTAL.INCLUDE_DIR (jam).  This is
	  the value returned by cs-config's --includedir option.
	- Eric Sunshine disabled warning C4248 for MSVC6 in win32/csosdefs.h
	  since MSVC6 emits bogus warning about "protected constructor" when
	  csHash instantiates Iterator and GlobalIterator even though csHash is
	  a friend of Iterator and GlobalIterator.
	- Luca fixed a MSVC6 'for(int i=)' scope bug.
	- res fixed more stuff in the shadersystem. r3dtest works now, tho no
	  stencil shadows yet.
4-Dec-2003
	- Steven Geens added a odedynam function for mesh<->plane collisions.
3-Dec-2003
	- res changed the csKeyEventHelper to accept 'const iEvent*' arguments.
	  Also changed the iEvent->Find() methods to be 'const'.
	- jamest Modifed swig wrapper to support iSector::HitBeamPortals(),
	  also added csBox* to the swig wrapper.
	- jamest commented out the setScale() function in sprcal3d
	  so plugin would build until setScale() makes it into cal3d
	  cvs
	- res did a bunch of changes and fixes to shadersys. He attempted to
	  get the r3dtest map functional, but hadn't too much success.
2-Dec-2003
	- res enabled VC the warning "class has virtual functions, but
	  destructor is not virtual". It was enabled in the past, but somehow
	  got lost on the way.
	- Eric Sunshine changed configure.ac so that a few (very few) detected
	  compiler flags are now deemed "mandatory".  Mandatory flags are
	  required even for external projects which utilize Crystal Space.  For
	  example, an external project on MacOS/X must use the
	  -force_cpusubtype_ALL flag if the project calls qsqrt().  cs-config's
	  --cflags and --cxxflags options now emit only mandatory flags, rather
	  than emitting all of the compiler flags with which Crystal Space
	  itself was built.  This prevents cs-config from polluting external
	  project builds with flags (such as -fno-exceptions) which are mere
	  preferences of the Crystal Space developers.
1-Dec-2003
	- Jorrit fixed a serious bug in csString::FormatV. A comment in that
	  routine incorrectly stated the following:
	    // Some vsnprintf()s return -1 on failure, others return
	    // desired capacity.
	  However, on MSYS neither happens. Instead the size of the input
	  buffer is returned in case of failure.
	- John Harger changed iRenderBuffer to use a "CopyToBuffer" method as
	  an alternative (and preferred) method to copy data to a buffer,
	  rather than Locking the buffer.  This should be especially beneficial
	  to sprite3d's, where it updates the buffer quite frequently, when VBO
	  is enabled because you cannot render from a locked VBO buffer.
	- res augmented csInitializer::DestroyApplication() documentation with
	  the information that it unloads all plugins (and what this can
	  cause.)
	- res changed csSimplePixmap to store the texture handle in a csRef<>.
30-Nov-2003
	- Eric Sunshine clarified and corrected comments in crystal.m4.	 Also
	  cleaned up m4 mis-quoting issues and generally improved formatting.
	- Eric Sunshine fixed bug in cs-config/Jamfile where it neglected to
	  export COMPILER.CFLAGS and COMPILER.C++FLAGS to generated cs-config
	  script, with the result that cs-config's --cflags and -cxxflags
	  options always returned the empty string.
	- Eric Sunshine applied a patch to csjoywin plugin from Dariusz
	  Dawidowski <truman@go2.pl> which allows it to build with Mingw.  The
	  patch also sets the DX cooperative level to DISCL_BACKGROUND when
	  CS_DEBUG is defined, rather than to DISCL_FOREGROUND.
	- Eric Sunshine added device/joystick/windows to msvc/required.mak.
	- res changed the buffer anf texture mapping specification in shader
	  files for consistency to be like:
	    <buffer name="vertices" destination="position" />
	    <texture name="tex diffuse" destination="unit 0" />
	- res made the 'type' attribute for <fp> and <vp> optional. Defaults
	  to 'fp' resp 'vp' now.
	- res updated the Thing plugin.
	- res made shader pass mixmode and alpha mode working again.
28-Nov-2003
	- Daniel Fryer found a bug in the thing mesh plugin when adding
	  polygon vertices one at a time. The vertex count was not correctly
	  updated in all cases.
	- Jorrit fixed a bug in the software renderer. GetOriginalDimensions()
	  would not return the original dimensions for a texture that was
	  scaled to fit po2 sizes.
	- Jorrit fixed a bug in the loader. It wouldn't parse <keepimage/>
	  correctly.
	- Jorrit fixed the software renderer so that it now scales the image
	  to power of two dimension at Prepare time and not at register time.
	  That way it works more like the OpenGL renderer.
	- Jorrit fixed an initialization bug in the kdtree code where the
	  'parent' of the root node was not set to 0. This could cause crashes
	  in viewmesh (and in other apps too if there were moving objects).
	- Wouter fixed an uninit variable in terrfunc.
	- James Thompson added iAws to swig wrapper, added missing cursor.h to
	  swig wrapper so that iGraphics2D.SetMouseCursor would not error out
	- Keith Fulton added GetAttributeValueAsBool( ) function to
	  iDocumentNode and related classes.
	- Keith Fulton added flags options for rotating cal3d sprites to appear
	  correctly and to auto-flip the UV coordinates.  See example .cal3d
	  file for how to use.
	- res added some NR VC7 projects to csall.
	- res made lots of changes. Waterdemo now works again.
	- res fixed missing shader program deactivation.
25-Nov-2003
	- Eric Sunshine removed the ugly, semi-private, legacy name_VERSION and
	  name_scfGetID() API which SCF_VERSION() created for each declared
	  interface.  This functionality has been entirely subsumed by the
	  newer scfInterface<> template.  Also, supporting both the old and new
	  APIs in parallel made it impossible for projects using namespaces to
	  invoke SCF_VERSION() (it would generate compilation errors both
	  inside and outside the namespace).  With the legacy API removed,
	  SCF_VERSION() can once again be used by projects using namespaces
	  (though the macro must be invoked outside the namespace).
	- Eric Sunshine patched cspace.i and the custom-code for each of the
	  Swig-supported languages (Python, Perl5, and Java) to work with
	  scfInterface<> rather than accessing the obsolete name_VERSION global
	  constant when requesting an interface's version number.
	- Eric Sunshine eliminated Swig complaints about redeclaration of
	  CS_CRYSTAL_PROTOCOL, CS_MUSCLE_PROTOCOL, and CS_XML_PROTOCOL in
	  javapre.i for csjava.
	- Eric Sunshine fixed the following problems in csperl5.mak:
	    - Fixed bug: Was placing the generated pure-Perl5 module
	      (.pm/.so/.dll) into the source directory (CS/scripts/csperl5).
	      This is incorrect because the source directory might be read-only
	      or shared.  Now instead places the generated module into
	      $(OUTPROC)/perl5.	 This mirrors the behavior of the pythmod
	      target which places the pure-Python module in $(OUTPROC)/python.
	    - Fixed bug: Failed to respect $(SRCDIR) when trying to locate the
	      perl5.cin input file, thus causing the csperl5 target to fail
	      when building outside the source directory.
	    - Fixed bug: Added several missing dependency rules for generated
	      files.
	    - Fixed bug: csperl5clean target failed to remove many of the
	      generated resources, such as the .cex file, and the .pm and .inc
	      derived files.
	    - Fixed bug: Swig would be run every single time the csperl5 target
	      was invoked even if the Swig-generated file was up-to-date.
	      This, in turn, would cause the Swig-generated file to be
	      recompiled each time (a 25-minute undertaking on Eric's
	      computer).
	    - Now places derived source files in a subdirectory of
	      $(OUTDERIVED) rather than directly into $(OUTDERIVED) in order to
	      avoid potential collisions.
	- Eric Sunshine made the following changes to cspython.mak:
	    - Fixed bug: pythmod target failed to utilize the factory-supplied
	      cspace.py from CS/scripts/python if Swig was not installed, thus
	      causing build failure.
	    - Fixed bug: cspythonclean and pythmodclean targets failed to
	      remove all of the generated resources, such as the .py file.
	    - Changed some makefile variable names in order to avoid global
	      namespace pollution.  For instance, SWIG.OUTDIR becomes
	      SWIG.CSPYTHON.OUTDIR, and SWIG.INTERFACE becomes
	      SWIG.CSPYTHON.INTERFACE.
	    - Now places derived source files in a subdirectory of
	      $(OUTDERIVED) rather than directly into $(OUTDERIVED) in order to
	      avoid potential collisions.
	- Eric Sunshine re-enabled csperl5 in user.mak since the Swig-generated
	  files are now kept up to date by a daily cron job, and because Eric
	  fixed all other build problems (at least on Unix) which plagued the
	  module.
	- Eric Sunshine eliminated a number of compilation warnings and errors
	  from the CS libraries reported by Borland C++Builder.	 It seems that
	  even the most recent version of C++Builder still fails to implement
	  some of the newer extensions to the C++ specification.  For instance,
	  csRef<iFoo> is illegal if iFoo has been seen only as a forward
	  declaration (this problem impacts all older C++ compilers).  The
	  compiler also seems to have trouble parsing normal, valid C++ in a
	  number of cases.  Issues reported by Randall Foreman
	  <rrforeman@comcast.net>.
	- Luca fixed a compilation error in cssys/win32.cpp: the error was
	  a bad casting.
	- Marten Svanfeldt branched CS with the new branch NEW_SHADERSYS.
	  The purpose of this branch is to develop the new shadersystem
	  without disturbing all other development. Goal is to merge it back
	  within three weeks. Initial changes to this branch is:
	    - Move shadermgr into plugins\video\render3d\shader\shadermgr
	    - Moved the shaderplugins to
	      plugins\video\render3d\shader\shaderplugins
	    - Added an initial implementation of csXMLShader and
	      csXMLShaderCompiler in
	      plugin\video\render3d\shader\shadercompiler\
	      xmlshader. It have all methods but lacks testing.
	    - Rewrote ivideo/shader/shader.h We should move this file to
	      ivideo.
	- res re-added VC7 project files.
	- res added VC7 project files for the xmlshader plugins.
	- res fixed xmlshader.mak.
	- res made various compile and semantic fixes.
24-Nov-2003
	- Eric Sunshine performed minor clean up of the new cslibs test in
	  configure.ac.	 Now wraps cslibs-config invocations in AC_RUN_LOG().
	  Added documentation.	Minor whitespace cleanup.  Re-generated
	  configure script with Autoconf 2.57 on Unix to fix formatting of
	  --help, which Windows Autoconf messes up.
	- Jorrit added csStrKey which can be used as a simple key type for
	  usage with csHash and csConstCharHashKeyHandler. csStrKey makes
	  a copy of the key so it is safer to use then just using
	  const char* as the key.
	- Jorrit fixed a bug in the OpenGL renderer. DrawPolygonMesh was
	  not correctly restoring the z-buffer mode after drawing lightmaps.
	  In some cases this could cause objects to use the wrong z-buf
	  mode later.
	- res fixed some compile errors on gcc3.3.
	- res disabled the use of SetDllDirectory() in Win32. Doesn't seem
	  to do what it was intended for.
23-Nov-2003
	- Matze fixed jam clean target for libraries.
	- Matze fixed a bug when SubInclude rule was placed in the middle of a
	  jam file.
22-Nov-2003
	- res made the following changes to configure:
	    - Now checks for a 'cslibs-config' script, which provide
	      additional CFLAGS and LDFLAGS. This script will be included in
	      the upcoming unified Win32 libs package.
	    - Some library checks now utilize the new aliases feature for the
	      lib names in the Win32 libs package.
21-Nov-2003
	- Eric Sunshine augmented CS_CHECK_LIBS_WITH() in checklib.m4 so that
	  it now accepts an optional list of alias names of the library for
	  which it is checking.	 For example, the zlib check which normally
	  checks for "z" can be given aliases "zlib" and "libz" which are names
	  common on Windows.
20-Nov-2003
	- Eric Sunshine once again disabled /nodefaultlib:"MSVCRT" in the
	  freefnt2 MSVC project files since a user reports that it results in
	  many unresolved references at link time.
	- Eric Sunshine re-configured msvcgen/required.mak so that the sprcal3d
	  and sprcal3dldr project files actually get generated (as was
	  intention).
19-Nov-2003
	- Eric Sunshine added new static method scfInterface<>::GetName() which
	  returns an interface's name as a string.  This allows templates to
	  retrieve an interface's name as a string even if the template knows
	  the interface only by the opaque name `T'. For example:
	  char const* n = scfInterface<T>::GetName();
	- Jorrit added a short-hand notation for specifying addons in a
	  map file. Instead of:
	      <addon>
		<plugin>pluginname...</plugin>
		<params>
		   ...
		</params>
	      </addon>
	  you can now also say:
	      <addon plugin="pluginname...">
		...
	      </addon>
	- Jorrit added processing of the <file> keyword for mesh objects in
	  map files. If you use <file> it will try to open the given file
	  and parse it. There are three possibilities:
	    - The file starts with <params>: in this case it is equivalent
	      to using the old <paramsfile> keyword.
	    - The file starts with <meshobj>: in this case it will load
	      the mesh object parameters from that file. After processing
	      <file> it will continue with the meshobject statements in the
	      parent node.
	    - The file starts with <meshfact>: in this case it will load
	      the factory (if not already loaded with that name) and do
	      nothing else. After that you can use <params> like usual.
	- Jorrit fixed a bug so that <file> in combination with <meshfact>
	  actually works.
	- Jorrit added error reporting in case the <file> is not a meshfact,
	  meshobj, or params.
18-Nov-2003
	- Keith committed a new version of the Max level export scripts.
	  This version supports ThingFactories and instances now.  Also
	  the doc is slightly updated.
	- Eric Sunshine re-added /nodefaultlib:"MSVCRT" to the freefnt2 MSVC
	  project file since MSVC complained that this flag was needed.
17-Nov-2003
	- Jorrit removed obsolete bits64.h from Dynavis.
	- Jorrit performed additional micro-optimizations in the coverage
	  routines of Dynavis.
	- Jorrit optimized the kdtree considerably by using a block allocator.
	- Jorrit fixed a bug in Dynavis by moving history culling AFTER
	  frustum culling. Otherwise Dynavis would sometimes cull wrong because
	  objects outside of frustum kept contributing to culling. This
	  could happen if you have sudden changes in camera position.
	- Jorrit changed Dynavis to also use the block allocator inside
	  Dynavis.
	- Eric Sunshine fixed bug in CS_CHECK_BUILD_FLAGS() in checkbuild.m4
	  where it could invoke the `test' program with too many arguments
	  because it failed to quote the result of the build check, and the
	  build result might consist of multiple tokens.  An example which
	  triggered the error: `test -multiply_defined suppress != no'.	 Now,
	  it correctly quotes the build result ("-multiply_defined suppress").
	- Eric Sunshine added assignment operators for csHash::Iterator and
	  GlobalIterator to pacify MSVC which complained that it could not
	  generate default assignment operators.
	- jamest added spritecal3d support to swig wrapper
16-Nov-2003
	- Eric Sunshine fixed bug in make and Jam `install' targets where they
	  neglected to install the generated volatile.h if the build directory
	  differed from the source directory.  Problem pointed out by Allister
	  MacLeod <amacleod@mv3d.com>.
	- Wouter fixed two 'jumps on uninitialised values' errors in aws:
	  in awsmenu the mouse_captured was uninited (inited to false),
	  in awscomponent the redraw_tag was uninited (inited to 0).
	  Another bad initialisation in the console buffer of std.output.
	  Seems that SetPageSize() was called too early in the constructor.
	  Also in conbuff some delete instead of delete[] usage fixed.
	- Wouter also fixed a buffer over-read problem in writechr.inc.
	  The alpha byte was pre-fetched at the end of the writeloop,
	  but also prefetched for the last iteration (i.e. reading a value
	  outside bounds which wasn't used).
	  Additionally, the freefnt2 plugin sometimes did a new[0], which
	  is bad as well, changed it to allocate at least 1 byte.
15-Nov-2003
	- Jorrit fixed various significant bugs in Dynavis related to the
	  depth buffer. The bugs had to do with the fact that a tile is now
	  64 wide while all coverage buffer routines assumed it was only
	  32 wide. This caused the depth buffer to be wrongly updated
	  which in turn could cause culling errors (very rare) but more
	  also reduced culling efficiency a lot. With this bug fixed framerate
	  goes up one or two fps again.
	- Jorrit removed the ability in Dynavis to use tiles of 64 high.
	  This only complicates matters and it wasn't working well anyway.
14-Nov-2003
	- Jorrit did the following Dynavis changes:
	    - Removed the write queue optimization for kdtree nodes again as
	      it doesn't seem to do anything at all.
	    - Removed the object bounding box for the kdtrees. This saves
	      about 28 bytes per node and also makes building/updating
	      the kdtree slightly faster. This also affects frustvis.
	    - Replaced history culling and avoiding write queue flushes
	      with a real fast random function instead of a counter.
	- Jorrit did an optimization in Dynavis by caching the state
	  of movable->IsFullTransformIdentity().
	- Jorrit fixed a slight bug in one of the coverage tile flush routines
	  of Dynavis. This bug would not cause errors but it could cause
	  slight performance degradation in some cases.
	- Jorrit optimized FlushForFull() in Dynavis by decreasing the depth
	  wherever a 8x8 block is fully covered. This improves culling
	  efficiency at the slight cost of some more work. This optimization
	  could be done in some of the other flush routines as well.
	- Jorrit started work on an optimization in Dynavis which detects
	  if an object actually modifies the coverage buffer. This is
	  not finished yet though.
	- Jorrit optimized Dynavis routine FlushNoDepthConstFValue() to also
	  test for full coverage of blocks.
	- Jorrit additionally optimized FlushGeneralConstFValue() to also
	  test for full coverage of blocks.
13-Nov-2003
	- Keith Fulton committed updated versions of the scripts for 3ds Max
	  exporting.  I've had these for two months and forgot to commit them
	  (I thought it was done already.)  See Luca Pancallo (Talad on irc),
	  director of PlaneShift project with any questions about these -- he
	  wrote them.
	- res improved support for transparency in NR. An 'alphamode' has been
	  added, for selection of what kind of transparency to use: none,
	  binary(ie alpha test), smooth blending. It's another member in
	  csRenderMesh. On the shader side, it can be set per pass. There's
	  also an 'auto' mode, where the shader pass selects the alpha mode
	  based on a specified texture (i.e. 'binary' mode for keycolored
	  textures.)
	- res fixed a problem in csRenderMeshList::CompareMeshListInfo(),
	  where the arguments weren't casted correctly.
	- res fixed a 'double to float conversion' MSVC warning in dynavis.
	- res fixed a compile error in docconv.
	- res fixed misinterpretion of the 'flags' TGA header field.
	- res removed some leftover comments from
	  plugins/video/render3d/opengl/gl_txtmgr.cpp.
	- res fixed some visual glitches with 2D graphics on NR GL by adding
	  some code to choose the default texture unit and turning off alpha
	  test when entering 2D mode.
	- Eric Sunshine continued working around SourceForge CVS server
	  brokenness with regards to jobber.pl.	 Specifically, the SourceForge
	  CVS server is so mis-configured that it drops the connection any time
	  the large Swig-generated CS/scripts/perl5/cswigpl5.inc is committed
	  to the repository even though this script is running on a local
	  SourceForge machine.	To work around the problem, we enable
	  compression in order send less information to the CVS server, under
	  the assumption that the huge file size is what is triggering the
	  server to drop the connection.  Using -z6 resulted in some success,
	  but it still dropped the connection at times, so now it is being
	  bumped up to -z9.
12-Nov-2003
	- Eric Sunshine removed redundant SubDir invocation from
	  cspython/Jamfile.
	- Jorrit added another optimization to Dynavis.	 Dynavis now attempts
	  to check if adding items from the write queue will help make the
	  object invisible.  If not it will not flush the write queue.
	- Jorrit optimized Dynavis so that nodes also use the write queue now.
	  Not sure if this really is an optimization.  Have to do further
	  tests.
	- Wouter fixed a bug in the input console, csconin, where if it would
	  hang when truncating the command history.  It was using Delete (0)
	  instead of DeleteIndex (0).  Additionally, the history position could
	  be invalid after truncation.
	- Wouter fixed glcommon2d to invoke glClear() after resizing.
	  Apparently some drivers (like ati radeon 7500 on win XP) corrupt the
	  video memory if you don't.  Fix from Robin Stanton.
	- Wouter added SetDefaultFont() to AwsPrefsManager.
11-Nov-2003
	- Eric Sunshine fixed MacOS/X application menu malfunction introduced
	  on August 1, 2003 when configuration was changed so that OSXDelegate
	  would no longer be registered as the application's delegate.	This
	  caused problems with the Quit and Pause menu items because those
	  items were still targeting the delegate, thus they became
	  dysfunctional.
	- Luca fixed a compilation error in plugins/mesh/bcterr/object/bcterr.h
	  due to recent changes to the iTerrFuncState interface.
	- Eric Sunshine worked around problem where CVS `Header' keyword in sed
	  expression in swig.jam was accidentally being expanded in swig.jam
	  itself.  This keyword needs to appear verbatim in the sed expression;
	  not in expanded form.
	- res added a new tool app, docconv, to convert documents between
	  different document systems.
	- res tweaked the bindoc plugin a bit so it takes up a bit less memory
	  when writing a document.
10-Nov-2003
	- Jorrit removed the blend2cs script from CS.  It is made obsolete by
	  the blend2cs project http://projects.blender.org/projects/blend2cs/
	- Wouter fixed up the terrain texture caching to use the
	  CacheManager. Instead of a cachedir, put cache="yes" to
	  use caching.
	- Jorrit did another optimization to Dynavis. This time the target was
	  TestRectangle() in the coverage buffer. Optimized this routine by
	  splitting the coverage buffer test and the depth test. Both tests
	  can then be written a lot more efficient.
	- Wouter changed the texture generation <heightmap> and <slope>
	  statements, as well as the terrfunc <heightmap> statement to
	  accept a <flipx>yesno</flipx> and/or a <flipy> attribute.
	  iTerrFuncState::SetHeightMap also has arguments to flipx or flipy.
	  By default, no flipping occurs, keeping the API compatible.
	- Jorrit added a function to return an estimate of the amount of
	  objects that are in a kdtree node and its children. Currently
	  unused.
	- Eric Sunshine corrected typographical errors in build/msvc6.txi and
	  msvc7.txi.
	- res tweaked the doxygen files to include paths relative to the
	  CS/include resp. CS directory. Also updated the layout of the
	  generated HTML files a bit.
	- Chris Matuszewski fixed a bug in csIntersect3::IntersectTriangle that
	  was causing it to fail in certain cases.  The new implementation
	  returns a successful intersection for both frontface and backface
	  triangles.  This fixes a previous problem with HitBeam not working
	  correctly for genmesh objects.
	- Chris Matuszewski updated some code that was using
	  csIntersect3::IntersectTriangle twice: once for frontface, once for
	  backface.  This is no longer necessary due to the updated
	  implementation of csIntersect3::IntersectTriangle, which works for
	  both frontface and backface now.  The affected files are
	  terrfunc.cpp and spr3d.cpp.
9-Nov-2003
	- Rhad added functions to handle reversing some operations with
	  particle emitters.  These take care of some simple situations where
	  previously the entire emitter or emitgen3d had to be recreated to
	  alter certain settings.
	    - iEmitState::RemoveAge reverses iEmitState::AddAge
	    - iEmitMix::RemoveEmitter reverses iEmitMix::AddEmitter
	    - iEmitMix::AdjustEmitterWeight allows for adjusting the weight
	      of an existing emitter beneath a mix without recreating the
	      entire mix, or removing and re-adding the sub emitter.
	- Wouter added csgfx library to linking of thing.so, now needed
	  under NR. Both to .mak and Jamfile.
	- Eric Sunshine added SCF_DESTRUCT_IBASE() invocations for each of the
	  corresponding SCF_CONSTRUCT_IBASE() invocations in methods in
	  CS/plugins/video.  The only remaining directories which need to be
	  converted are the CS/plugins/mesh tree.
	- Wouter created new option for terrain (terrfunc, old renderer)
	  texture generation. You can specify a cache directory, for the
	  generated terrain textures, and if you do so, the textures are
	  cached there. If present, the files are also read from the cache,
	  speeding up loading. Note that changes cannot be detected,
	  a recalc must be forced by deleting the pictures.
8-Nov-2003
	- Andreas Busch added missing awstut.cfg
	- Wouter fixed a typo in csfxscr fullscreen header file, and
	  added a new function that can do a dpfx for part of the screen.
	- res made the following (mostly NR-related) changes:
	    - Rendermeshes now contain a shader var context.
	    - Can now support up to 8 texture coordinate sets.
	    - Added very basic support for lightmaps.
	- res slightly cleaned up after the LM-related changes.
	- res removed bit field use in the TGA image loader.
	- res fixed a few double-to-float warnings in the chunklod plugin.
	- res added missing SCF_IMPLEMENT_IBASE_REMOVE_REF_OWNERS invocations
	  to bindoc.
	- Eric Sunshine fixed some Texinfo mark-up problems and typographical
	  errors in apimod98.txi.
	- Eric Sunshine fixed bugs in awstut.mak where it was referencing
	  CSWS makefile variables.
	- Eric Sunshine fixed awstut.mak and awstut/Jamfile so that they
	  mention the new awstut.cfg file which Andreas Busch added.
	- res fixed a bug in genmesh where it wasn't lit correctly when an
	  object was used without localshadows and -relight.
	- Eric Sunshine added missing SCF_IMPLEMENT_IBASE_REMOVE_REF_OWNERS()
	  invocations to render3d/software and render3d/opengl.
	- Chris Matuszewski changed the AWS component transitions to use
	  real time clicks instead of virtual ones.
7-Nov-2003
	- res reverted the behaviour of setting the alpha of keycolored pixels
	  of textures in GL: just drop the alpha of KCed pixels to 0, but don't
	  raise the alpha of non-KCed pixels to 255, which gave problems with
	  alpha transparency in AWS (which sets a keycolor on all images.)
	- Chris Matuszewski changed AWS component transitions to use a delay
	  parameter specified in csTicks instead of using a step_size
	  parameter.  This approach has the benefit of making the transitions
	  take the same amount of time on computers with different processor
	  speeds.
	- Jorrit implemented the silhouette splatting optimization in Dynavis.
	  With this optimization, outlines that are partially behind the view
	  plane are now splatted to the view plane instead of simply discarded.
	  At some spots this optimization can really help a lot.
	- Jorrit added a 'toggle_splatting' command to Dynavis. Assigned the
	  ctrl-d 8 key to that command.
	- Jorrit enhanced the Dynavis debug mode so that it now shows which of
	  the optimizations are enabled and which are disabled.
	- res updated a comment in ogl_txtmgr.cpp. Just dropping the alpha of
	  keycolored pixels to 0 and leaving other pixels as is is indeed the
	  desired behaviour.
	- res added a paragraph about iGraphics2D::WriteBaseline() to
	  apimod98.txi.
	- res fixed a crash in the fixed function shader programs. A shader
	  variable wasn't properly set up.
	- res added a fix from Marten to
	  csShaderVariableContextHelper::FillVariableList().  Previously, not
	  all provided variables were actually filled.
	- Jorrit removed the first technique from ambient.xml. The second
	  technique is more compatible and works fast enough everywhere.
	- Wouter added a new technique to the NR terrain shader splatting_bump,
	  that avoid bumpmapping and lighting to make it work on 2 texture
	  units graphics cards.
	- Eric Sunshine added SCF_DESTRUCT_IBASE() invocations for each of the
	  corresponding SCF_CONSTRUCT_IBASE() invocations in methods in the
	  following locations:
	    CS/plugins/aws
	    CS/plugins/bugplug
	    CS/plugins/collide
	    CS/plugins/console
	    CS/plugins/cscript
	    CS/plugins/csparser
	    CS/plugins/cssaver
	    CS/plugins/culling
	    CS/plugins/device
	    CS/plugins/documentsystem
	    CS/plugins/engine
	    CS/plugins/engseq
	    CS/plugins/filesys
	    CS/plugins/font
	    CS/plugins/isoldr
	    CS/plugins/motion
	    CS/plugins/movierecorder
	    CS/plugins/net
	    CS/plugins/perfstat
	    CS/plugins/physics
	    CS/plugins/picogui
	    CS/plugins/proctex
	    CS/plugins/reporter
	    CS/plugins/sequence
	    CS/plugins/sound
	    CS/plugins/stdrep
	  The only remaining directories which need to be converted are
	  CS/plugins/mesh and CS/plugins/video.
	- Eric Sunshine eliminated numerous ambiguous operator overload errors
	  from partedit.
	- Eric Sunshine worked around bizarre preprocessor error on CompileFarm
	  Linux 2.2 (Alpha) installations where it fails to search
	  CS/plugins/aws for headers #included by aws/skinpars.cpp (at least
	  when building outside the source tree).  Work-around in aws.mak and
	  Jamfile involves explicitly adding -I$(SRCDIR)/plugins/aws to CFLAGS
	  for skinpars.cpp.
	- Jorrit fixed engseq plugin after Eric added an additional destructor
	  to some of the classes. C++ only accepts one destructor.
	- Eric Sunshine added missing SCF_IMPLEMENT_IBASE_REMOVE_REF_OWNERS()
	  invocations to csReporterListener and csXmlReadNode.
	- Wouter added new extensions to the csconout (standard output
	  console) plugin. This enables shadowing of the letters. Default
	  is off, the same behaviour as before. Extensions are:
	  EnableShadow, DisableShadow, SetShadowColor, GetShadowColor.
	- Wouter fixed some more SCF_DESTRUCT_IBASE typos in the sndmod
	  loader, linux joystick and iff loader. Also unbalanced ()'s
	  in cssaver.
	- Luca fixed some compilation errors for VC6 in the method
	  void csSequenceManager::Clear ().
	- John Harger fixed the Cg plugin so it works with the newer
	  iShaderProgram interface
	- Chris Matuszewski documented recent changes made to iAWS interface
	  concerning the new way to create window transitions in apimod98.txi.
6-Nov-2003
	- res bumped the version of the iGraphics2D interface and updated some
	  Doxygen comments in include/graph2d.h (basically, the differences
	  between res's local copy he forgot to commit yesterday and Eric
	  Sunshine's patch to graph2d.h to work around res's commit amnesia :-)
	- res made the csShadowIterator destructor virtual.
	- Eric Sunshine added an ugly hack to jobber.pl to work around
	  SourceForge CVS server brokenness.  Specifically, the SourceForge CVS
	  server is so mis-configured that it drops the connection any time the
	  (admittedly) large Swig-generated CS/scripts/perl5/cswigpl5.inc is
	  committed to the repository even though this script is running on a
	  local SourceForge machine.  To work around the problem, we enable
	  compression in order send less information to the CVS server, under
	  the assumption that the huge file size is what is triggering the
	  server to drop the connection.  Enabling compression seems to
	  side-step the problem.
	- Andreas Busch changed pgtest and pgserver to use new keyboard event
	  handling.
	- Eric Sunshine removed an unportable #include <memory.h> from
	  bitarray.h.  This header is not present on all platforms.
	- Eric Sunshine augmented the Swig rules in the makefiles and in Jam
	  so that they filter out $Header: keywords from the generated files.
	  This will prevent the files from appearing modified to jobber.pl
	  simply because an element of the header, such as date, is different.
	  Also added SED variable to makefiles.
5-Nov-2003
	- Jorrit optimized the kdtree a bit so that it now does 20 attempts
	  instead of 10 to find the best split location. Also the cost is
	  now calculated based on a measure that looks more at number of
	  cut objects as opposed to balanced tree.
	- res changed the fire proctex to set an alpha of 255 on the output
	  image, instead of 0.
	- res removed the superfluous 'texture' parameter from
	  csGLStateCache::GetTexture().
	- res fixed the GL renderer to properly deal with keycolored procedural
	  textures.
	- Eric Sunshine added SCF_DESTRUCT_IBASE() invocations for each of the
	  corresponding SCF_CONSTRUCT_IBASE() invocations in methods in
	  CS/include and CS/libs.
	- Eric Sunshine split Class::scfRemoveRefOwners() implementation in
	  scf.h out into its own SCF_IMPLEMENT_IBASE_REMOVE_REF_OWNERS() macro
	  rather than having it bundled into SCF_IMPLEMENT_IBASE_DECREF().
	- Andrew Craig fixed up some calls to SCF_DESTRUCT_IBASE() that had a 0
	  as a param.
	- res added a 'flags' parameter to iGraphics2D::Write(). At the moment
	  you can specify flags to write on a baseline and disable font glyph
	  antialiasing. As the functionality of WriteBaseline() is now
	  provided by Write(), so it has been marked as deprecated.
	- res added SCF_DESTRUCT macros to the common and glwin32 canvas code.
	- res updated a comment in ogl_txtmgr.cpp.
	- res added a SCF_IMPLEMENT_IBASE_REMOVE_REF_OWNERS invocation missing
	  for csTinyXmlNode.
	- Eric Sunshine fixed bugs: swigpythinst and swigperl5inst makefile
	  targets failed to ensure that the appropriate `out' directories
	  existed before instructing Swig to emit files into those directories.
	- Eric Sunshine updated ivideo/graph2d.h to hopefully reflect res's
	  changes (above), since res forgot to commit all the files he had
	  changed, causing compilation to fail.
	- Eric Sunshine augmented jobber.pl to now automatically update
	  out-dated Swig-generated Python and Perl5 files.
	- Eric Sunshine performed project-wide spelling corrections:
	    invokate   --> invocate
	    invokation --> invocation
4-Nov-2003
	- Jorrit fixed a bug in Dynavis history culling. In some cases objects
	  could remain visible for longer then expected because the history
	  counter was only decremented if the object visibility test was
	  called. So if the node itself is not visible then it would not
	  get decremented. Solved this by comparing with the global history
	  frame counter instead.
	- Jorrit did an optimization to the usage of the write queue in
	  Dynavis. The write queue is the module in Dynavis that is responsible
	  for delaying writes to the coverage buffer. This is good for two
	  reasons:
	    - A write to the coverage buffer is an expensive operation. So
	      delaying that until really needed is good because sometimes it
	      is not needed at all.
	    - A write to the coverage buffer disrupts the depth buffer because
	      the depth buffer in Dynavis is always updated to highest values
	      (in contrast with a usual Z buffer). So by delaying writes to
	      the coverage/depth buffer we can often improve culling
	      efficiency.
	  The current optimizations reflects the fact that an object that
	  was calculated to be visible the previous frame (after testing the
	  write queue) will most likely not benefit from the write queue the
	  next frame either. So we don't flush the write queue. To make sure
	  we sometimes recheck the write queue for a given object we sometimes
	  flush anyway.
	- Eric Sunshine repaired outdated and incorrect Doxygen comments in
	  scf.h.  For example, documentation for SCF_DESTRUCT_EMBEDDED_IBASE
	  was 100% incorrect.
	- Jorrit changed the way that the coverage buffer outline drawing
	  works in preparation for outline clamping.
	- Jorrit removed all usages of SCF_SET_REF, SCF_DEC_REF, and
	  SCF_INC_REF and then removed those macros. You should now use
	  csRef instead.
	- Eric Sunshine fixed bug in csHash<>::Iterator copy constructor where
	  it neglected to initialize its `key' member.
	- Eric Sunshine augmented win32.jam so that it can optionally use
	  dllwrap during plugin creation instead of "gcc -shared" when invoked
	  with "jam -sUSE_DLLWRAP=yes myplugin".  Perhaps this change will
	  allow Jorrit to debug plugin modules in gdb with Mingw.
	- Eric Sunshine fixed the following errors reported by Swig when
	  processing cspace.i (some of which were emitted many, many times):
	    - scf.h: Syntax error in input.
	    - scf.h: Warning(503): Can't wrap class scfInterface<iFoo> unless
	      renamed to a valid identifier.
	    - evdefs.h: Warning(305): Bad constant value (ignored).
	    - string.h: Warning(503): Can't wrap 'operator char const*' unless
	      renamed to a valid identifier.
	- Eric Sunshine made the following changes to cspython.mak:
	    - Added top-level swigpythclean and cspythonmaintainerclean
	      targets, the latter of which is hooked into the top-level
	      maintainerclean target.
	    - Set up some additional variables instead of repeatedly using
	      constants for pathnames in rules section.
	    - Fixed bug: Secondary-level swigpythclean target was not marked
	      `phony'.
	    - Eliminated some special-case code which prevented dependency
	      loops when SWIGBIN was not set.  Cleaner logic obviated the need
	      for this confusing special-case.
	    - Fixed bug: swigpythclean failed to clean generated cspace.py.
	    - cspythonclean now also cleans Swig-generated files.
	- Eric Sunshine made the following changes to csperl5.mak:
	    - Added top-level swigperl5clean target.
	    - Eliminated convolution of swigperl5gen and swigperl5inst targets.
	      New logic is clearer, more obvious, and less bug-ridden.
	    - swigperl5gen and swigperl5inst targets are now available only if
	      SWIGBIN is set.  (Having the targets available with Swig absent
	      was not sensible.)
	    - Fixed bug: Secondary-level swigperl5clean target was not marked
	      `phony'.
	    - Fixed poor design: Would refuse to build csperl5 module if user
	      did not have Swig installed; even though the Swig-generated files
	      are present already in the source tree.  Instead, now simply
	      falls back to the files from the source tree (after all, that is
	      why they are in CVS).
	    - Fixed bug: swigperl5gen (and swigperl5inst) failed when invoked
	      outside of source tree.
	    - Fixed bug: swigperl5inst target was moving generated files from
	      build directory to source directory rather than copying them.
	      This caused subsequent invocations of these targets to think that
	      additional work was required.
	    - Fixed bug: swigperl5gen target failed to ensure that `out' build
	      tree existed before Swig emitted files there.
	    - Fixed bug: swigperl5clean was removing the wrong files.  It was
	      removing the files from the source tree rather than the files
	      emitted by Swig into the `out' build directory.
	    - Fixed bug: csperl5maintainerclean was not removing the Swig files
	      from the source tree (which, after all, is the purpose of a
	      "maintainerclean" target).
	    - csperl5clean now also cleans Swig-generated files.
	- Wouter fixed unused int i in awsmgr, and a printf format error
	  in a dynavis debug statement.
3-Nov-2003
	- Chris Matuszewski added some explicit type casts to stop msvc6 from
	  emitting warning messages in csgfx/rgbpixel.h and shadervar.h.
	- Chris Matuszewski added ComponentIsInTransition() to iAws interface.
	  Cleaned up the implementation of ComponentIsInTransition within
	  awsmgr.cpp to do only what its name implies.	Removed spurious error
	  message that would display after a transition completed.
	- Chris Matuszewski fixed a bug in csObject::GetChild(const char* Name)
	  where it would crash when an object didn't have a name.
	- Chris Matuszewski brought cspace.i and swig generated python wrappers
	  up to date.
	- Eric Sunshine fixed bug which was recently introduced into
	  csObject::GetChild(char const*).  It was incorrectly aborting the
	  search when it found an unnamed child.  Instead, it should simply
	  ignore that child and continue examining the others.	Problem noted
	  by Frank Richter.
	- Eric Sunshine fixed SCF bug: SCF_DESTRUCT_EMBEDDED_IBASE() macro did
	  not accept any arguments, which made it impossible to specify
	  exactly which embedded object was being destroyed.
	- Eric Sunshine documented SCF_DESTRUCT_IBASE() and
	  SCF_DESTRUCT_EMBEDDED_IBASE() in scf.txi, plugin.txi, and
	  apimod98.txi.
	- Jorrit added csBox3::ProjectBoxAndOutline() which combines
	  ProjectBox() and ProjectOutline() is one function.
	- Jorrit fixed the exact visibility culler in Dynavis so that it works
	  again. The exact visibility culler is a debug tool which allows you
	  to calculate the maximum possible FPS possible at some point
	  assuming a culler that does a perfect cull AND needs zero
	  CPU time to does this perfect culling. Basically it uses a very
	  slow system to calculate perfect visibility and then stores that
	  information so that it is used every frame. You can also use this
	  feature to see how culling performs. After enabling this you can
	  walk around and see which objects are visible and which objects
	  are not.
	- Jorrit fixed the exact visibility culler in Dynavis again so that
	  you can now also freeze the Dynavis culling result instead
	  of the exact culling result.
	- Eric Sunshine added SCF_DESTRUCT_IBASE() invocations for each of the
	  corresponding SCF_CONSTRUCT_IBASE() invocations in CS/apps.
	- Marten Svanfeldt fixed a bug with shadervars in material which didn't
	  get loaded as they should.
	- Duhprey did the following:
	  - Implemented scattering in the chunklod and shaders
	  - Added splatting lod and other optimizations
	  - Modified terrain level to use scattering by default
	  - Added larger heightmap file (not default) to terrain level
	  - Added collision detection to walktest
	  - Added a general scattering shader for object that aren't terrain
	    (light_scattering replaces light_bumpmap for outdoor lighting)
2-Nov-2003
	- Eric Sunshine performed project-wide spelling corrections:
	    seperate	--> separate
	    seperated	--> separated
	    seperately	--> separately
	    seperatelly --> separately
	    seperation	--> separation
1-Nov-2003
	- Jorrit fixed a problem in Dynavis where history culling would
	  invalidate the frustum mask that is used for hierarchical frustum
	  culling. This is now fixed by remembering the last frustum mask
	  and using that in combination with the mask we have so far.
	- Chris Matuszewski fixed an incomplete SCF interface in iPath.
	  Added a virtual destructor to csCatmullRomSpline.
31-Oct-2003
	- Eric Sunshine performed additional cleanup of the various "Release
	  Notes" sections of the user manual.  Repaired some Texinfo mark-up
	  problems.  Converted tabs to spaces in apimod*.txi in order to fix
	  formatting problems in generated output for @example blocks.	Minor
	  formatting changes and typographical corrections.  Added a section to
	  apimod96.txi mentioning the introduction of csRef<> and csPtr<> and
	  related API changes (which, amazingly, had not been mentioned in that
	  document even though it was a significant change).
30-Oct-2003
	- Jorrit performed some additional minor optimizations to Dynavis
	  TestObjectVisibility.
	- res fixed a lock-up in the OpenAL plugin: a Delete() was errorneously
	  used instead of DeleteRange() in a loop, causing it to go round and
	  round infinitely.
	- Marten Svanfeldt fixed a few bugs in csShaderVariableContextHelper::
	  FillVariableList(). A more complete rewrite of shadersys is about any
	  day.
29-Oct-2003
	- Eric Sunshine added a test to configure.ac which checks if the C++
	  compiler recognizes the new explicit template specialization syntax
	  `template<> class Foo<Bar>', rather than the older implicit syntax
	  `class Foo<Bar>'.  csdef.h now defines the new macro
	  CS_SPECIALIZE_TEMPLATE as `template<>' if the compiler recognizes the
	  new syntax.
	- Eric Sunshine augmented scf.h to employ CS_SPECIALIZE_TEMPLATE when
	  declaring the scfInterface<> specialization for each SCF interface.
	  This change eliminates many warnings emitted by some compilers
	  (30,000 warnings, according to one report).
	- Eric Sunshine fixed ambiguous overload compilation error in
	  cfgmgr.cpp reported by some versions of gcc.
	- Eric Sunshine added copy constructor and assignment operator to
	  csArray<>::Iterator in order to make it legal to utilize the iterator
	  returned by csArray<>::GetIterator().	 This change should eliminate a
	  lot of MSVC compilation warnings when building PlaneShift, the
	  project files of which use a higher warning level than the CS project
	  files.
	- Jorrit cleaned up the main routine in Dynavis that tests object
	  visibility and also optimized it slightly.
28-Oct-2003
	- Jorrit did various optimizations to the tiled coverage buffer
	  in Dynavis. Added several new special cases to Flush() and
	  considerably optimized the bit-logic in it. This gains us a few
	  fps in general. More optimizations to Dynavis will hopefully
	  follow soon...
	- Eric Sunshine upgraded csConfigManager to use csRef<> instead of
	  managing reference counts manually.  Also upgraded and clarified
	  Doxygen comments.
	- Eric Sunshine fixed some minor problems in csbaseeventh.h.
27-Oct-2003
	- res fixed a few warnings occuring with GCC.
	- res fixed cssaver plugin so it compiles with NR.
	- res fixed some error messages in csparser where parameters were
	  mixed up.
	- Old_Belge fixed libs/csws/csstddlg.cpp to use
	  CaseInsensitiveCompareSort so the conversion of char to void wouldn't
	  bother the compiler.
	- Old_Belge added CaseInsensitiveCompare to stringarray.h; it seemed to
	  be missing.
	- Eric Sunshine removed the last couple references to luaswig and
	  cslua.
	- Eric Sunshine augmented csGetLibrarySymbol() for Unix so that it
	  looks for both `sym' and `_sym', rather than only `sym'.  This allows
	  it to work correctly on OpenBSD which still uses b.out format for
	  object files.
	- Eric Sunshine once again disabled warning C4291 (no matching operator
	  delete found) for MSVC6 builds since MSVC6 emits nearly a thousand
	  warning messages when this warning is enabled.
	- Eric Sunshine removed the obsolete CS/include/ivaria/cs.i.
	- Old_Belge added support for the newest cvs of CAL3D.
	- Old_Belge added a menu to viewmesh for using the morph animations
	  of CAL3D.
	- Old_Belge changed configure.ac and configure to detect if a
	  sufficiently recent version of CAL3D is used.
26-Oct-2003
	- Eric Sunshine updated `simple1' tutorial in the user manual to
	  reflect recent changes to keyboard-related event handling.
	- res changed the VFS cache to read files not null terminated.
	- Philip Wyett eliminated warnings by bad casting to float right
	  before initialization of an integer.
	- Marten Svanfeldt changed the ways shader variables work in new
	  renderer.  The current way works, but is somewhat messy code and
	  unclean design.  It should be fixed in the following week(s).
	- Rhad added a call to broadcast signalTextBoxFocused when a textbox
	  gains focus by any means - not just when it's set programatically.
25-Oct-2003
	- Rhad moved emitter list initialization into the
	  RecreateParticleSystem() member function of partedit.	 This fixes the
	  crash when switching graphics since the last commit (oops!).
	- Rhad fixed partedit to shut down cleanly when the window is closed.
	- Rhad added functionality to partedit to dump xml readable (mostly) by
	  emitloader.  This output is dumped to the console at the moment.
	  Placeholder windows have been added to the Aging Moments and
	  Load/Save screens indicating they are not yet complete.
	    - At this point I am going to work on revising the UI layout so
	      that it hopefully ends up less complicated (in code at least) and
	      more functional (from a user perspective).
	    - The emitloader plugin does not appear to be able to handle mix
	      emitters with more than one child emitter.  The whole point of
	      mix emitters is to use multiple child emitters, so this makes mix
	      emitters unusable with the loader.
	- Jorrit added the ability to Dynavis to change the tile size at
	  compile time.	 Four sizes are possible: 64x32 (old default), 32x64,
	  32x32, and 64x64.  32x64 appears to work a tiny bit faster then the
	  others so it is now set as default.
	- res fixed compilation of ddraw2d and glwin32 on older SDKs after
	  removing a #define.
	- Luca replaced some "for(int i=" with "int i; for(i =..." in genmesh
	  plugin.
	- Rhad added a check to awsManager::HandleEvent so that focus events
	  related to windows which are deleted after the event is generated but
	  prior to it being handled no longer cause a crash with a NULL pointer
	  dereference.	Also formatted awsManager::HandleEvent for readability.
	- Rhad fixed reference counting in awsWindow for the title member.  The
	  pointer was copied from the preference manager without an incref.  If
	  the title was changed, the shared copy was decref'd and destroyed.
	  If the title was changed from the default then all other current
	  instances of the window and all future instances will crash when
	  drawn.
	- Rhad made AWS scrollbars behave a little nicer with tiny ranges by
	  removing the aritifical +1 to the max value.	This doesn't appear to
	  be needed anymore.  All the listboxes and scrolling things I could
	  find to test work fine without it.
24-Oct-2003
	- res re-enabled a couple of MSVC warnings and fixed some occurences of
	  VC warnings in the source.
	- Jorrit changed walktest perftest so that it prints to standard output
	  and it will also call FinishFrame() now for a more realistic result.
	  Also fixed a bug with perftest if a number of iterations != 100 was
	  used.
	- Jorrit fixed stats in Dynavis so that it now reports the number of
	  visible objects and nodes instead of the time it takes to calculate
	  Dynavis.  This is more useful.
	- Jorrit added csBox3::ProjectOutline() which works similarly to
	  ProjectBox() except that it projects the outline to a 2D polygon.
	- Jorrit fixed csBox3::ProjectBox() so that the calculated min_z/max_z
	  actually accounts for all 8 vertices and not only the vertices of the
	  outline.
	- Jorrit changed the kdtree so that it sets the bounding boxes of the
	  nodes maximum to -100000/100000.  This avoids bugs in Dynavis which
	  cannot easily handle these big bounding boxes.  Unfortunately that
	  restricts worlds that use Dynavis to be within that range.  We'll
	  have to see about better solutions in the future.
	- Jorrit changed the write queue operation in Dynavis to test every
	  rectangle again after fetching an item from the write queue instead
	  of only testing after fetching all items.  This seems to improve
	  performance slightly.
	- Jorrit added code to test for polygons instead of just rectangles.
	  This allows a test that better matches the shape of the node box.
	  Using that does not help improve performance though.	Perhaps we need
	  to do this test only if the node is complex enough (i.e.  has
	  sufficient objects in it).
	- Jorrit optimized Dynavis TestRectangle() a bit by splitting it in two
	  routines which allows for early exit in case of write queue and also
	  allows for faster second-time calls of TestRectangle().
	- Jorrit added early exit code in Dynavis TestFullRect() to avoid
	  comparing all 32 depths.
	- Jorrit fixed a bug in Dynavis TestRect() which was initializing one
	  row wrongly.	The chance of this bug manifesting in real culling
	  errors is very small though.
	- res fixed csGetKeyDesc() to properly deal with keys that are
	  modifiers.
	- Eric Sunshine applied a patch from Fritz Elfert <felfert@to.com>
	  which makes the following changes:
	    - Fixed bug: csStringArray failed to override InsertSorted(), which
	      caused inserted strings to be compared by pointer rather than
	      content, thus the array was not sorted in a meaningful way at
	      all.  As a side effect, this fixes a bug in VFS where its
	      `deleted files' array had essentially random order, causing
	      csArchive:IsDeleted() to fail, which in turn caused zip
	      corruption. (Bug# 827467)
	    - Fixed bug in his recent VFS patch: "Fake" directory entries in
	      `dir' array were being written to "central directory" in zip file
	      even though the fake entries were not themselves represented in
	      the data portion of the archive.	This caused the central
	      directory to get out of sync with the stored entries, thus
	      resulting in corruption. (Bug# 827467)
	    - csArchive::NewFile() now checks if the desired file is already in
	      the `lazy' array. If so, it reuses this entry instead of creating
	      a new one.  This change removes the limitation that adding the
	      same file more than once without a Flush() could lead to
	      unpredicted results. It now resembles behavior of a real
	      filesystem more closely: Creating/Writing a file more than once
	      simply overwrites the previous version in cache.
	- Rhad fixed a typo that caused a lot of havok with components that
	  implemented signals.	If AWS was crashing today, update.  The
	  SetOwner() member of awsSource was incorrectly ignoring the passed
	  parameter, and setting the owner class member to itself.
23-Oct-2003
	- Jorrit reduced the 'yellow-message-time' in the standard reporter
	  from 10 to 5 seconds.
	- Jorrit fixed a bug in dynavis where it would sometimes incorrectly
	  update the depth buffer. The chance of this bug manifesting itself
	  was not very big though.
	- Jorrit optimized the coverage buffer in Dynavis a bit by adding
	  handling for a special case in a tile. If a tile is empty then a
	  more optimal routine is selected for flushing the operations.
	- Jorrit cleaned up the coverage buffer Flush() routine by splitting
	  it up in all different cases.
	- Matze fixed win32.jam so that the resource and supporting file names
	  incorporate the target's name.  This allows "variants" to work
	  correctly on Windows.
	- Jorrit reenabled the dynavis_debug target in the Dynavis jamfile
	  after Matze applied some fixes to the metadata embedding code
	  on windows.
	- Jorrit added VPT (visible point tracking) to Dynavis. Enabled
	  by default but you can disable it with the toggle_vpt bugplug
	  command (assigned to bugplug key '5'). Doesn't seem to give
	  a big performance increase though.
	- Jorrit fixed another bad bug in Dynavis. It was mistakenly assuming
	  that all objects are suitable for outline filling even if the
	  object was not closed.
	- Jorrit performed some minor optimizations in Dynavis.
	- Eric Sunshine made some corrections to the keystroke classification
	  (cooked versus raw) which is performed by OSXDelegate.  Most
	  importantly, it now correctly cooks Return and Enter to CSKEY_ENTER;
	  whereas previously it was incorrectly setting the raw code.  Updated
	  full-screen toggle in OSXDriver2D to reflect the corrected raw/cooked
	  classification performed by OSXDelegate.
	- Jorrit fixed a bug in the frozen OBB creation (csOBBFrozen class).
	  It could crash if z happened to be 0. In addition to fixing that bug
	  it will now also create a conservative projection of the OBB
	  if one or more of the points are behind the view plane (z < 0).
	  In the past it would simply create a huge screensize box.
	- Jorrit moved the VPT test in Dynavis so that it now works on 3D
	  coordinates instead of 2D.
	- Jorrit attempted to change VPT tracking so it would find a real
	  visible point. This doensn't work very well yet so it is still
	  disabled. Currently the center of the object is still used.
	- Jorrit did some additional small optimizations to Dynavis. Including
	  increasing the time a visible object remains visible.
	- Jorrit fixed csBox3::ProjectBox() in a similar way as csOBBFrozen
	  so that points behind the view plane (z < 0) are clipped in a
	  conservative manner.
	- Eric Sunshine fixed a bug in assembler.jam where the pathnames used
	  with the -I directives lacked a trailing slash.  The slash is
	  required by NASM.  (Bug #827028)
	- Jorrit added the ability to csBox3 and csBox2 to use CS_BOX_CENTER3
	  and CS_BOX_CENTER2 for GetCorner(). This will return the center.
	  Yes I know. The center of a box is not a corner. Just leave me alone
	  will you? :-)
	- Jorrit notes that the previous trick now also works for csOBB.
	- Jorrit added a default constructor to csOBBFrozen which does
	  nothing.
	- Jorrit changed VPT tracking so that it tries the 8 corners of the
	  object box to see which point is visible. This seems to work a
	  lot better now.
22-Oct-2003
	- Jorrit fixed a bug in csMovableSectorList which did all the needed
	  SCF stuff EXCEPT inherit from iBase. This is an old bug but for
	  some reason this only causes crashes on linux with a static build
	  and new renderer enabled and while using profile mode???
	- Jorrit modified csMovableSectorList so it no longer uses
	  embedding to implement iSectorList.
	- Jorrit reverted the Jamfile modification for dynavis to add a new
	  dynavis_debug target. It conflicts somehow with the standard
	  dynavis target.
	- Jorrit did a slight optimization in the stencil renderloop plugin.
	  Using memcpy instead of manual copy.
	- Eric Sunshine added a new templated scfInterface<> class to scf.h.
	  This class can be used to perform queries for static information
	  relating to SCF interfaces.  The following information is supplied
	  by this class:
	    - GetVersion(): Retrieves an interface's current version number.
	      This is the same as the value of the global constant
	      name_VERSION, where `name' is the interface's name (such as
	      iVFS_VERSION).
	    - GetID(): Retrieves an interface's unique identifier as an
	      scfInterfaceID.  This is the same as the value returned by the
	      global function name_scfGetID(), where `name' is the interface's
	      name (such as iVFS_scfGetID()).
	  As an example of use, to retrieve the version number of the iFooBar
	  interface, the following code can be used:
	      int ver = scfInterface<iFooBar>::GetVersion();
	  An important benefit of scfInterface<> is that it allows template
	  authors to retrieve static information about an interface even though
	  the template might know an interface only by the opaque tag `T'.  For
	  instance scfInterface<T>::GetVersion() will work as expected from
	  within a template class.
	- Eric Sunshine eliminated bogus metaball reference from features.txi.
	- res made the following changes:
	    - Genmesh can now properly receive shadows, i.e. if the half of
	      an object is blocked from a light source, that half won't get
	      lit.
	    - Fixed a bug in csGetKeyDesc() causing bogus key strings to be
	      returned for character keys.
	- Rhad added float support to aws for scrollbars.  This involved some
	  additions to the various aws interfaces.  It also involved expanding
	  the parser a bit to handle numeric values with a decimal point.  I
	  think everything worked out OK, but I'm not really proficient with
	  flex or yacc, so if something doesn't appear to work, please let me
	  know (or fix it!).
	- Rhad fixed a bounds issue in partedit.
	- Rhad added a minimum scrollbar knob width to aws scrollbars of 5
	  pixels.  Without this, when the range of the scrollbar was big
	  enough, the knob would disappear.
	- Eric Sunshine disabled the MSVC warning C4099 ("type first seen as
	  'struct' now seen as 'class'") in order to avoid complaint from
	  SCF_VERSION() in those very rare cases when SCF_VERSION() is applied
	  to a class rather than a pure SCF interface (struct).	 The C++
	  language specification states that classes and structures are 100%
	  identical (except for default access mode), therefore, it makes more
	  sense to simply disable this warning than to try to arrive at some
	  ugly work-around in the code for avoiding it.
	- Rhad added Field Speed and Field Acceleration interface windows
	  to partedit.
	- Rhad changed partedit so the particle system is only recreated when
	  it must be due to parameter changes that cannot be incorporated into
	  the running system.  This allows for smooth adjustment of most values
	  on a running system.
21-Oct-2003
	- Rhad added UI for Initial Speed and Initial Acceleration to partedit.
	- Eric Sunshine made the following configuration-related changes:
	    - Added CS_CHECK_BUILD_FLAGS() to checkbuild.m4.  This is similar
	      to CS_CHECK_BUILD(), except that it checks only if the build
	      tools recognize particular options, rather than checking if a
	      test program can be built.
	    - Rewrote CS_EMIT_BUILD_FLAGS() in configure.ac to utilize the new
	      CS_CHECK_BUILD_FLAGS().  Also dropped the somewhat hacky
	      CACHE-VALUE argument from CS_EMIT_BUILD_FLAGS().	This type of
	      functionality can now be accomplished more cleanly by calling
	      CS_CHECK_BUILD_FLAGS() directly.	Callers which were using the
	      CACHE-VALUE hack have been rewritten to use
	      CS_CHECK_BUILD_FLAGS() instead.
	    - Added a check for -force_cpusubtype_ALL to configure.ac.	This
	      flag is needed on MacOS/X when building the PowerPC version of
	      qsqrt() which uses the `frsqrte' instruction.
	    - Fixed the qsqrt() check in configure.ac so that it employs
	      -force_cpusubtype_ALL when applicable.  This allows the qsqrt()
	      check to succeed on MacOS/X.
	    - Added a check for -fno-common to configure.ac for MacOS/X.
	    - Fixed bug: Jam build on MacOS/X failed to utilize
	      -force_cpusubtype_ALL and -fno-common.
	- Eric Sunshine fixed bug in qsqrt() check in configure.ac where it
	  would always fail if configuring outside the source directory because
	  it failed to locate CS/include/qsqrt.h.
	- Jorrit added data/shader/std_rloop_ambient.xml.
	- Jorrit modified engine.cfg so that the ambient renderloop is now
	  default.
	- Jorrit fixed changing of an alternative renderloop in the engine.
	- Jorrit fixed various places in CS where the result of a
	  GetContentsValue() (for XML parsing) was stored but not copied.  This
	  is not valid since the string is not guaranteed to exist for a long
	  time.	 The places I fixed are:
	    - Parsing of 'priority' in main loader.
	    - Parsing of 'cullerp' in main loader.
	    - Parsing of 'type' for textures.
	    - Parsing of cubemaps.
	    - Parsing of renderloops.
	- Jorrit fixed the cloth plugin so it no longer includes the removed
	  tesselator class. It wasn't using the class anyway.
	- Jorrit changed a few calls to Warn() in the engine with calls to
	  Error(). It is an error if a renderloop cannot load.
	- Eric Sunshine fixed bugs in macosx.mak where it was prefixing one
	  extra $(SRCDIR)/ to each of the paths mentioned by $(SRC.SYS_CSSYS)
	  and $(INC.SYS_CSSYS).
	- Eric Sunshine fixed bug in CS_CHECK_BUILD_FLAGS() in checkbuild.m4
	  where it gave different results between cached and uncached
	  configuration runs.
	- Eric Sunshine fixed bug in glrender.mak. `gl3dclean' was not declared
	  "phony" in `roottargets'.
	- Eric Sunshine made the following changes to cocoa2d.mak:
	    - Removed MACOSX.SOURCE_COCOA2D_PATHS and
	      MACOSX.HEADER_COCOA2D_PATHS variables.  These were a necessary
	      complication from back when the plugin had to build for MacOS/X,
	      Rhapsody, OpenStep, and NextStep; but are no longer needed since
	      the older ports were dropped.  Also, MACOSX.HEADER_COCOA2D_PATHS
	      was not dealing correctly with $(SRCDIR); it was simply being
	      ignored.
	    - Added support for .mm Objective-C++ file extension.
	    - Converted over to new build style where generated resources are
	      placed in a cocoa2d-specific build directory, rather than
	      directly in $(OUT).
	- Eric Sunshine fixed bugs in cgdriver2d.mak and glosx2d.mak where they
	  were prefixing one extra $(SRCDIR)/ to several of the computed path
	  containers.
	- Eric Sunshine worked around compilation error on MacOS/X 10.1 in
	  ogl_polybuf.cpp where it failed to resolve ?: conditional operator
	  when given a csRef and a zero.  Changed it to instead use a simple
	  `if' expression.
	- Eric Sunshine eliminated compilation warning in cspthrd.cpp; failed
	  to return a value from bool function.
	- Eric Sunshine fixed MacOS/X defaultsconfig.{mm|h} so that it can be
	  built on pre-10.2 machines where -[NSUserDefaults
	  objectIsForcedForKey:inDomain:] is not present.
	- Eric Sunshine eliminated signed versus unsigned compilation warning
	  in cskeyacc.cpp.
	- Eric Sunshine eliminated compilation warning in thing/polytext.cpp
	  about unused variable in non-debug mode.
	- Eric Sunshine fixed compilation error in csparser/prstex.cpp where a
	  `goto' jumped over the initialization of a variable used by the block
	  of code which was the target of the goto.
	- Eric Sunshine eliminated signed versus unsigned compilation warning
	  from aws/awsmled.cpp.
	- Eric Sunshine made the following changes to the build system with
	  regards to AWS:
	    - Fixed bug in aws/Jamfile where it failed to correctly apply
	      -Wno-unused when compiling skinlex.cpp.
	    - Updated aws/Jamfile to also apply -Wno-unused to skinpars.cpp.
	    - Worked around bizarre preprocessor error on older MacOS/X
	      installations where it fails to search CS/plugins/aws for headers
	      #included by aws/skinpars.cpp (at least when building outside the
	      source tree).  Work-around in aws.mak and Jamfile involves
	      explicitly adding -I$(SRCDIR)/plugins/aws to CFLAGS for
	      skinpars.cpp.
	    - Updated aws.mak to apply -Wno-unused when building skinlex.cpp
	      and skinpars.cpp in order to avoid compilation warnings over
	      which we have no control in these auto-generated files.
	    - Converted aws.mak to new build style where generated resources
	      are placed in a aws-specific build directory, rather than
	      directly in $(OUT).
	- Rhad fixed a bug in the particle emitter plugin.  Attractors were
	  adjusting acceleration instead of speed of particles.	 This alters
	  the effects of any particle system using the emitter plugin with
	  an attractor noticably.
	- Rhad fixed some bugs in partedit including position values carrying
	  over into speed/accel/attractor.  Initial speed/accel weren't being
	  properly updated in UI.
	- Rhad fixed a bug in partedit where conical emitters where initialized
	  incorrectly.
	- Rhad fixed a bug in partedit that caused regular particles to be
	  unavailsble after some changes last night, and another bug that
	  caused negative forces on attractors (repulsors) to fail to function.
	- Philip Wyett fixed typo in aws makefile, fixing make depend.
	- Rhad made some changes to partedit so it doesn't need to recreate the
	  mesh associated with the particle system for every change.
	- Rhad re-activated the code to set the Value (position) of an AWS
	  scrollbar with a SetProperty call.  Documentation be damned, this
	  property will be writable!
	- Rhad commented awsScrollBar::KnobTick and fixed this and other
	  functions to correctly handle a minimum scroll value other than 0.
	  Note that "proportional scrollbar" functionality is probably still
	  broken since I don't know how that's supposed to work.
	- Rhad changed the SetProperty() calls to awsScrollBar to expect floats
	  instead of ints.  PLEASE NOTE THAT THIS MAY BREAK EXISTING FUNCTIONAL
	  PROGRAMS WITHOUT COMPILER WARNINGS. (Thanks to void * cast calling
	  convention) However, I have doubts that anyone is using this since
	  the internal values in the scrollbar have been floats for some time
	  and the GetProperty() call has always presumed it was filling in a
	  float * .
	- Rhad added some "experimental" UI to partedit.  Rather than adding a
	  scrollbar for each element, there is currently one scroll bar in a
	  separate window.  Any text box containing a float or int value that
	  gains focus will be controlled by the global scroll bar (and extra
	  text box) until another float or int textbox component gains is
	  selected.  This allows you to adjust a single value with minimal
	  interface clogging up the screen.  The ranges still need work
	  and the handling of value changing for emitters needs to be smoothed
	  out so the system doesnt reset with every change if possible.
20-Oct-2003
	- Philip Wyett added 'joytest' to CS/ root .cvsignore file.
	- Jorrit added thing.cfg.
	- Eric Sunshine augmented "thing" makefile and Jamfile to ensure that
	  the new thing.cfg gets installed.
	- Eric Sunshine fixed numerous Texinfo errors and other mark-up
	  problems recently introduced into the user manual.  Also rewrote some
	  of the discussion in apimod98.txi.
	- Jorrit removed csTesselator class since it is the marching cubes
	  algorithm and that is patented :-(
	- Jorrit also removed metaball and metagen since both use
	  csTesselator. They can be revived if someone can provide an
	  alternative algorithm to do tesselation.
	- Eric Sunshine eliminated signed versus unsigned compilation warning
	  from impnames.cpp.
	- Eric Sunshine applied a patch to csArchive and csVFS from Fritz
	  Elfert <felfert@to.com> which fixes methods, such as FileExists(), so
	  that they work correctly for directory names even if an explicit
	  directory entry does not exist in the zip file.  This means that if a
	  zip files contains the single entry "foo/bar/cow.txt", FileExists()
	  will now correctly return true for "foo" and "foo/bar".  Previously,
	  it would return false.  Eric also applied a bit of cleanup to the
	  patch to reduce coupling and increase safety.
	- res fixed problems in the handling of the Pad+, Pad-, Pad* and
	  PadDecimal keys on Win32, as pointed out by Fritz Elfert
	  <felfert@to.com>.
	- Philip Wyett corrected DIR.WATERDEMO path in apps makefile and
	  eliminated make depend failure when --enable-new-renderer is used.
	- Jorrit marked the old metaball and metagen plugins with the
	  PRE_REMOVE_METABALL tag so that they can be revived more easily.
	- Eric Sunshine added a makefile for `partedit'.
	- Eric Sunshine fixed the `make help' formatting for a number of
	  targets.
	- Eric Sunshine worked around MSVC6 crasher reported by Fritz Elfert
	  <felfert@to.com> in sequence.cpp where compiler couldn't deal with
	  `if ((*seq) != 0)' where `seq' is a `csWeakRef<csSequence>*'.
	- jamest changed the swig wrapper to support the new polygon creation
	  and manipulation API (AddInsideBox).	The python samples have been
	  updated to reflect the new API.  added iShaderBranch to the wrapper
	  to eliminate a warning/ignore during swigpythgen.
	- jamest removed css.h references to the recently removed metaball,
	  metagen, and csTesselator.
	- Rhad did some more work on partedit.	Initial position UI and
	  attractor UI are now complete.  Some pretty nice effects can be seen
	  with just these two sections.
19-Oct-2003
	- res fixed a bug in the OR polygon buffers: when two polygons
	  subsequently passed into AddPolygon() would have different lightmaps,
	  they would later not be drawn together, even if they could. But as
	  distinct polys always have distinct lightmaps, this basically caused
	  the polybuffers to be ineffective. Now, not the polygon's lightmap,
	  but the super lightmap it is on is considered, and polys on the
	  same SLM will be drawn together.
	- res updated the OS/X CG2D for the latest keyboard event changes.
	- Rhad fixed a typo in the aws group frame documentation.
	- jamest updated cspace.i for latest keyboard event changes.
	  updated the the python module samples to reflect latest
	  keyboard event changes.
	- res added an updated version of csParseKeyDef().
	- res changed the logic when a key state is set; now it is set after
	  the event is emitted for Down resp. before the event for Up events.
	- Rhad changed signals for button presses on radio buttons
	  (signalRadButtonClicked) and checkboxes (signalCheckBoxClicked)
	  in AWS to occur AFTER the state change associated with them.
	  This makes these signals actually useful in a consistant manner.
	- Rhad commited a partial rework of the partedit tool.	Still a lot
	  of UI work and cleanup to do.
18-Oct-2003
	- DeSigna made the following changes:
	    - Considerable cleanups to the csShaderExpression optimizer pass.
	    - Added support for zero-arg and fixed arg operations to optimizer.
	    - Added support for zero-arg ops to the compiler.  Fixed arg ops
	      require special handling in the compiler, not done yet.
	    - Added various sanity checks in the optimizer.
	    - Fixed a severe optimizer bug, where it didn't check if the
	      reverse CDR was a cons cell, and tried to feed it through
	      argument reduction as an atom.
	- Jorrit fixed the python plugin to compile again. Unfortunatelly this
	  was done by simply removing support for getting key event
	  information. We need to fix cspace.i so we can get this
	  functionality again but I'm not sure how to do that.
	- Jorrit also fixed the perl5 plugin to compile again by removing
	  CSMASK_KeyUp and CSMASK_KeyDown and replacing with CSMASK_Keyboard.
	- Jorrit fixed the shader manager. The following construct is illegal:
		static bla;
	  Please use:
		static int bla;
	- res fixed a cut'n'paste error in the xwindow plugin.
	- DeSigna made the following changes:
	  - Added support for MAKE-VECTOR to csShaderExpression.
	  - Fixed a bug in the compiler, which wouldn't generate opcodes
	    for single argument ops if the arg wasn't an atom.
	  - Fixed a bug in the single-arg op dispatcher, to resolve accum
	    references.
	- res updated apimod98.txi with paragraphs on the new i18n stuff and
	  the keyboard event changes.
	- Rhad fixed a documentation error regarding awsListBox. The
	  "selectable" property applies to the entire row and not each column.
	- res enhanced csSubRectangles2 with the ability to enlarge the
	  region.
	- res augmented the Thing lightmap layouter with the ability to enlarge
	  an existing super lightmap. This is done if the lightmaps to be
	  distributed would fit onto the enlarged super lightmap and less than
	  a specified area of the SLM would be unused.
	- Rhad added code to call existing signalListBoxScrolled.  Added
	  signalListBoxStateChanged called when the state of a stateful
	  column is changed.  Added documentation for both signals as well
	  as the existing implemented signalListBoxFocused.
	- DeSigna implemented dot, cross, norm and vec-len ops for
	  csShaderExpression.
17-Oct-2003
	- res added some files he forgot with his recent commit.
	- Jorrit fixed the engine sequence manager a better way. With
	  yesterday's fix it was essentially possible for the sequence
	  manager to grow in memory forever since sequences that were once
	  the target of an operation would be registered and never released
	  (except at shutdown of the sequence manager).
	  The current fix works by making the operations use real references
	  instead of weak references again (as they should). But the sequence
	  manager now manages an array of weak references to all sequences.
	  Whenever a sequence is deleted then that weak ref will become 0
	  automatically and the sequence manager will later remove that entry
	  from the array. If after Clear() the weak ref is
	  still there then this means we have a circular reference. In that
	  case the sequence manager will call CleanupSequences() on all the
	  sequences to force breaking the circular references.
	  Note that this fix doesn't help clean up sequences that circularly
	  reference each other but are no longer used (i.e. they have no
	  scheduled operations). For those there is no other solution but
	  to clear the sequence manager manually.
	- Jorrit fixed fog in OpenGL (for DrawPolygonMesh). It would fail for
	  triangles that required clipping.
	- Jorrit replaced a DeleteAll() in portalcontainer with Empty().
	  DeleteAll() completely reinitializes the array but we want to keep
	  the internal array size the same to avoid reallocating all the time.
	- Jorrit fixed the bug with software renderer fog.
	- Jorrit changed iSequenceManager->NewSequence() so it returns a
	  csPtr<iSequence>.
	- Eric Sunshine removed a C++ construct and a type which is only
	  defined by the CS C++ headers from iutil/evdefs.h since this file
	  must not contain any C++ on account of the fact that it gets
	  included in Objective-C code.
	- Eric Sunshine upgraded the MacOS/X port to work with the updated key
	  event functionality.
	- res made a small cleanup in win32kbd.cpp.
	- res made the following changes:
	    - Moved csKeyEventHelper to from iutil/event.h to csutil/event.h.
	    - Made csKeyEventData a 'dumb' struct (no construction logic.)
	    - Some small documentation updates.
	    - Disabled the workaround for glTexSubImage problems with some
	      ATI drivers. Seems to work now.
	- Eric Sunshine fixed compilation error on MacOS/X in
	  csShaderExpression.  MacOS/X does not have strtof().
	- res fixed waterdemo for the recent keyboard handling changes.
	- Anders Stenberg made the buffer and texture activation in NR more
	  efficient. Also made sure render mesh lists are sorted on material
	  to minimize state switches.
	- DeSigna made the following changes:
	    - Fixed compilation error for VC6, the debug macro's use of
	      variable arguments isn't valid
	    - Macro now uses csPrintf (not a big issue, since it'll all be
	      removed once the shaderexps are complete).
	    - Fixed initializer problem in csShaderExpression::Parse(), MSVC6
	      doesn't accept the constant initializer for an oper_arg struct.
	    - Added some extra comments to csShaderExpression::eval_const() and
	      csShaderExpression::compile_cons().
16-Oct-2003
	- Jorrit fixed a big memory leak related to the engine sequence
	  manager. There are actually three fixes to solve this bug:
	    - Two callbacks for cleanup to sector and light used a csRef
	      to a sector and light respectively. However, this causes a
	      circular reference since those callbacks are added to the
	      sector and light. Fixed this by using weak references.
	    - Various objects in the engine sequence manager keep references
	      to engine stuff. However the engine also kept a reference to
	      the engine sequence manager. Changed the latter to use a weak
	      reference.
	    - Added iSequenceManager->RegisterRef(). This is a general routine
	      with which you can register a specific reference. The purpose of
	      this is to register references to sequences so that you can
	      use weak references in the operations itself. That way circular
	      references between operations and sequences are avoided and
	      the sequences are cleaned up properly on destruction of the
	      sequence manager and/or a manual call to Clear().
	- res added the Joystick plugin for Windows (utilizing DirectInput)
	  and the joytest app contributed by Turbo J <turboj@web.de>.
	- res augmented the DirectX configure check to include DirectInput.
	- Jorrit removed 'motion', 'csbmpimg', and 'fontplex' targets from
	  'jam walkall'. These are not required by walktest. Added 'spiral'
	  and 'spirldr' to the meshes target.
	- Jorrit made 'ieplex' optional in walktest and then removed the
	  target from 'jam walkall'.
	- Jorrit removed 'crossbld' from the 'meshes' target.
	- Jorrit fixed a bad and old clipping bug in the old OpenGL renderer.
	  This bug manifested itself if plane clipping (P) was selected as
	  the default clipping method AND if a clipped portal had five
	  vertices AND the previous portal had four vertices AND an object
	  was rendered that required plane clipping. In that specific case
	  the fifth plane was not calculated. This bug sounds rather
	  esoteric but it manifested very easily with the recent removal
	  of single polygon drawing.
	- Eric Sunshine removed 8-bit characters from numerous source and
	  header files throughout the project.
	- Eric Sunshine re-generated the configure script on Unix since the
	  previous generation was done with Windows (presumably Autoconf 2.56)
	  which borks the help message.
	- Jorrit fixed the copy constructor and the constructor with T*
	  from csWeakRef. Apparently they were completely broken.
	- Wouter fixed awstxtbox, changing a iString* to csRef<iString>,
	  which stops awstut from crashing when typing a password.
	  Still, it's fishy that iString::Clone and Slice return a csRef<>.
	- res made the following changes:
	    - Tagged everything with OLD_KEYBOARD_EVENTS.
	    - Overhauled keyboard events. The event data is now stored via
	      iEvent's property bag mechanism (a helper class can simplify
	      the access.) The idea of 'scan codes' and 'char codes' has been
	      replaced with 'raw codes' and 'cooked codes.' Also, there's only
	      one keyboard event now, and the information whether the key was
	      pressed or released is now part of the event data. A couple of
	      features have been added as well, for example, CS can now
	      distinguish between left/right modifiers or keypad and
	      non-keypad keys.
	- res fixed a few files to compile again after his latest changes.
	- res reverted an accidential change to md32spr.
	- DeSigna wrote the csShaderExpression class in csgfx for Dentoid's
	  csShaderVariables. It is not yet integrated into the XML parser's
	  syntxldr service or shader variables, and it is missing S-expression
	  support.
15-Oct-2003
	- Eric Sunshine fixed a bug in RemoveDups from helper.jam.  It was
	  trying to dereference a variable using an 8-bit character instead of
	  dollar sign ($).  The result was that the function was a complete
	  no-op; it did not remove duplicates at all.  As a consequence, when
	  building targets in static mode, many libraries were mentioned
	  hundreds of times in the link statement, with the result that the
	  command length was too long, causing Jam to abort.  Also reverted
	  Matze's attempted fix for this problem yesterday where he added a
	  hack to shorten the pathnames mentioned by the the link statement.
	  This hack did not fix the problem, and is not necessary now that the
	  real problem has been corrected.
	- Jorrit fixed a bug in thing which would sometimes reset the
	  cached movable to 0 at the wrong place.
	- Jorrit fixed a bug in thing and allocation of three-vertex
	  polygons. This bug would cause too many memory allocations and
	  memory leaks at exit.
	- Jorrit reverted the helper.jam fix from Eric by putting an invalid
	  character back instead of $(i). This will break static linking but
	  at least normal linking works. With $(i) many modules won't link
	  correctly.
	- Jorrit fixed a bad bug in the OpenGL renderer. DrawPolygonMesh()
	  didn't call FlushDrawPolygon() which could cause particle systems
	  not to be rendered.
	- res made the following changes:
	    - Made some updates to the map2cs tutorial.
	    - cssys/win32/wintools.h doesn't include <windows.h> any more.
	- res updated the Jam 'walkall' target to include rendstep_stencil as
	  well.
	- res made a small fix to the font plugins: GetLength() now doesn't
	  return the number of encoded characters, but instead the number of
	  encoding character (ex: A-umlaut is stored as two 8-bit values in
	  UTF-8. That's one encoded character, but two encoding characters.)
	- res made a cosmetic change in thingldr.cpp.
	- Jorrit fixed a bug in the rain particle system. It was using
	  vertex buffers but didn't register itself as a vertex buffer
	  client. This causes problems at destruction (and thus simpmap
	  crashes at exit).
	- Jorrit fixed visibility culling errors in mottest which were caused
	  by scaling objects through the movable (not allowed!). Fixed this
	  by using HardTransform instead.
	- Eric Sunshine reverted Jorrit's reversion of helper.jam.  Eric's
	  fix to RemoveDups was correct, but fixing RemoveDups allowed a bug in
	  LinkWith (flags.jam) to manifest.  Consequently, applied a patch from
	  Matze which fixes LinkWith.
14-Oct-2003
	- Eric Sunshine fixed typographical error in constant expression in
	  cssys/general/platformconfig.cpp: S_IWGRPS_IXGRP --> S_IWGRP|S_IXGRP.
	  Also made more robust in case any of the read-write-execute named
	  constants are missing at compile time.
	- Eric Sunshine fixed problem in cssys/general/platformconfig.cpp where
	  it was trying to pass a csString into fprintf() rather than passing
	  in the (char const*) equivalent.
	- Jorrit fixed a memory leak in thing polygons. They were not
	  releasing the vertex indices from the block allocators. This caused
	  simple1 to crash at exit due to an assert in csBlockAllocator.
	- Jorrit forgot to remove some instances of FASTMESH.
	- Jorrit removed an unused field from csPolygon3DStatic.
	- res fixed a few 'signed/unsigned mismatch' compiler warnings in
	  cssys/csuctransform.h.
	- res re-enabled 'signed/unsigned mismatch' compiler warnings for MSVC.
	- Eric Sunshine made the following changes to the user manual:
	    - Updated MacOS/X usage instructions to reflect that settings are
	      now stored via NSUserDefaults, rather than user.cfg.
	    - Generally upgraded MacOS/X build instructions.
	    - Eliminated some obsolete engine and lighting options from
	      documentation and configuration files.
	- Jorrit removed csPolyLightMapMapping and merged it with
	  csPolyTextureMapping. This saves some memory again.
	- Jorrit eliminated mean lightmap color. This saves another 20 bytes
	  per polygon.
	- Jorrit eliminated the iEngine->GetLightmapsRequirePO2() function.
	  None of the renderers require PO2 lightmaps so this functionality
	  can be removed entirely. Also removed the equivalent config option
	  from opengl.cfg.
	- Jorrit eliminated the po2 scaling option from lightmaps. This
	  saves another 8 bytes per polygon.
	- Jorrit eliminated the lmsize field in lightmaps, saving another
	  4 bytes per polygon.
	- Jorrit eliminated another 12 bytes per polygon and then another
	  12 bytes for every polygon and pseudo-dynamic light that affects
	  the polygon.
	- Jorrit fixed a new bug in the thing loader which incorrectly tests
	  for duplicate vertices.
	- Eric Sunshine rewrote almost completely the configuration section of
	  the user manual.  Expanded discussion of configuration domains and
	  how priority-based system works.  Added missing material.  Clarified
	  existing material.  Added section detailing MacOS/X-specific storgage
	  of user-specific settings via NSUserDefaults.
	- Eric Sunshine fixed some transpositional borkness in xmlfmt.txi, as
	  well as some other minor formatting issues.
13-Oct-2003
	- Eric Sunshine eliminated several compilation warnings from Walktest.
	- Jorrit fixed phystut for the latest polygon changes.
	- Jorrit fixed relighting of lightmaps for thing. It was broken since
	  my latest changes.
	- Eric Sunshine eliminated compilation warning in glshader_fvp.cpp.
	- Eric Sunshine fixed bug in csString::FindLast() prototype where the
	  incoming pos argument defaulted to 0 but should have defaulted to -1.
	- Jorrit added iThingFactoryState->SetPolygonVertexIndices() to set
	  all indices of a polygon at once.
	- Jorrit did an optimization to thing so that vertex indices are now
	  stored in a more optimal way. Used csBlockAllocator for this. This
	  also affects csPolygonRenderData which is used by new renderer.
	- Eric Sunshine eliminated numerous memory leaks in
	  libs/cssys/defaultsconfig.mm, the MacOS/X-specific iConfigFile
	  implementation which utilizes Cocoa's NSUserDefaults for storing
	  user-specific settings.  Also upgraded to CS formatting standards.
	- Eric Sunshine simplified overly complex code in
	  cssys/general/platformconfig.cpp and cssys/win32/filesysconfig.cpp.
	- Jorrit removed the world to texture transformation from
	  csPolyTexture. This makes some operations a small bit slower (like
	  static + dynamic lighting in case the object has moved) but it
	  saves a lot of memory again.
	- Eric Sunshine upgraded comment in configure.ac regarding filtering
	  out of Autoconf's default -O and -g flags.
	- Eric Sunshine made the following changes to apimod98.txi:
	    - Documented the path-related queries: csGetAppPath(),
	      csGetAppDir(), csGetResourceDir(), and the corresponding
	      iCommandLineParser methods.
	    - Documented new VFS variables $* and $^, and fact that VFS now
	      searches for vfs.cfg in the resource directory, then the
	      application directory, and finally the installation directory,
	      rather than only searching the installation directory.
	    - Moved the warning about libbfd's GPL license so that it appears
	      earlier in the discussion about meta-information embedding.
	    - Re-organized sections a bit so that sections logically related to
	      one another are now physically grouped, thus achieving a somewhat
	      less fragmented feel.
	- Eric Sunshine brought vfs.txi in the user manual up to date.	Also
	  added mention of new $@, $*, and $^ pseudo-variables.
	- res made the following changes:
	    - Added some functions to csUnicodeTransform helper class to
	      determine how many encoding characters a Unicode character from
	      an encoded string occupies.
	    - Fixed some cats from size_t to int in csUnicodeTransform.
	    - Added a version of Insert() to csString that accepts a const
	      char*.
	    - csReport(V) won't attempt to query a reporter from the registry
	      if the supplied pointer to the object registry is 0. Instead,
	      they print the error.
	    - Small tweak to fontplex.cfg; now contains standard Arial as well,
	      not just Arial Unicode.
	- res slightly changed a few doxygen comments for iPolygonMesh.
12-Oct-2003
	- Eric Sunshine clarified documentation for csGetResourceDir(),
	  iCommandLineParser::GetResourceDir(), and
	  csCommandLineParser::GetResourceDir() so that the Cocoa application
	  wrapper's "Resources" directory is mentioned explicitly.  Also
	  clarified documentation for csGetAppDir() so that Cocoa application
	  wrapper is mentioned explicitly.
	- Jorrit removed the iPolygonTexture interface. This eliminates
	  another SCF interface for every polygon.
	- Jorrit removed iLightMap. csCurveLightMap (for bezier curves) and
	  csLightMap (from polygons) no longer inherit from iLightMap. This
	  is another cases where the SCF interface is removed. Also removed
	  the virtual destructor from csShadowMap.
	- Jorrit removed the cache_data from csPolyTexture and csLightMap
	  (also for bezier). Also removed delayed_light_info structure
	  since this has been unused for a long time.
11-Oct-2003
	- Jorrit added csPolygonRenderData structure. This structure is now
	  used for communication between the thing mesh plugin and the
	  new renderer in case of the new renderer. This avoids the usage
	  of iPolygon3DStatic in all of CS.
	- Jorrit completely removed iPolygon3D and iPolygon3DStatic. This also
	  means that csPolygon3D and csPolygon3DStatic no longer use virtual
	  functions, no longer use ref counting and no longer implement
	  their respective iPolygon3D interfaces through embedding.
10-Oct-2003
	- Jorrit added iPolygonHandle. This is an SCF interface that can
	  be used to represent a thing polygon in situations where an SCF
	  interface is required. It is created by
	  iThingFactoryState->CreatePolygonHandle() or
	  iThingState->CreatePolygonHandle(). The handle is safe in the
	  sense that it will automatically return 0 pointers in case the
	  factory or instance is removed (uses weak references to do that).
	- Jorrit changed the engine sequence manager to use the new
	  iPolygonHandle instead of iPolygon3D.
	- Jorrit changed the engine sequence manager so that it now sets the
	  material on the instance polygon instead of the factory polygon.
	- Jorrit moved an error if a thing has no polygons after converting
	  everything to portals.  This error complained if a part had no
	  polygons but it should only complain if the entire thing has none.
	- Jorrit removed the unused csSector::IntersectSphere().
	- Jorrit removed a few additional declarations of iPolygon3D.
	- Eric Sunshine added new methods GetResourceDir() and GetAppPath() to
	  iCommandLineParser to complement the existing GetAppDir() method.
	  These methods correspond to the lower-level platform-specific
	  functions csGetResourceDir(), csGetAppDir(), and csGetAppPath().
	- Marten fixed a crash in stencil shadow plugin. Added test to see that
	  we don't try to create a shadow for a meshobject without polygons.
	- Eric Sunshine added %include "cstool/csfxscr.h" to cspace.i.	Problem
	  pointed out by James Thompson.
	- Eric Sunshine made the following changes to VFS which were very
	  loosely influenced by a patch submitted by Dariusz Dawidowski
	  <chfsoft@interia.pl>, but with additional functionality.
	    - Added vfs.cfg meta-variable $* which expands to the value of
	      csGetResourceDir().
	    - Added vfs.cfg meta-variable $^ which expands to the value of
	      csGetAppDir().
	    - VFS now attempts to load vfs.cfg from the following locations
	      (first one wins): resource directory, application directory,
	      installation directory.  In the past, it only attempted to load
	      vfs.cfg from the installation directory.
	  These modifications should be considered interim "helper" changes
	  until such time when a more complete VFS overhaul can be performed,
	  as proposed by Gregory Block wherein the monolithic and obnoxious
	  vfs.cfg is retired in favor of a more dynamic and automatic
	  configuration mechanism.
9-Oct-2003
	- Jorrit added the following new functions to iThingFactoryState:
	    - FindPolygonByName (const char*)
	    - AddEmptyPolygon ()
	    - AddTriangle (csVector3, csVector3, csVector3)
	    - AddQuad (csVector3, csVector3, csVector3, csVector3)
	    - AddPolygon (csVector3*, int)
	    - AddPolygon (int, ...)
	    - AddOutsideBox (csVector3, csVector3)
	    - AddInsideBox (csVector3, csVector3)
	    - SetPolygonName (csPolygonRange, const char*)
	    - GetPolygonName (int)
	    - SetPolygonMaterial (csPolygonRange, iMaterialWrapper*)
	    - GetPolygonMaterial (int)
	    - AddPolygonVertex (csPolygonRange, csVector3)
	    - AddPolygonVertex (csPolygonRange, int)
	    - GetPolygonVertexCount (int)
	    - GetPolygonVertex (int, int)
	    - SetPolygonTextureMapping (csPolygonRange, csMatrix3, csVector3)
	    - SetPolygonTextureMapping (csPolygonRange, csVector2, csVector2,
		csVector2)
	    - SetPolygonTextureMapping (csPolygonRange, csVector3, csVector2,
		csVector3, csVector2, csVector3, csVector2)
	    - SetPolygonTextureMapping (csPolygonRange, csVector3, csVector3,
		float)
	    - SetPolygonTextureMapping (csPolygonRange, csVector3, csVector3,
		float, csVector3, float)
	    - SetPolygonTextureMapping (csPolygonRange, float)
	    - GetPolygonTextureMapping (int, csMatrix3, csVector3)
	    - SetTextureMappingEnabled (csPolygonRange, bool)
	    - IsPolygonTextureMappingEnabled (int)
	    - SetPolygonFlags (csPolygonRange, uint32)
	    - ResetPolygonFlags (csPolygonRange, uint32)
	    - GetPolygonFlags (int)
	    - GetPolygonObjectPlane (int)
	    - IsPolygonTransparent (int)
	  and the following new functions to iThingState:
	    - GetPolygonWorldPlane (int)
	    - GetPolygonMaterial (int)
	    - SetPolygonMaterial (csPolygonRange, iMaterialWrapper*)
	  The idea is to eventually get rid of the iPolygon3DStatic and
	  iPolygon3D interfaces.  To do that we have to provide alternative
	  ways to create polygons.  We attempted to make an API that is as
	  flexible as the old one but a lot easier to use.  For example, in
	  simple1 we could replace about 44 lines with 3 using the new API.
	- Jorrit removed the bumptest app since this way to do bumpmapping is
	  obsolete when the new renderer is ready.
	- Jorrit converted all applications to use the new thing API.  As a
	  consequence none of the applications use the iPolygon3D or
	  iPolygon3DStatic interfaces now.
	- Jorrit fixed some parts of the documentation to reflect the latest
	  changes.
	- Jorrit renamed iThingFactoryState->SetTextureMappingEnabled() to
	  SetPolygonTextureMappingEnabled() to be more consistent.
	- Jorrit added a new version of iThingFactoryState->SetPolygonFlags()
	  that also accepts a mask.
	- Jorrit added iThingFactoryState->GetPolygonVertexIndices().
	- Jorrit added CS_POLYINDEX_LAST which can be used to get information
	  about the last created polygon in all functions that accept a single
	  polygon index.  In case of AddInsideBox() and AddOutsideBox() this
	  will actually return the index of the last polygon of that box.
	- Jorrit converted thing loader to the new API.
	- Eric Sunshine fixed Texinfo syntax error in apimod98.txi.  Also
	  re-wrapped to fit within 79 column.
	- Eric Sunshine added warning about libbfd's GPL license to
	  apimod98.txi.
	- Eric Sunshine corrected several mark-up and formatting problems in
	  apimod98.txi.
	- Eric Sunshine eliminated TeX `underfull hbox' warnings from
	  apimod98.txi and simple.txi.
	- Jorrit removed usage of iPolygon3D from a few plugins.
8-Oct-2003
	- Jorrit fixed keycolor rendering in the old OpenGL renderer in case
	  DrawPolygonMesh was used (fastmesh).
	- Jorrit added support for setting global mixmode on a thing (only for
	  objects).  Extended iThingState with SetMixMode() and GetMixMode().
	  Also extended the thingloader with a new <mixmode> keyword.
	- Jorrit removed support for setting mixmode and alpha for individual
	  polygons.  It is now only possible to set this on the entire mesh.
	  So if you need a transparent polygon then you have to make it a
	  separate mesh.
	- Jorrit fixed alpha support with DrawPolygonMesh by doing the above
	  change.  However, the alpha is still to dark in combination with a
	  lightmap.  The old OpenGL renderer still needs fixing for that.
	- Jorrit removed support for individual polygon drawing in thing.  This
	  greatly cleans up thing.  The fastmesh threshold flag has been
	  removed too as this no longer makes sense: all thing meshes are
	  fastmesh now.
	- Jorrit removed csPolygon2D in thing mesh plugin completely.  This
	  class is no longer needed.
	- Jorrit removed support for getting camera vertices from iThingState
	  and iPolygon3D (GetVertexC() function).
	- Eric Sunshine fixed a bug in configure.ac reported by Matze where it
	  was emitting -L/usr/local/include rather than -L/usr/local/lib.
7-Oct-2003
	- Jorrit changed the main loader for portals:
	    - New <portals> statement that can group several portals and also
	      allows the keywords 'lodlevel', 'move', 'hardmove', ...
	    - The ability to specify <portals> or <portal> as a child of
	      another mesh.
	    - Some notes: if you have a standalone <portal> then the optional
	      name of that portal will be used for both the portal container
	      and the portal.  In that case portals sharing the same name will
	      be grouped on the same portal container.	If you use a manually
	      specified <portals> statement then the names of the individual
	      portals will no longer be used for the portal container (only for
	      the portals).
	- Jorrit marked everything with the PRE_THING_PORTALREMOVE tag.
	- Jorrit removed portal support from thing.  There are still some
	  issues:
	    - 'portal' command in walktest is now temporarily broken.
	    - Infinite maze is now temporarily broken.
	- Jorrit removed iThingState and iThingFactoryState,
	  IntersectSegment().  This function is now obsolete (same as
	  iMeshObject->HitBeamObject()).
	- Jorrit removed the temporary function iRenderView->GetLastPortalP().
	- Jorrit added iMeshWrapper->GetPortalContainer() as an easy and
	  efficient way to get to the portal container of a mesh.
	- Jorrit removed iMeshObject->GetPortalCount() and GetPortal().
	- Jorrit changed api documentation to reflect new portal changes.
	- res changed the GL extensions manager to set function pointers to 0
	  only at initialization time, not when retrieving the ext fails.  This
	  should fix the crashes on GL implementations that support
	  ARB_vertex_program, but not ARB_fragment_program.  Also added
	  GL_ARB_texture_non_power_of_two and GL_ARB_point_sprite extensions.
	- Eric Sunshine upgraded the snap15 and snap16 images in the MSVC6
	  HOWTO in the user manual so that they no longer mention the obsolete
	  cssys library.
6-Oct-2003
	- Philip Wyett added 'waterdemo' to CS root .cvsignore file.
	- Jorrit fixed waterdemo so it no longer uses '/this/data'.  It is best
	  to avoid /this.
5-Oct-2003
	- Marten Svanfeldt added the posibility to automatically generate
	  texturecoordinates for reflective cubemaping.
	- Marten Svanfeldt added a demo using a reflective cubemap and a simple
	  liquid surface simulation
	- Marten added a missing check of the ARB_texture_cube_map extension to
	  the reflective cubemapping code.
	- res fixed a few flaws in the waterdemo Jamfile: some superflous
	  CompileGroup statements and the wrong Help.
	- Marten applied a fix to csSet::GetIterator and the
	  csSet::GlobalIterator
	- res fixed borked recursive directory scan logic in the cssys/general
	  .csplugin plugin scanner.
	- Eric Sunshine removed some unneccessary change-log entries which were
	  recently added to the source and header files of the MacOS/X port.
	  We already have CVS and history.txt for this purpose.	 Also made
	  minor formatting and whitespace corrections.
	- Luca fixed an error in a math formula in the documentation section
	  "7.6.6.4 Bringing it All Together" for doing texture mapping.
	- Rhad fixed csString's use of isalpha, isspace, toupper, tolower.
	  These functions must be passed a value in the range of an unsigned
	  char or EOF.
3-Oct-2003
	- Jorrit changed syntax services->ParsePortal() into
	  HandlePortalParameter().  This is a more general function which can
	  parse portal parameters but doesn't return an error if it doesn't
	  recognize the token.	That way the standard loader will be able to
	  use this and also add additional tokens to parse.
	- Jorrit changed the warp vector notation for portals in the loader
	  from 'v' to 'wv' and 'w' to 'ww' to avoid collision with using 'v'
	  for specifying the vertices of a portal.
	- Jorrit changed the main loader so that it also calls syntax services
	  HandlePortalParameter().  This means that you can now specify all
	  portal stuff in the <portal> statement.
	- res added a patch from Fritz Elfert <felfert@to.com> to fix thread
	  problems after change to _beginthreadex().  Apparently, the last
	  parameter needs to be a valid pointer.
2-Oct-2003
	- Jorrit extended the two versions of iEngine->CreatePortal() with a
	  'name' parameter.  That name will be used for the portal container
	  mesh.	 If there is already a portal container with that name then
	  that portal container will be reused (possibly allowing to create
	  multiple portals in the same portal container).
	- Jorrit changed the main loader to use the name of the <portal> for
	  the created portal container.
	- Jorrit changed the disabled part of thing loader (which creates
	  portal containers instead of portals in the thing itself) to use
	  "__portals__" as the name of the portal container where all portals
	  are created.
	- Jorrit additionally added a return 'portal' parameter to both
	  versions of iEngine->CreatePortal() so that the caller can more
	  easily find out the portal that was created without having to revert
	  to getting the last created portal in the portal container.
	- res fixed the missing of the csappframe library directory from
	  cs-config output under certain circumstances, as reported by Bjorn
	  Hansen <holomorph@users.sourceforge.net>.
	- Jorrit fixed a bug in the portal implementation of portal containers.
	  The csPortal->IntersectSegment() routine didn't work properly if a
	  portal container contains more then one portal.
	- Jorrit added a new 'portal' render priority.	If that render priority
	  is present then it will be used automatically for portals created by
	  the thing loader.
	- Jorrit fixed some bugs related to render priorities in case some
	  render priorities are not specified by the map file.
	- Jorrit changed the way the rotating door works in flarge.  The
	  overlay texture of the portal is now a separate child mesh in a
	  higher render priority.  This works a lot better with the new portal
	  container approach.  Also added a 'portal' render priority to flarge.
	- Jorrit temporarily removed the <float> from the door portal in flarge
	  since it appears to be broken a bit with the new portal containers.
	  Need to investigate.
	- Jorrit added SetName/GetName() to iPortal.
	- Jorrit attempted to fix the 'wavy portal' stuff in flarge for the new
	  portal containers but failed.
	- Jorrit implemented HardTransform() for portal containers.
	- Jorrit enabled portal compatibility mode in the thing loader now!
	  This means that all portals that you create in map files using the
	  <portal> keyword inside a polygon will now become portals in a portal
	  container that is linked to the mesh of the polygon.	Note that
	  portals in things are still supported (but not through the map file).
	  These will be removed later if this turns out to work well.  So this
	  is basically an experimental stage.  There are still a few issues
	  though:
	    - In OpenGL mode the keycolor of the hole in the large room of
	      flarge no longer works.  With software renderer it is fine.
	      Strangely enough the keycolor works fine if you look at the hole
	      from underneath.	That's a different portal though.
	    - In Software mode the rotating door no longer has correct
	      reflection.  In OpenGL it is fine.
	    - The <float/> keyword for the rotating door had to be removed so
	      there may be some issues there.  This needs to be investigated.
	    - Wavy sector doesn't work yet.
	- Jorrit fixed a bug in the HardTransform() implementation of the
	  portal container.  This fixes the partsys level.
1-Oct-2003
	- Jorrit fixed a bug reported by valgrind in the portal container.  It
	  was using an uninitialized variable.
	- Jorrit made frustvis and dynavis totally independent of things.
	- Jorrit changed the default value of accurate for the second
	  iVisibilityCuller->IntersectSegment() function (the one that returns
	  polygon indices) from false to true.	This means that by default the
	  most accurate version is used.
	- Jorrit added an optional movable parameter to
	  iPortal->GetWorldPlane().  This can be used by the portal container
	  to update the world plane if that is needed.
	- Jorrit added iPortal->PointOnPolygon() which tests if a worldspace
	  point is in the portal polygon.
	- Jorrit implemented iMeshWrapper->PlaceMesh() so that it works with
	  the new portal containers.  In addition it now also works on portals
	  that move.  This wasn't the case in the past.
	- Jorrit updated the apimod documentation for all recent beam
	  intersection related changes.
	- Jorrit fixed a bug in iSector->FollowSegment().  If a polygon was hit
	  but that polygon was not a portal then the intersection point was not
	  correctly set.  This bug could cause the explosion in walktest to not
	  appear from time to time.
	- Jorrit changed portal container so that it implements
	  iShadowReceiver.  This fixes lighting for the new portals.
	- Jorrit fixed a bug with thing and polygon meshes.  If a polygon mesh
	  didn't have any polygons in it then the polygon mesh would be setup
	  and cleaned all the time causing performance degradation.
	- Jorrit added a random value to the pause between setup of polygon
	  mesh and cleanup (in thing plugin).  That way the load of cleaning up
	  all polygon meshes will be spread in time.
	- Eric Sunshine fixed a bug in cs-config where the value of
	  $(LIB.EXE.PLATFORM) was not emitted by cs-config's --libs option.
	  This caused linking problems on Windows since gdi32.lib was not
	  getting mentioned in the link statement.  This broke recently when
	  LIBS.EXE was changed so that it is distinct from LIBS.EXE.PLATFORM,
	  rather than incorporating LIBS.EXE.PLATFORM.	Problem was reported by
	  Dariusz Dawidowski <chfsoft@interia.pl>.
	- Reed Hedges added cscmdCanvasHidden/Exposed events to MacOSX (cssys
	  lib), and made some small documentation changes for the Blender
	  scripts and for the System.RunWhenNotFocused config option.
30-Sep-2003
	- Jorrit fixed a bug in thing polygon mesh helper where it would not
	  clean up old data if the thing changes and at the same time the
	  polygon mesh helper is locked.
	- Eric Sunshine eliminated gobs and gobs of compilation warnings from
	  throughout the project which were emitted with the new renderer
	  enabled.
	- Eric Sunshine upgraded ODE check in configure.ac to require 0.039
	  rather than 0.035 since `odedynam' now requires 0.039.
	- Eric Sunshine fixed compilation problem: csRGBVector::CompareKey()
	  was using static_cast<> where reinterpret_cast<> was required.
	- res made the following changes:
	    - Added an In() method to csHash<>.
	    - Changed cstool/tokenlist.h so the name of the token table init
	      function can be user-defined.
	    - Removed unused glwin32 wglext.h.
	    - Changed glwin32 plugin to use less UTF8/WCHAR conversions.
	    - Fixed mode switching when exiting/terminating app on glwin32.
	    - Removed a prototype for a non-existing function from
	      win32/wintools.h.
	- Jorrit made the parsing of the 'start' keyword safer by allocating
	  the string from the node.
	- Jorrit fixed a bug in hierarchical meshes. If you had more then
	  two levels (i.e. a child of a child) then it was possible that in
	  certain conditions the leaf wouldn't be correctly added to the
	  culler.
	- Jorrit changed the way child meshes are treated for render
	  priorities. A child mesh is now put as a separate entity in a
	  render priority. That way it is now possible to put child meshes
	  in different render priorities (different compared to the parent
	  mesh).
	- Jorrit fixed the way static lod works. The child is now responsible
	  for asking the parent if it should be rendered (this also works
	  for hierarchical meshes in general). This is perhaps not the ideal
	  solution but for now it will do.
	- Jorrit fixed a bug in portal loading and collision detection. This
	  bug caused the camera to jump up and down in the reflecting room.
	- res fixed another problem with mode switching back on app exit.
	- res did some small cleanups in graph2d.cpp (removed some commented
	  out statements, removed a printf.)
	- Keith added fix for missing GetTriangles() in sprcal3d.  Still is
	  not 100% correct but will work well enough for viewmesh.
	- Duhprey added a todolist for the terrain plugin
29-Sep-2003
	- Jorrit moved ParseTextureMapping() and ParsePoly3d() from syntax
	  services to thing loader. It doesn't make much sense to make those
	  parsing functions public. Especially since iPolygon3DStatic is
	  going to be removed in the future.
	- Eric Sunshine added csMD5::Encode(csString const&) to complement the
	  existing Encode(char const*) method.
	- Eric Sunshine added csMD5::Digest::HexString() and HEXString().
	  These methods return a hexadecimal string representation of the
	  digest in lower- and uppercase, respectively.
	- Eric Sunshine added a lot of missing `const' qualifiers to iString
	  and csString.
	- Eric Sunshine removed a bunch of inline methods from iString.	 This
	  is supposed to be a pure, abstract interface for communication
	  between modules.  It is not supposed to contain implementation.
	- Eric Sunshine fixed several problems in iString where it failed to
	  return csRef<> in appropriate circumstances.
	- Eric Sunshine repaired the butchered "char* GetData() const"
	  abomination in iString and csString by replacing it with two methods:
	  one entirely const, and one entirely non-const.
	- Eric Sunshine added missing const version operator[] to iString.
	- Eric Sunshine added Slice() method to iString and csString.  This is
	  just like SubString() but returns the substring by value rather than
	  stuffing it into a passed-in buffer.
	- Eric Sunshine added iString::Downcase() and Upcase() methods.
	- Eric Sunshine renamed csString::strlwr() to Downcase().  Also added a
	  complementary Upcase() method.
	- Eric Sunshine fixed bugs in csString and scfString where some
	  operations were incorrectly aborting at the first null character,
	  rather than processing all characters in the string.	It is
	  acceptable (presently) for csString to contain arbitrary binary data,
	  thus embedded null characters may be present.
	- Eric Sunshine fixed bogus logic in scfString::SubString().
	- Eric Sunshine replaced a bunch of long, ugly copy/paste sprintf()
	  invocations throughout the project with csMD5::Digest:HexString().
	- Eric Sunshine removed the unused iShaderProgram::GetProgramID().
	- Jorrit fixed a missing strlwr() in win32/loadlib.cpp.
	- Jorrit removed the poly3d parameter from syntax
	  services, ParsePortal() routine. Instead added a sector return
	  parameter. By doing this, ParsePortal() is now independent of
	  polygons and also no longer creates the portal itself.
	- Eric Sunshine applied a few small patches from Dariusz Dawidowski
	  <truman@go2.pl> protecting some printf()'s in CS_DEBUG and changing
	  others to use iReporter.
	- Eric Sunshine eliminated a slew of compilation warnings in cstool
	  which were present when the new-renderer was enabled.
	- Eric Sunshine eliminated scads of compilation warnings from the new
	  renderer plugins.
	- Eric Sunshine eliminated compilation warning from
	  portalcontainer.cpp.
	- Jorrit changed the standard loader so that it now gives the mesh
	  wrapper as the context data for a mesh plugin (i.e. inside params).
	- Added code in thing loader to create portals using the new
	  portal container stuff instead of using portals in the thing plugin.
	  This seems to work mostly but not completely. That's why this new
	  code is still disabled for now.
	- Andrew Mann made a small optimization in csEventTimer::HandleEvent()
	  This is far from the best way to do things, but it's faster than
	  the previous method in the apparent current common use.
28-Sep-2003
	- Eric Sunshine corrected erroneous comments in
	  CS/mk/autoconf/compiler.m4.
	- Eric Sunshine performed clean-up of
	  CS/scripts/jamtemplate/configure.template.
	- Eric Sunshine fixed a number of problems in
	  CS/scripts/jamtemplate/cs_check_host.m4:
	    - Comments were all wrong; they had been copy/pasted from
	      configure.ac but not edited to suit the new context.
	    - Was using an old, unreliable scheme for differentiating between
	      MacOS/X and Darwin.
	    - Was incorrectly emitting OS_MACOSX when building for Darwin.
	    - Neglected to emit OS_UNIX when building for MacOX/X (in addition
	      to OS_MACOSX which it was correctly emitting).
	- Eric Sunshine augumented configure.ac so that plugin meta-information
	  embedding is disabled by default for platforms on which libbfd
	  accesses the embedded information, since libbfd uses a GPL license
	  which is incompatible with Crystal Space's LGPL license.  People who
	  do not mind having their project infected by the GPL libbfd library
	  must enable embedding explicitly.
	- Eric Sunshine augmented configure.ac so that it no longer performs
	  the libbfd check if plugin meta-information embedding is disabled.
	  Previously it performed the check regardless, which could result in
	  -lbfd appearing in the link statement even when embedding was
	  disabled.
	- Wouter added csgeom/polymesh to include/css.h.
	- Jorrit implemented csEngine::CreatePortal() which makes a portal
	  container as a child of another mesh.
27-Sep-2003
	- Eric Sunshine made minor clarifications to the "SCF Changes" section
	  of the "Release Notes 0.96 to 0.98" appendix in the user manual.
	- Jorrit implemented csPortal::ComputeCameraPlane().
	- Eric Sunshine worked around a GNU make bug on MacOS/X which caused
	  compilation of `gl3d' to fail.  In particular, under certain "random"
	  circumstances, GNU make incorrectly resolves implicit rules.	In this
	  case, when building the gl3d source files, it neglected to use the
	  gl3d implicit rule, thus GL.CFLAGS was not consulted and the build
	  failed.  Worked around the problem magically by changing cs.mak so
	  that the module makefiles define their own implicit rules before
	  cs.mak defines the fallback implicit rules.  Previously, cs.mak
	  defined implicit rules first.
26-Sep-2003
	- Jorrit fixed the static lod documentation which forgot to mention
	  that you had to add the children to the parent too.
	- Jorrit added an optional polygon_idx parameter to
	  iMeshObject->HitBeamObject(). Currently only thing supports this.
	  The intention is that you can get the index of the polygon that is
	  hit.
	- Eric Sunshine protected the new terrain item in user.mak inside
	  USE_NEW_RENDERER conditional.
	- Eric Sunshine changed mkdir.m4 so that _AS_MKDIR_P_PREPARE() removes
	  the bogus "-p" directory using rmdir rather than "rm -rf" since rmdir
	  is a bit safer in case someone actually has an existing directory
	  named "-p" (unlikely though that is).
	- Eric Sunshine wrapped CS_TEXT_CACHE_OUTPUT's AS_MKDIR_P invocation
	  inside AS_ESCAPE in order to ensure that AS_MKDIR_P works correctly
	  even in cases when AS_MKDIR_P has to fall back to the non-"mkdir -p"
	  case.	 When it is not wrapped in AS_ESCAPE, the AS_MKDIR_P variables
	  and subshell invocations ($ac_dir, $ac_dirs, `dirname`) are
	  incorrectly evaluated in the context of configure, even though they
	  are supposed to be evaluated in the context of config.status.
	- Eric Sunshine updated commentary in mkdir.m4 and textcache.m4 to
	  reflect the fact that he finally managed, with additional prompting,
	  to get the Autoconf maintainers to fix the bugs which he had reported
	  nearly a year ago.
	- Jorrit completed the implementation of csSector::IntersectSegment()
	  for portal containers.
	- Jorrit implemented HitBeamObject() for portal containers. Also
	  supports the polygon index.
	- Jorrit made the first portal in flarge (the one from the first
	  room to the second small room) use the new portal container feature.
	  Seems to work ok so far. Note that this change requires a relight
	  since the geometry in the first room changed.
	- Jorrit changed the spider in bugplug to use a weak reference to the
	  camera to ensure the camera pointer is cleaned up if the camera
	  is deleted. This fixes a crash bug in bugplug when trying to
	  select some objects through portals.
	- Jorrit implemented HitBeamOutline() of portal container. This is
	  a faster version of HitBeamObject() which stops at the first hit
	  it finds. Also did a small optimization on thing HitBeamOutline().
25-Sep-2003
	- Jorrit removed iCamera->GetHit(). This function is only a very
	  thin wrapper on top of iSector->HitBeamPortals() so it is not
	  very useful to keep it and to clutter the API with it.
	     camera->GetHit(csVector3& v, int* pidx)
	  becomes:
	     camera->GetSector ()->HitBeamPortals (
		camera->GetTransform ().GetOrigin (), v, isect, pidx)
	- Duhprey added a new terrain plugin and demo for the NR
	- res made the following changes:
	    - Fixed walktest for recent iCamera->GetHit() removal.
	    - Added Jamfiles for duhprey's CLOD plugin.
	    - Added a patch from John Harger <john_h@selectpath.com> which
	      enhances the glshader_arb plugin with fragment program support.
	    - Added "polygon buffers" to the NR. You can compare it to the
	      polygon buffers of the OR; you feed in some polygons, and get out
	      a render buffer source you have specify in the csRenderMesh
	      structure. The 'mesh type' has to be 'POLYGON'.
	    - In the csRenderMesh structure, the 'transform' member was
	      renamed to the more speaking 'object2camera'.
	    - Brought the NR SW renderer up-to-date.
	    - Added polygon drawing to NR SW. Still veeery crude.
	    - Some GL extensions are now inited in the plugins which actually
	      use them.
	    - Fixed the problem that the shader manager only accepted
	      technique priorities > 0.
	- Norman Kraemer extended pythmod_setup.py to handle "-l" prefixed
	  additional libraries between the two "--".
	- Norman Kraemer augmented PYTHMOD.LIBS.PLATFORM flags to include
	  LIBBFD.LFLAGS. He thinks this should probably go into configure.ac.
	- res removed the 'privateGetVariable()' stuff from shader manager.
	- DeSigna removed incorrect information about iEventQueue's name in
	  the object registry from ievq's doxygen comments.
	- Keith Fulton added functions to set the spr3d action by index instead
	  of having to use action name strings.
24-Sep-2003
	- Jorrit finished implemented basic drawing of portals in
	  csPortalContainer. Still some optimizations and testing to do.
	- Jorrit extended iEngine->CreatePortal() so that you can give the
	  3D coordinates of the portal.
	- Jorrit added the first basic support for the <portal> keyword in
	  a sector (loader).
	- Jorrit changed GetNearbyObjects() and GetNearbyMeshes() to support
	  the new portal objects. This still leaves functions like
	  FollowSegment() and IntersectSegment().
	- Jorrit added a test standalone portal to flarge (in comments for
	  now).
	- Jorrit fixed a bug in csSector::HitBeam(). It wasn't correctly
	  using GetFullTransform().
	- Eric Sunshine upgraded a bunch of outdated information in the
	  reference-counting HOWTO in the user manual, and added lot of
	  important information which was missing.
	- Eric Sunshine heavily revised the SCF chapter of the user manual.  It
	  was extremely outdated.  Also documented all of the features of the
	  revised SCF implementation, such as .csplugin meta-files and
	  automatic plugin discovery.
	- Eric Sunshine update apimod98.txi to reflect all of the major SCF
	  changes for version 0.98.
	- Eric Sunshine finished updating the user manual to reflect all of the
	  recent SCF changes.
	- Eric Sunshine fixed formatting problems in msvc7proj.txi, and
	  eliminated TeX warnings.
	- Eric Sunshine repaired some mark-up problems in sequence.txi.
	- Jorrit changed the api of the following functions:
	    - iThingState->IntersectSegment() and
	      iThingFactoryState->IntersectSegment() now return polygon index
	      instead of polygon pointer.
	    - The version of iSector->HitBeam() that doesn't support portals
	      now returns polygon index instead of pointer.
	    - The version of iSector->HitBeam() that supports portals is
	      now renamed to iSector->HitBeamPortals(). It now returns
	      the mesh that is hit and also a polygon index.
	    - iCamera->GetHit() now returns the mesh that was hit and
	      a polygon index.
	    - iVisibilityCuller->IntersectSegment() now returns a polygon index
	      instead of a pointer.
	    - iPortal->HitBeam() is renamed to HitBeamPortals() and now
	      returns a mesh and polygon index.
	- Eric Sunshine eliminated a slew of compilation warnings from
	  rgbpixel.h reported by MSVC regarding implicit conversion from int to
	  unsigned char.  Also eliminated extremely dangerous code which
	  assumed 32-bit architecture.
	- Eric Sunshine fixed some invalid URLs in sysreq.txi pointed out by
	  Roland Schulz <mail@r2s2.de>.
	- Eric Sunshine re-created all of the EPS images in
	  CS/docs/texinfo/tutorial/howto/msvc7proj because the existing ones
	  had corrupt bounding boxes.  Also converted the JPEGS from
	  progressive to normal mode.
	- Eric Sunshine re-created all of the EPS images in
	  CS/docs/texinfo/tutorial/howto/msvc6proj because the existing ones
	  had corrupt bounding boxes.
23-Sep-2003
	- Jorrit changed the default display depth in video.cfg from 16
	  to 32. On 3D cards, CS performs awfully bad with 16-bit displays
	  because stencils are not hardware accelerated. So 32-bit is a better
	  default.
	- Jorrit implemented csPortalContainer::DrawTest(). This still leaves
	  Draw() unimplemented.
	- Jorrit started implementation of csPortalContainer::Draw().
	- res added constructors to csSet<>::Iterator and
	  csSet<>::GlobalIterator to shut up MSVC7 warnings about failure to
	  create default constructors.
22-Sep-2003
	- Eric Sunshine converted csengine.mak and thingmsh.mak over to the new
	  style where built objects and resources are placed in their own
	  directory, rather than polluting and possibly colliding with other
	  resources in $(OUT).
	- Jorrit fixed a bug in syntax services where it was parsing a
	  string shader variable as float.
	- Jorrit moved code to compress vertices from csThing to
	  csVector3Array::CompressVertices(). There are two versions: one
	  for csArray<csVector3> and one for csVector3*.
	- Jorrit worked more on the portal container stuff. Added csPortal
	  implementation. Also extended iPortalContainer with functions
	  to create and manage portals. csPortalContainer now does
	  the following:
	      - Compress vertices automatically.
	      - Calculate bounding box for object model.
	      - Support for polygon mesh.
	- Jorrit fixed a bug in polygon meshes of thing. The base polygon
	  mesh was also being restricted to the CS_POLY_COLLDET flag. But
	  that's wrong. It should have all polygons.
	- Jorrit renamed csPortal in thing to csPortalObsolete. This to avoid
	  a clash with csPortal in engine.
	- Jorrit added GetObjectPlane(), GetWorldPlane() and
	  ComputeCameraPlane() to iPortal and the two current implementations.
	- Jorrit added iRenderView->SetLastPortal() and GetLastError().
	  This function replaces GetPortalPolygon() and SetPortalPolygon().
	  Temporarily the function still accepts an iPolygon3D but that
	  is going to change as soon as portal support is removed in thing.
	- Jorrit added CS_PORTAL_CLIPSTRADDLING to indicate a portal has to
	  cut geometry that goes through the portal itself. This is only needed
	  if the portal surface is transparent.
	- Jorrit added CS_PORTAL_VISCULL and CS_PORTAL_COLLDET.
	- Jorrit added support for the three new portal flags in syntax
	  services (<clipstraddling />, <viscull />, and <portal />).
	- Eric Sunshine added adjustments for TeX parameters in cs.txi in order
	  to reduce the likelihood of over- and underfull hbox warnings.
	- DeSigna patched in jsquare's changes to the msvc7 external
	  project howto, and added jpeg images for the HTML version.
	- res added EPS versions of the new images for the VC7 external
	  project HOWTO.
	- res changed the EPS images from the Cygwin setup guide to be wrapped
	  versions of the JPEG images and reduced their size in the document a
	  bit.
	- Norman Kraemer changed qsqrt to silence gcc-3.3.1, which started to
	  complain about deprecated use of memory input without lvalue in asm
	  argument. The resulting code is the same as generated with the
	  deprecated version (hopefully this is true for other gcc versions
	  too).
21-Sep-2003
	- Jorrit added iEngine->CreatePortalContainer() and CreatePortal().
	  With these functions it is possible to create portal container
	  meshes.
	- Jorrit fixed wrong header protector in cstool/meshobjtmpl.h.
	- Anders Stenberg implemented operator/= for csDVector3, since it
	  wasn't implemented by some reason, just declared in the header.
	- Eric Sunshine changed the `objcopy' check in configure.ac to employ
	  AC_CHECK_TOOL() rather AC_CHECK_PROGS() in order to support
	  cross-builds.
	- Marten Svanfeldt made these changes
	    - Added GetCurrentFrameNumber() to [cs/i]Engine. It will return a
	      number which is incremented on each Engine::Draw.
	    - Added Empty () to csRenderMeshList. It will empty all meshlists,
	      but keep the renderpriority structs.
	    - Added Sector::GetVisibleMeshes(iRenderView*). It will return
	      all visible meshes for a given sector and rview. These will
	      be cached, and only updated once each frame. This is to avoid
	      doing culling so many times when using multipass rendering.
	      Also made the generic renderstep to use it.
	    - Fixed a nasty bug in csGLRender3D where CS_ASSERT() was set
	      around an important statement in the VBO renderbuffer
	      implementation.  This had the sideeffect that VBO didn't work in
	      releasemode.
	- res added a missing #include to portalcontainer.cpp (older GCC
	  didn't like the (void)t where t's type was only forward declared.)
20-Sep-2003
	- Jorrit reverted nearly all his changes of yesterday. The only two
	  changes that remain are the iPortalContainer object (but now
	  totally empty and unimplemented) and the multiple inheritance
	  used in csMeshWrapper. But csSectorObject is now gone. The reason
	  is that this system turned out much too complex. Instead portals
	  will be implemented by a special mesh object that is managed
	  by the engine itself.
	- Jorrit changed csPortalContainer so that now implements iMeshObject
	  (through csMeshObject).
	- Jorrit fixed a bug in csMeshObject->GetRenderMeshes(). It didn't
	  set 'num' to 0.
19-Sep-2003
	- Eric Sunshine added the new CS_MSG_ERROR() Autoconf macro.  This is A
	  convenience wrapper for AC_MSG_ERROR() which invokes AC_CACHE_SAVE()
	  before aborting the script.  Saving the cache should make subsequent
	  re-invocations of the configure script faster once the user has
	  corrected the problem(s) which caused the failure.  All invocations
	  of AC_MSG_ERROR() in configure.ac have been converted to instead
	  invoke CS_MSG_ERROR().
	- Jorrit started a fundamental change in the way portals work. The
	  plan is to move portals away from thing and let the engine manage
	  them:
	      - Created csSectorObject. csSectorObject is now the superclass
		of csMeshWrapper and takes care of the movable, render
		priority and so on.
	      - csSectorObject now inherits from iVisibilityObject.
	      - Added csPortalContainer which will be the object implementing
		portals. Currently this does nothing.
	      - Added iPortalContainer.
	- Jorrit changed all PrepareItem/FreeItem calls in the engine
	  with clearer names (i.e. PrepareMesh, PrepareSector, PrepareLight,
	  and PrepareFactory). That makes it easier to grep for them and
	  also makes it easier to read code that uses those functions.
	- Jorrit changed pubapi target so that it no longer includes
	  csengine documentation.
	- Jorrit moved csRGBVector from csutil to csgfx. Firstly it belongs
	  there, and secondly this avoids a circular dependency between
	  csgfx and csutil.
	- Jorrit added iPortalContainerList.
	- res made the following changes to the stencil shadow render step:
	    - When a shadow mesh is auto-closed, the created polymesh is
	      reused the next time the shadow mesh has to be closed.
	    - Don't draw shadow volumes when the shadow shader doesn't offer
	      a suitable technique.
18-Sep-2003
	- res reverted Paul's change made to libs/cssys/win32/shellstuff.h
	  yesterday which caused SHGetFolderPathW() to be used when present.
	  The way this function was employed was borked: as the W in the name
	  indicates, it returns it's data as a wide(i.e. wchar_t*) string.
	  However, it was stored in a standard char* string - thus the data
	  returned would've been useless.
	- Eric Sunshine updated the API documentation for csGetPluginMetadata()
	  so that it clearly states how the function returns status
	  information, and exactly how it signals normal and abnormal retrieval
	  results.
	- Eric Sunshine fixed all of the implementations of
	  csGetPluginMetadata() so that they operate as documented.  In
	  particular, they now return a valid csRef<iDocument> if and only if
	  they successfully retrieve metadata for the plugin.  In the past, the
	  implementations often incorrectly returned empty iDocuments which
	  confused SCF since SCF was expecting an iDocument only if metadata
	  had been retrieved.  This fixes the problem in which SCF would crash
	  as a result of receiving an empty iDocument from the various
	  platform-specific csGetPluginMetadata() implementations for non-CS
	  shared libraries (.so, .dll, etc.) if they happened to reside in the
	  same directories as CS plugins.
	- Eric Sunshine applied a patch to csList<> from Bjorn Hansen
	  <holomorph@users.sourceforge.net> which added methods
	  csList::Iterator::Prev(), InsertBefore() and InsertAfter(), as
	  well as a little bit of additional Doxygen documentation.  Eric
	  also fixed several other problems, such as numerous missing
	  inline keywords, and performed additional documentation cleanup.
	- Jorrit applied the same fixes he did to glextmanager.h to the
	  Python scripts that generate that file. That way his fix will not
	  be overwritten.
17-Sep-2003
	- Eric Sunshine documented cssys+csutil merge in apimod98.txi.
	- Eric Sunshine documented csHash<> and csSet<> in apimod98.txi.
	- Eric Sunshine repaired a lot of Texinfo mark-up errors in
	  apimod98.txi.
	- Eric Sunshine renamed Appendix C and all of its subsections from "API
	  Changes" to "Release Notes" since these sections cover more than just
	  API changes.
	- Eric Sunshine eliminated numerous `hbox' warnings reported by TeX.
	- Jorrit used valgrind in combination with the new renderer and
	  discovered that the csGLExtensionManager didn't initialize the
	  function pointers if some extension is not available. Since
	  glrender3d (and other modules) sometimes test on the value of
	  such a function pointer this could obviously give very bad
	  results. Now csGLExtensionManager will initialize everything
	  even if the extension is not present.
	- Eric Sunshine added dlltool, dllwrap, and windres checks to
	  configure.ac.	 These checks respect the --host configure option,
	  which makes it possible to cross-build CS for Mingw from Linux.
	  http://www.libsdl.org/extras/win32/cross/README.txt
	- Eric Sunshine changed the Mingw build to once again use "gcc -shared"
	  when creating plugin modules instead of dllwrap.  Jorrit reports that
	  he has trouble debugging plugins (missing debug symbols) built with
	  both "gcc -shared" and dllwrap, so we might as well use the more
	  well-supported option (gcc -shared) rather than the deprecated one
	  (dllwrap).  It has also been reported that this change might work
	  around a crash when loading some DLLs (such as glwin32) which are
	  created with very recent Mingw/Msys tools.
	- Eric Sunshine fixed a typographical error in configure.ac:
	  CS_GL_PATH --> CS_GLU_PATH
	- Eric Sunshine fixed render3d/opengl/gl_txtcache.cpp so that, when
	  including glu.h, it respects the CS_GLU_PATH which is emitted by the
	  CS configure script.
	- Eric Sunshine fixed problem on MacOS/X following the cssys+csutil
	  merge where .m and .mm source files were making their way into the
	  OBJ.CSUTIL makefile variable, thus causing make-based builds to fail.
	- Eric Sunshine fixed bugs in libs/cssys/cssys.mak where it failed to
	  respect $(SRCDIR) in all cases.
	- Eric Sunshine eliminated hundreds of "macro redifinition" warnings
	  from renderer/opengl/csglext.h.
	- Paul Garceau performed a Mingw/Msys build/maintenance update for
	  Windows OS versions < 5.0:
	    - Added exception processing to allow SHGetFolderPathW to be
	      properly loaded for Unicode Processing as needed or requested by
	      Windows OS for those Windows OS versions < 5.0
	      (NT4/Win98/Win98SE/Win95).
	    - Impact: Reduce time and overhead required to open Canvas and
	      start Renderer for Windows OS versions < 5.0.
16-Sep-2003
	- Jorrit fixed the thing plugin so that it now actually registers
	  leaving portals to the sector.
	- Jorrit cleaned up a few portal things in thing mesh.
	- Jorrit changed the leaving portals in iSector so that
	  it is now a set of meshes that have portals instead of just portals.
	- Jorrit removed the arriving portal stuff. It is currently not
	  possible to correctly maintain this list and it is probably also
	  not needed.
	- Jorrit changed the movable code so that it now correctly updates
	  the list of leaving portal meshes when an object changes sector.
	- Eric Sunshine merged the object files from cssys and csutil into a
	  single library: csutil.  (The cssys sources are still separate.)
	  This change solves a host of problems resulting from the severe
	  circular dependencies between these two modules, and should help pave
	  the way for creation of proper shared libraries in the future.
	- Eric Sunshine augmented cs-config so that it has knowledge of the
	  csappframe library.
	- res made the following changes:
	    - Moved the const char* and csRef<> hash key handlers from
	      engine/renderloop.h to csutil/hashhandlers.h, as they're general
	      purpose.
	    - Changed the renderloop file loader: instead of <renderloop>, the
	      top level node must be named <params>, for compatibility with
	      the "paramsfile" option from csloader.
	    - Added a GetIterator() method to csSet<>.
15-Sep-2003
	- Eric Sunshine added a check for the C++ `typename' keyword to
	  configure.ac.	 If not recognized by the compiler, the
	  CS_USE_FAKE_TYPENAME_KEYWORD macro is emitted to volatile.h, which
	  csdef.h recognizes in order to fake up a `typename' keyword.
	- Eric Sunshine removed a couple useless #defines from csdef.h.
	- Jorrit added a templated csSet<T> which is to csHash<T> what
	  csHashSet is to csHashMap (i.e. csSet<T> is a templated version
	  of csHashSet).
	- Jorrit added a set of arriving portals and a set of leaving
	  portals to every sector. This list is maintained by the entities
	  that create portals (i.e. thing mesh only at this moment) and
	  also by the movable when objects that contain portals move.
	  Note that this is not done yet!
	- Eric Sunshine performed project-wide spelling corrections:
	    basicly	--> basically
	    conveniance --> convenience
	    conveniant	--> convenient
	    occurance	--> occurrence
	    occurrance	--> occurrence
	- Jorrit added weak reference support to all SCF objects. This adds
	  four bytes of overhead per SCF object but that should not hurt
	  too much. On the other hand you can now use csWeakRef<T> on every
	  iBase instance. There is a new SCF_DESTRUCT_IBASE() macro (and
	  SCF_DESTRUCT_EMBEDDED_IBASE()) which should now be used in
	  all implementations of iBase (but currently is not used in anyone).
	- Jorrit changed the portal implementation in thing to use a weak
	  reference to the sector instead of using the old iReference based
	  approach. This means that when a sector is removed the portals
	  pointing to that sector will automatically get cleared. As
	  a consequence of this iPortal no longer inherits from iReference.
	- Jorrit removed iReference and iReferencedObject. These interfaces
	  are no longer needed.
	- Eric Sunshine added `scf' prefix to new internal-detail iBase
	  instance variables and methods to avoid namespace pollution.
	- Eric Sunshine added --accept and --reject options to msvcgen.pl which
	  allow filtering of the input filename list in case the client is
	  unable to do the filtering itself.
	- Marten Svanfeldt fixed the bug with stencil-shadows in r3dtest.
	- Eric Sunshine fixed a problem introduced on 12-Sep-2003 which
	  resulted in platform-specific libraries not being linked into plugin
	  modules.  The problem was triggered when the LIBS.EXE definition in
	  the platform-specific makefiles was changed to the more correct
	  LIBS.EXE.PLATFORM.
14-Sep-2003
	- DeSigna made the following changes:
	    - Fixed the SCF_CREATE_INSTANCE macro to return a csPtr<>, in
	      accordance to the other SCF macros.
	    - Fixed all usage of SCF_CREATE_INSTANCE in CS to work correctly.
	    - Fixed nettut to use csRef<> tracking instead of raw pointers.
	- Eric Sunshine added an RTLD_NOW check to configure.ac since this
	  constant is missing from some platforms, such as OpenBSD.
	- Eric Sunshine added a check to configure.ac for the Cg shader
	  toolkit.  The glshader_cg plugin is now built only if the Cg toolkit
	  is detected.
	- Eric Sunshine added a check to configure.ac to see if the compiler
	  recognizes the -pipe option.
	- Eric Sunshine fixed several bugs in various shader plugins where
	  their ProgramID() methods were casting the first character of
	  a string to a pointer, rather than taking the address of the string
	  as intended.	Also eliminated several compilation warnings in
	  glrender_cg plugin.
	- Eric Sunshine eliminated use of magic constants in favor of sizeof()
	  in numerous locations throughout the project.
	- Eric Sunshine worked around a problem where X11-related plugins
	  failed to link when built with Jam.  This problem arose on
	  12-Sep-2003 when configure was "fixed" to not emit empty properties
	  to the generated Jamconfig file.  Jam performs variable expansion in
	  the odd and usually annoying "product-wise" manner in which
	  "$(X) $(Y)" with X set to "x" and Y undefined will expand to ""
	  rather than "x " which would be the case with every other tool on the
	  planet.  The Jam expansion method broke the build because X11.LFLAGS
	  referenced other X11-related variables by name, and one or more of
	  those variables were undefined because configure omitted them from
	  Jamconfig since their values were empty.
13-Sep-2003
	- Philipp Aumayr removed changed a delete data; to delete[] data; in
	  plugins/video/openglcommon/glfontcache.h. mentioned by unaek in
	  #crystalspace
	- Jorrit cleaned up the shadermanager. Also fixed a small bug in the
	  registration of the event handler where it would use || to combine
	  two masks instead of |. Additionally removed some warnings.
	- Jorrit cleaned up the shader plugins.
	- Duhprey fixed an error in shadow caps.  Fixes one of the glitches
	  behind the wall in r3dtest.
12-Sep-2003
	- Jorrit moved the progressive LOD calculation classes from sprite3d
	  to csgeom.
	- res changed r3dtest so the twisted torii aren't bump mapped for now.
	  genmesh currently doesn't provide all the informations required for
	  dot3 at the moment, causing visual glitches on some hardware.
	- Eric Sunshine added an --enable-meta-info-embedding option to the
	  configure script.  When enabled, plugin meta-information is embedded
	  directly in the plugin module (if supported by the platform).	 When
	  disabled, the meta information is placed alongside the plugin module
	  in a separate .csplugin file.	 Embedding is enabled by default.
	- Eric Sunshine augmented CS_BUILD_PROPERTY() in configure.ac so that
	  it no longer emits properties for which the value is empty.  Not only
	  does this eliminate empty assignments in the generated configuration
	  files, but it also simplifies numerous callers of
	  CS_BUILD_PROPERTY().
	- Eric Sunshine relocated cleanup of autom4te.cache from the
	  "maintainerclean" target to the "distclean" target.
	- Eric Sunshine removed the last remnant (DO_DINPUT_KEYBOARD) of
	  DirecInput support; the bulk of which was removed some time ago.
	- Philip Wyett corrected #include's for Cg and eliminated make
	  depend warnings.
	- Eric Sunshine fixed a number of problems where the output of
	  "cs-config --makevars" was lacking on some platforms (missing
	  definitions, etc.) for both make and jam generations of cs-config.
	  (bug #759768)
	- Eric Sunshine fixed csconf.mak so that it also extracts <cs-config>
	  blocks from CS/mk/*.mak, rather than only from the platform-specific
	  makefile.
	- Eric Sunshine changed cs-config so that it also now recognizes
	  --long-version in addition to --longversion.
	- Eric Sunshine added --makevars to cs-config --help output.
11-Sep-2003
	- Jorrit cleaned up some sources in the stencil renderloop.
	- Jorrit did the following optimizations with regards to
	  iPolygonMesh::CloseMesh() and the stencil renderloop:
	    - CloseMesh() now returns a table of indices so it doesn't do an
	      alloc for every single polygon.
	    - The copy of the polygon mesh maintained by the stencil renderloop
	      also avoids the per-polygon alloc now.
	    - CloseMesh() now uses a more optimal way to close the mesh if it
	      knows the base mesh prefers triangles.
	- Jorrit fixed a bug in csRenderMeshList with front2back and back2front
	  sorting.  The sorting functions were casting the pointers wrong.
	- Jorrit did some cleanups to glrender3d.
	- Jorrit removed the assembly mmx routines for the Dynavis coverage
	  buffer.  They didn't appear to be working correctly anymore (at least
	  with gcc 3.2) and the gain was minimal while complexity is a lot
	  more.
	- Eric Sunshine increased the minimum FreeType2 version number checked
	  by the CS configure script from 2.0 to 2.1.3 since the CS FreeType
	  plugin is using features introduced in 2.1.3.	 (Better yet, in the
	  future, the configure script should be updated to check for the
	  actual FeeType features CS requires, rather than checking for
	  specific version numbers.)
	- Eric Sunshine renamed csHash<>::Iterator::Return() and
	  csHash<>::GlobalIterator::Return() to Reset() for consistency with
	  other iterators and because Reset() is a more sensible name.
10-Sep-2003
	- Philip Wyett made struct ShadowDrawVisCallback a friend to class
	  csStencilShadowStep.	This works round C2248 MSVC 6 compiler error
	  and known compiler bug Q243351.
	- res fixed the totally bogus OR csLight::GetDistanceForBrightness ().
	- Philip Wyett added CSTOOL dependency to rlsstd.mak (rendstep_std).
	- Anders Stenberg fixed some drawing problems in pgserver.
	- Jorrit copied data/shader/light.xml to data/shader/light_bumpmap.xml.
	  Then he created a new data/shader/light.xml which doesn't do the
	  bumpmapping techniques. r3dtest now uses light_bumpmap.xml while
	  stenciltest uses light.xml.
	- Jorrit extended the engine sequence manager with the ability to
	  move lights. This could be done without modifying the engine
	  sequencer API as the AddOperationMoveDuration() function can be
	  reused. In the parser Jorrit added the <movelight> operation.
	- Jorrit added a few sequences to r3dtest so that the light now moves.
	  This demonstrates how the shadows and bumpmaps are modified
	  dynamically.
	- Jorrit fixed a crash in old renderer related to light attenuation.
	- Jorrit fixed a strange construction in syntax services which
	  prevented flarge from loading since there was a conflict with
	  the 'float' keyword being used for shader variables and for
	  portals.
	- Eric Sunshine removed 8-bit characters from rendermeshlist.h and
	  rendermeshlist.cpp.
	- Eric Sunshine fixed bug in bfdplugins.cpp where it assumed the
	  `errmsg' variable would be null, but was in fact unassigned.
	- Jorrit added three torus objects from stenciltest to r3dtest.
	- Eric Sunshine fixed errors in glshader_fixed.mak where the SRC and
	  INC variables were not respecting SRCDIR.
	- Eric Sunshine fixed problem in rendermeshlist.h where it mentioned
	  iObjectRegistry in a prototype even though it wasn't declared.
	- Anders Stenberg did some color correction in picogui to get
	  red/blue right.
	- Jorrit did some code cleanup in the engine renderloop code. Also
	  removed a few warnings.
	- Jorrit performed the following small optimizations in relation
	  to the renderloop stuff:
	    - Avoided a memory allocation of a transformation for every single
	      technique.
	    - Avoided a memory allocation of the callback structure every
	      frame.
	    - Changed csRenderMeshList::GetSortedMeshList() so that it now
	      updates a csArray<csRenderMesh*> instead of returning a table
	      that has to be deleted every time.  This avoids a lot of memory
	      allocation overhead.  In the generic render step code we now
	      maintain a permanent array (permanent for that step) to keep
	      these meshes in.	This avoids having to construct/grow the array
	      all the time.
9-Sep-2003
	- res added a simple calculation of binormals and tangents to thing.
	- res reformatted light.xml a bit.
	- res added some cheesy new textures to stdtex.zip: normalmaps for the
	  textures used in r3dtest and a new texture for the donut in flarge.
	  Also moved it a bit so it's only half shadowed.
	- Jorrit added 'cstool' library to rendstep_std plugin.
	- Jorrit fixed an accidental cvs conflict stuff that got into
	  plugins/video/render3d/opengl/gl_txtcache.cpp.
	- Jorrit fixed an accidental commit in thing.cpp.
	- Jorrit fixed a bug in rendermeshlist.cpp which would sometimes try to
	  use a 0 render priority.
	- Keith updated the example .cal3d file in
	  /plugins/mesh/sprcal3d/persist.
	- Jorrit fixed a compile error in thing.cpp for old renderer.
	- Jorrit added the notion of weak references to CS (experimental
	  feature, untested).  First there is a csWeakRef<T> which takes an
	  object of type T that implements at least AddRefOwner() and
	  RemoveRefOwner().  The weak reference doesn't call IncRef() on the
	  object but it will call AddRefOwner().  As soon as the object is
	  destroyed the pointer in the weak reference will be set to 0.
	- Jorrit added several macros in scf.h to assist the creation of
	  objects that support weak references (all untested).	Basically you
	  can now do in the class definition:
	      SCF_DECLARE_IBASE_WEAK (csMyClass)
	  and then in the source file:
	      SCF_IMPLEMENT_IBASE_WEAK (csMyClass)
		 SCF_IMPLEMENTS_INTERFACE ...
	      SCF_IMPLEMENT_IBASE_WEAK_END
	- Jorrit added a new csTimerEvent class (untested).  This class can
	  schedule operations to be performed later.  It is a very low overhead
	  scheduler since it will actually only check all events if needed.
	- Jorrit added csEventTimer::GetStandardTimer() convenience function.
	  This gets (or creates) the standard timer with id
	  'crystalspace.timer.standard' from the object registry.
	- Jorrit fixed SCF_IMPLEMENT_IBASE_WEAK_DECREF so that it now also adds
	  a RemoveRefOwners() function that you can use in the destructor of
	  some object to clean all ref owners.
	- Jorrit fixed some bugs in csTimerEvent so that it actually works.
	- Jorrit removed iPolygonMesh->Cleanup() and added iPolygonMesh->Lock()
	  and iPolygonMesh->Unlock() instead.  The reasoning is that cleanup
	  should not be called by the modules using iPolygonMesh because they
	  don't know if another module isn't going to need the data later.
	  Instead the new timer is used to register events that will clean up
	  the polygon mesh data later provided none of the modules is locking
	  it.
	- Jorrit reports: The thing mesh object now implements this way of
	  cleanup. Still need to do this for the other mesh objects.
	- Jorrit added the CS_POLYMESH_TRIANGLEMESH flag for iPolygonMesh which
	  indicates that the polygon mesh prefers to give a triangle mesh.
	  Added this flag to all iPolygonMesh implementations that need this.
	- Anders Stenberg added a ParseShaderParam to syntax services, and made
	  material use this to load parameters.	 Other parts of the shader
	  system should also use this, but don't right now.
	- Anders Stenberg added a bumpmapping shader, and fixed tangent and
	  binormal calculations in thing.
	- res made the following changes:
	    - Simplified tangent/binormal calculation in thing a bit. Also
	      'flipped' the binormal, seems to look more correct.
	    - Changed stencil plugin to use either an iPolygonMesh's poly or
	      triangle mesh, depending what's 'native' to the object.
	- Eric Sunshine renamed csArray<T>::Iterator::Return() to Reset() to
	  match the name Marten specified in his CVS log message when he added
	  the method (also because Reset is a more sensible name than Return).
	- res made the following changes:
	    - glshader_fixed now reports the number of available texture
	      units.
	    - Added some helper #defines to deal with CS_VATTRIB ids.
	    - Added a technique to do dot3 lighting in a single pass.
	    - Added a new 'srcalphaadd' blending mode, needed for single pass
	      dot3.
	- res & groton fixed csLight::GetDistanceForBrightness () to properly
	  work on non-CLQ attenuations for OR. Apparently, the fact that this
	  function returned 'false' caused some trouble (e.g. weird floating
	  point exceptions with VC6.)
8-Sep-2003
	- Jorrit added csgfx to the stdsteps renderloop plugin (for Jam).
	- Jorrit did the following changes to bring new and old renderer
	  branches closer together:
	    - Added back the CalculateFog stuff in iRenderView.	 This is not
	      relevant for new renderer but it doesn't hurt to have it back.
	    - Some light changes.
	    - Removed several unused NR specific variables from csSector.
	    - csAnonRenderBufferManager is now part of OR build too.
	    - Added NR specific genmesh API to OR build.
	    - Re-added Dump(g3d) to iDebugHelper.
	    - Iso engine change and fix.
	    - iVertexBufferManager added to NR build.
	    - Added csShaderBranch to OR build.
	- Jorrit improved error reporting in the renderloop loader plugin.
	- Jorrit removed un unneeded dependency on iEngine from glshader_ffp.
	- Jorrit removed lots of #ifdef CS_USE_NEW_RENDERER in the plugins
	  directory.
	- Jorrit fixed aws compile with old renderer.
	- Jorrit moved the entire renderloop stuff from
	  plugins/video/render3d/renderloop to plugins/engine/renderloop where
	  it belongs.
	- Jorrit added csPolygonMeshTools::Triangulate() and
	  csPolygonMeshTools::Polygonize().
	- Jorrit added the notion of a triangle mesh to iPolygonMesh.  Many
	  modules prefer to hand over triangle meshes instead of the clumsy
	  polygon mesh.	 Additionally many modules prefer to receive triangle
	  meshes too.  To solve that iPolygonMesh can now also support triangle
	  meshes but it is always required that the other type works too.  The
	  conversion should be transparent and is the responsibility of the
	  iPolygonMesh implementer (the new functions
	  csPolygonMeshTools::Triangulate() and
	  csPolygonMeshTools::Polygonize() can be used to assist with that).
	- Jorrit reports: Rapid collision detection plugin now uses
	  GetTriangles() to get the mesh information.
	- res removed plugins/engine/renderloop/stdsteps/lightiter.pp.	This
	  file was a leftover from some debugging times ago which must have
	  made it's way to CVS by accident.
	- Jorrit fixed the stencil shadow plugin to also use GetTriangles()
	  now.
	- Jorrit fixed mk/user.mak so that it no longer compiles glrender3d if
	  NR is not enabled.  Similarly for jam.
	- Oktal made the following changes to the perl5 plugin:
	    - Accumulation of many different updates to the Swig interface
	      files. Regenerated the Swig files.
	    - Fixed the makefile so it should now by reasonably easy to add
	      Swig code regeneration to jobber.pl. This involved moving
	      cswigpl5.inc to CS/scripts/perl5/.
	    - Commented out the Jamfile since I don't know how to make it do
	      what I want it to do.
	- Anders Stenberg added three pass PPL technique for cards with just
	  two texture units. Also inlined all FFPs.
	- Marten Svanfeldt made the following changes:
	    - Added a Reset() member to csArray<T>::Iterator to reset the
	      iterator.
	    - Added the class csRenderMeshList which is a utilityclass used by
	      the rendersteps to collect csRenderMeshes after culling and sort
	      those correctly according to renderpriority and z-order.
	    - Added correct usage of culling in the generic renderloopstep.
	      It is correct when just culling against a rview. Functions to
	      cull properly against lightvolumes and portals is still work
	      in progress.
	- Marten Svanfeldt changed GL_CLAMP into GL_CLAMP_TO_EDGE in
	  glrender3ds texturecache. They should be identical, but ATI does not
	  work as expected when using GL_CLAMP.
	- res hardcoded the texture format for cubemaps to RGB8 to fix visual
	  glitches on ATI cards.
7-Sep-2003
	- Jorrit performed a lot of changes to unify the new and old
	  renderer branches:
	    - iGraphics3D now has all functions from both new and old
	      renderer. Old renderers now implement the new functionality
	      (but empty) and new renderers now implement the old
	      functionality.
	    - iMaterial->GetShader()/SetShader() ported to new renderer.
	      Similarly for iMaterialHandle.
	    - Ported various enums and defines from new renderer to old
	      renderer.
	    - Enabled the new renderer stuff in the OpenGL statecache for the
	      old renderer too.
	    - iMaterial is now a shader branch in old renderer too.
	    - The end result of these changes is that all new renderer
	      specific plugins now compile with old renderer enabled. The
	      desired end result of my changes is that the CS_USE_NEW_RENDERER
	      flag will be removed and all plugins will automatically function
	      for both old and new renderer. We're not there yet though...
	- Andrew Craig fixed a problem in sprcal3d where it was using the old
	  renderer iLight::GetSquaredRadius() function that no longer exists.
	- Anders Stenberg added attenuation shader for PPL
6-Sep-2003
	- Jorrit fixed a compile bug in perfstat.
	- Anders Stenberg did the following changes to the new renderer:
	    - Fixed various bugs regarding texture switch reduction
	    - Made sure cubemaps honor the NOFILTER flag
	    - Worked around a problem with textures being prepared multiple
	      times.
	    - Added a new standard texture ("standardtex normalization map")
	    - Added support for setting up GL lighting with gl_fixed_vp
	    - Updated lighting shaders to support per pixel lighting (no
	      attenuation) and vertex lighting without VP
	    - Moved lighting standard variables to lightiter renderstep
	    - Removed all calls connected to vertex lighting from iGraphics3D
	    - Made sure shadermanager grabbed texture handle instead of wrapper
	      since textures added by the renderer doesn't have wrappers
	    - Changed shadow shader mixmode from add to copy. No point in
	      blending since the output is masked anyway.
5-Sep-2003
	- Jorrit changed R3D_RENDERSTATEOPTION to G3D_RENDERSTATEOPTION for the
	  new renderer.
	- Jorrit renamed GetWVMatrix() to GetObjectToCamera().	This is more
	  logical (symetrical with SetObjectToCamera()) and also more
	  compatible with old renderer.
	- Jorrit completely merged render3d.h with graph3d.h so that only
	  graph3d.h remains.
	- Peter Amstutz added more comments to the AttachCollider* methods in
	  varia/dynamics.h and changed the default softness from .316 to .01
	- Duhprey fixed the default to stepfast and coding style in odedynam.
	- Duhprey made the following changes to stencil shadows:
	    - Improved memory management with csHash<> and csArray<>
	    - Fixed robustness on animated (deforming) meshes
	    - Fixed robustness on moving meshes
	- Eric Sunshine augmented configure.ac so that it recognizes and
	  attempts to work around anomalous installations with multiple
	  versions of libiberty (one from binutils and one from gcc), in which
	  the gcc version is missing the htab_create_alloc() function required
	  by libbfd.
	- Jorrit fixed a bug in the new renderer where it would fail to
	  set the top_clipper in StartDraw(). In fact new renderer fails to
	  do anything in StartDraw().
	- Jorrit replaced iPolygonMesh->IsDeformable() with the more general
	  iPolygonMesh->GetFlags(). The following flags are supported:
		- CS_POlYMESH_CLOSED: object is closed.
		- CS_POlYMESH_NOTCLOSED: object is not closed.
		- CS_POlYMESH_CONVEX: object is convex.
		- CS_POlYMESH_NOTCONVEX: object is not convex.
		- CS_POlYMESH_DEFORMABLE: object is deformable.
	  Modules inside CS (like the shadow manager for the new renderer
	  and the visibility culler) may use these flags to optimize
	  their behaviour with respect to the model. For example, the stencil
	  shadower wants to have closed objects so if an object is not closed
	  it will have to close it itself.
	- Jorrit added <closed />, <notclosed />, <convex />, and <notconvex />
	  keywords to <polymesh> parser so that you can set the hints to be
	  used for culler, CD, and shadow manager. Note that <box> is closed
	  and convex by default so there is no need to add the hints then.
	- Jorrit also added <default /> to <polymesh> parsing so that you can
	  change the closed/convex flags for the default polymesh of
	  some object.
	- Jorrit removed CS_ENTITY_CONVEX. This flag was not used and
	  is now made obsolete by the flags in iPolygonMesh.
	- Jorrit reports: the old <convex> and <closed> keywords that you could
	  use in a mesh will now also set the equivalent CS_POlYMESH_... flags
	  in all polygon meshes associated with that mesh.
	- Jorrit added support for <closed> and <convex> to factories too.
	- Jorrit changed api mod documentation for latest polymesh change.
	- Jorrit removed CS_CULLER_HINT_CONVEX and CS_CULLER_HINT_CLOSED.
	  These are now obsolete since they are replaced by CS_POLYMESH_...
	  flags.
	- res made the following changes wrt the stencil shadow render step:
	    - Loading the shadow shader now happens upon a 'system load' event,
	      not when a render step is created. The old way was problematic,
	      as it required certain shader plugins that don't work well with
	      unopened systems (e.g. the GL shaders need the extension
	      manager.)
	    - The hashes used now take advantage of templated key types.
	    - There were circular references between csStencilShadowStep and
	      csStencilShadowCacheEntry. Now only csStencilShadowStep holds
	      csStencilShadowCacheEntry references.
	    - csStencilShadowStep::Perform() now uses a viscallback to
	      iterate over shadowing meshes.
	    - The CLOSED/NOTCLOSED flags of the shadow poly meshes are honored.
	- res made the following changes:
	    - Ditched loading of the shadow shader at system open time again.
	      It may happen that the renderstep is loaded after the open event,
	      and in this case the shader wasn't loaded. Instead, the shader
	      is now loaded when needed the first time.
	    - Added the ability to 'override' the engine's default render loop.
	      This can be done either with a config setting
	      "Engine.RenderLoop.Default" or a "-renderloop=X" command line
	      parameter. In both cases, the full VFS name must be specified.
	    - Removed "ALTERNATE_RENDERLOOP" #define from engine. Using
	      renderloops is default now.
	    - Added two renderloops in data/shader.
	    - Changed csHash<> so all 'key' parameters are now const refs.
	    - Added a 'csHashReversible<>' which is analogue to
	      csHashMapReversible. Still very primitive, tho.
4-Sep-2003
	- Peter Amstutz fixed the csPolyTexture destructor (part of
	  the thing plugin) to not try to deallocate the lightmap
	  (and thus crash) if the lightmap is actually NULL
	- Peter Amstutz added new API documentation for the
	  parameters of about 75% of the methods defined in iEngine
	- Jorrit updated the collision detection howto and also clarified
	  a Doxygen comment about the need to call ResetCollisionPairs().
	- Jorrit reverted data/shader/vertexlight.avp because with revision
	  1.8 of that file the new renderer crashes because GetBestTechnique()
	  returns 0 for some shader.
	- Jorrit fixed iso engine for latest light and material changes.
	- Jorrit merged api of new renderer iLight with old renderer iLight.
	  This means that Set/GetRadius() is now Set/GetInfluenceRadius() and
	  GetSquaredRadius() is now GetInfluenceRadiusSq().
	- Jorrit and res2k fixed data/shader/vertexlight.avp so that it now
	  compiles on at least one additional OpenGL implementation.
	- Jorrit added some extra debug code (number of rendered meshes)
	  to glrender3d.
	- Jorrit added stenciltest level to CVS. This is for the new
	  renderer.
	- res added the ATI_separate_stencil and EXT_stencil_two_side
	  extensions to the GL extension manager and made some other small
	  tweaks in the ext manager.
	- res fixed a cut'n'paste error in metaglext.xml.
	- res removed his EXT_stencil_two_side definition - there already was
	  one in metaglext.xml.
	- res added some tools to deal with 'closedness' of polygon meshes
	  (csPolyMeshTools.)
	- res changed how the stencil plugin retrieves the shadow mesh.
	  First, the shadow polygon mesh is tried. If it's present, it's used.
	  No testing for closedness is done - the shadow mesh is "trusted" to
	  be closed. Next the viscull mesh is used. A check for the 'closed'
	  flag of the mesh object will be added later. If it's set, the mesh
	  will be treated as closed. If the viscull mesh isn't present, the
	  colldet resp. base meshes are tried. If, either due the missing flag
	  or a test, the mesh is found 'unclosed', it'll be naively closed
	  (by duplicating faces & flipping their normals.)
	- res modified the Thing static data to not set the shadow poly mesh.
	- res changed r3dtest so that the viewer doesn't stare at a wall at
	  startup.
	- Jorrit started merging iGraphics3D for new and old renderer a bit.
	- Jorrit reverted the shadow mesh change from res. This is totally
	  against the spirit of how iObjectModel works. The visibility culler
	  should ONLY use the viscull polygon mesh. If not present no
	  visibility culling will happen. Similarly the shadow manager should
	  ONLY use the shadow polygon mesh. If that is not present no
	  shadow casting should happen either.
	- Jorrit removed the usage of the collision detection mesh in case
	  there is no shadow mesh (from the stencil shadower).
	- Jorrit removed the new csPolyMeshTools which was badly placed (should
	  be in csgeom instead of cstool) and which also was already there
	  under the name csPolygonMeshTools :-)
	  So I just moved the two functions in csPolyMeshTools to the
	  already exsisting csPolygonMeshTools in csgeom.
	- res made the following changes:
	    - ARB VPs can now contain a <description> token. The content of it
	      is displayed in case of a program error (or warning).
	    - ARB VP spec says that a program error string may be available
	      even if no program error occured. The error string is displayed
	      as well in this case (but it's not fatal.)
	    - Several Load() functions in the shader manager errorneously
	      returned 'false' even if no problem occured.
	    - Changed the logic to determine the shadow mesh. Now, only the
	      shadow mesh is used; if not present, no shadow is casted.
	      However, the shadow mesh is tested for closedness.
	- Duhprey commited the ode.h he forgot to commit yesterday
	- Troy fixed broken strcmp calls in stringarray.h: Find() and
	  FindCaseInsensitive().
3-Sep-2003
	- Peter Amstutz changed nullmesh to properly initialize it's
	  bounding box to a legal (albeit extremely small) value.
	- Jorrit changed the engine to create the stringset object in the
	  object registry when this is not already done by the new renderer.
	  This is also done with old renderer.
	- Jorrit made the csStringID's in csMaterial static so that not
	  every csMaterial instance has them.
	- Jorrit added csStringID names for the four texture layers so that
	  we can use the same API for iMaterial/iMaterialWrapper as the
	  new renderer uses.
	- Jorrit Removed iMaterial->GetTextureWrapper() which takes an index as
	  a parameter. Instead we now use GetTextureWrapper() which takes
	  a name. Added four names ('tex layer1'... ) to refer to the four
	  texture layers.
	- Jorrit removed csMaterial::SetTexture() with a texture handle
	  as a parameter. Materials should NEVER refer to handles directly
	  but always go through iMaterialWrapper.
	- Jorrit consequently also removed support for iMaterialHandle
	  in the shader variables.
	- Jorrit migrated csMaterial::GetTexture() to old renderer.
	- Jorrit reverted the change that shader variables don't support
	  iTextureHandle. Apparently this is needed for fog.
	- Jorrit re-introduced the notion of attenunation type to the
	  new renderer. In addition to the four standard ones there is
	  now also CS_ATTN_CLQ which is how the new renderer prefers it.
	  Also made the api more similar between new renderer and old
	  renderer. The old renderer now also supports CS_ATTN_CLQ with
	  the attenuation vector. On the new renderer, when attenuation
	  values different from CS_ATTN_CLQ are used with the new renderer,
	  the engine will still calculate the attenuation vector from that
	  so you can be sure that on the new renderer GetAttenuationVector()
	  will always work.
	- res made the following changes:
	    - Fixed shadow volume generation. The problem was that the
	      "light position" shader var wasn't properly propagated to the
	      shadow volume shader.
	    - The shadow model is now queried from the mesh object, not the
	      factory.
	    - Fixed an unitialized member of csShader.
	    - Small optimization in glshader_arb: shader var 'type casting' is
	      done when a value on the SV is set, so no need for the client
	      code to do that itself.
	    - Updated NR todo.
	- Philip Wyett updated docs to reflect a new msvc_libs release.
	- Eric Sunshine fixed a memory leak in bfdplugins.cpp where it was
	  duplicating a string before passing it to iStringArray::Push() and
	  then leaking the clone.
	- Duhprey did the following to physics:
	    - Added a per-frame callback so the input can be checked after each
	      physics frame
	    - fixed a bug with somehow deleting the line that saves created
	      systems. (weird)
	- res made the following changes:
	    - In glrender3d, the "light attenuation" SV was overwritten with
	      the "fog texture" SV, with the result that light attenuation
	      couldn't be set.
	    - glrender3d did some unnecessary Vector3->Vector4 conversions
	      in SetLightParameter ().
	    - csLight::CalculateInfluenceRadius () called SetInfluenceRadius ()
	      to set it's calculated influence radius. However, this called
	      CalculateAttenuationVector(), which in turn called
	      SetAttenuationVector(), which clears the "influence radius valid"
	      flag, causing an unnecessary recalculations of the influence
	      radius. Worse, probably due to numerical precision, the
	      attenuation vector and influence radius wasn't the same between
	      two calls of GetInfluenceRadius (), causing very visible
	      flickering.
	    - Worked a bit on the vertex light VP. It is a bit more complete
	      now - not just diffuse, but also specular lighting (tho FP
	      support for this lacks), and also honors the attenuation vector
	      now.
2-Sep-2003
	- Philip Wyett re-applied Eric Sunshine's Cygwin __argc/__argv fix in
	  win32.cpp, which was overwritten by the old version by another
	  developer.
	- Philip Wyett added CreateThread() and ExitThread() for Cygwin port,
	  as it does not have _beginthreadex() or _endthreadex().
	- Jorrit changed the new renderer iGraphics3D API as follows:
	  Removed ActivateBuffer, DeactivateBuffer, ActivateTexture, and
	  DeactivateTexture. Instead there is now SetBufferState() and
	  SetTextureState(). This has two advantages:
	    - Avoid the overhead of many virtual function calls when
	      external modules (shader manager) have to activate and
	      deactivate buffers and textures.
	    - Make it possible to do further optimizations in those
	      routines to avoid the work of deactivating if not needed.
	- Jorrit implemented the new API in the new renderer software and
	  OpenGL renderers.
	- Jorrit fixed a bug in the new renderer in relation to the
	  activation of vertex buffer. There was only one table used to
	  indicate if a vertex table was active or not but two tables
	  are needed to distinguish between conventional and extra
	  buffers (range 0 to 15 and 100+0 to 100+15).
	- Jorrit optimized the OpenGL version of SetBufferState() and
	  SetTextureState() by avoiding the deactivation of the buffers
	  if this is not needed.
	- Jorrit performed some further optimizations on
	  csShaderManager::SetupState().
	- Jorrit fixed some occurrences of Compare (changed with CompareKeys)
	  in csHash.
	- res fixed a bug in csHash<>::GetAll(). When you have a loop that
	  should iterate from n-1 to 0, it's better to decrement the loop
	  counter than to increment.
	- Eric Sunshine changed the NASM check in configure.ac so that it
	  checks for `nasmw' in addition to `nasm', since `nasmw' is the
	  program name on Windows.  Also fixed so that it no longer
	  unnecessarily and (potentially) incorrectly passes "-f elf" to nasm
	  during the test invocation.
	- Duhprey did the following to the physics loader:
	  Added softness parameter in a few places it wasn't (Thought this was
	  there already)
	  Changed behavior of mesh colliders attached to bodies so they won't
	  transform based on the mesh (the body is already transformed based on
	  the mesh so this would do the transform twice) mesh colliders
	  attached to a systme are unaffected.
	- Duhprey did the following to odedynam:
	  Added ODEDynamicsState (although tunneling prediction
	  "EnableFastObjects") not yet implemented
	  Fixed a bug where somehow the line to rotate the mesh mass correctly
	  was moved
	- res removed the <texturemapping> statement from the shadow debug
	  shader. Apparently, it caused crashes.
	- Oktal moved BFD reading and conflict checking in bfdplugins.cpp to
	  follow the standard of other implementations.
1-Sep-2003
	- Jorrit unreverted the changes from Old_Belge on the sprcal3d
	  mesh object. Unfortunatelly this means that this plugin now
	  requires the CVS version of cal3d. Version 0.9 is no longer
	  sufficient.
	- Jorrit added iTextureWrapper->IsVisitRequired() (and also
	  equivalent iMaterial->IsVisitRequired() and
	  iMaterialWrapper->IsVisitRequired()). This function will return
	  true if it is needed to call visit(). Basically this function
	  tests if the texture has a use callback. Mesh objects can use
	  this function to avoid the need to call Visit(). The Visit() function
	  comes up pretty high in profiling runs so this is not
	  insignificant.
	- Jorrit also fixed a bug in csMaterial. It was not calling Visit()
	  on the layered textures. This caused procedural textures not to
	  work if in a layer.
	- Jorrit modified the thing mesh so that it only calls Visit() on
	  materials that actually require this. This should have some
	  impact on performance since Visit() comes up pretty high in
	  profiling runs.
	- Jorrit also modified the genmesh mesh so that it only calls
	  Visit() when needed.
	- Philip Wyett removed the sprcal3d plugin from the default MSVC build.
	- Jorrit reports: After Oktal's changes to csHash, the
	  Iterator::Return() function was wrong. It would set 'element' to -1
	  which caused crashes later in the Seek() function. Fixed to start at
	  0 now.
	- Philip Wyett updated docs to reflect a new msvc_libs release.
	- Jorrit added iMeshObject->InvalidateMaterialHandles(). The idea
	  is that the engine (or another entity that manages materials)
	  will call that on all mesh objects as soon as the material handles
	  change. This can't happen at this moment but in the future this
	  could happen if, for example, the renderer changes at runtime or
	  if a material animates and gets different material handles.
	  Normally mesh objects always have to go through the material
	  wrapper and call GetMaterialHandle() ALL the time through
	  rendering. But this is a virtual function call and if you have
	  an object with a lot of materials (like a thing) this can get
	  very expensive. So now a mesh object can cache the handle and
	  it only has to call GetMaterialHandle() again when
	  InvalidateMaterialHandles() is called.
	- Changed Thing mesh so it now supports InvalidateMaterialHandles().
	- Jorrit fixed a problem in the generic renderloop plugin where
	  SCF_IMPLEMENT_IBASE was combined with
	  SCF_IMPLEMENT_EMBEDDED_IBASE_END.
	- Jorrit fixed a stupid bug he introduced with his more recent
	  changes.
	- Eric Sunshine moved getopt.h include to bottom of css.h since it
	  aliases getopt to __getopt on some platforms, which causes problems
	  for other includes (for instance, on MacOS/X, it is reported that it
	  was breaking <unistd.h> in some fashion).
	- res made the following changes:
	    - Typo fix: iVisibilityCullerListner -> iVisibilityCullerListener
	    - Added viscallback versions of the viscull methods to cull
	      against planes and spheres.
	    - Stencil shadow plugin now compiles again. However, it's still a
	      work in progress of trying to get it to work (and it looks like
	      that.)
31-Aug-2003
	- Philip Wyett changed #include "GL/glu.h" to <GL/glu.h>, in the new
	  GL renderer gl_txtcache.cpp, eliminating the warning messages within
	  the make build system.
	- Jorrit fixed an initialization error of last_visible_vistest_nr
	  with both dynavis and frustvis. With a bit of bad luck this could
	  cause culling errors.
	- Jorrit fixed another initialization error with current_visnr in
	  csSector. Please people! Don't forget to initialize variables
	  in the constructor!
	- Jorrit fixed wrong calculation of the radius of a thing which
	  could cause things to be culled wrong in some rare cases.
	- res reverted an accidential commit of msvcgen.mak and committed the
	  originally intended win32.mak.
	- Eric Sunshine changed configure.ac so that it only checks for
	  opengl32 and cousins on Windows platforms.  This will eliminate
	  problem where Wine's opengl32.so was being detected on Unix
	  platforms, thus causing an unwanted dependency between CS and Wine.
	- Eric Sunshine changed configure.ac so that it performs a reliable
	  test to distinguish between MacOS/X and Darwin.  It is still
	  possible, however, to cross-build for Darwin from MacOS/X by
	  specifying the --with-x switch.
	- Eric Sunshine changed configure.ac so that the X-windows check is
	  bypassed for MacOS/X.	 This fixes the problem where MacOS/X
	  executables and plugins would have an undesirable dependency upon
	  XFree86, if XFree86 happened to be installed on the computer.	 (The
	  --with-x flag can be used to override this behavior.)
	- Oktal added a FindContent method to csStringArray and iStringArray
	  that compares the contents of the strings instead of the char
	  pointers themselves, and FindCaseContent a case insensitive version.
	- Oktal fixed bfdplugins.cpp so it supports BFD data in .so files and
	  .csplugin files at the same time (but not for the same plugin).
	- Oktal fixed an off-by-one bug in csHash::Iterator.
	- Oktal changed csHash::DeleteAll() from void to bool.
	- Eric Sunshine made the following changes:
	    - Removed the pointless csStringArray::Find() method which did
	      pointer comparisons.  This would never succeed under normal
	      circumstances.  Ditto for iStringArray and scfStringArray.
	    - Renamed csStringArray::FindContent() and FindCaseContent() to
	      Find() and FindCaseInsensitive().	 Ditto for iStringArray and
	      scfStringArray.
	    - Fixed several memory leaks in bfdplugins.cpp where it was leaking
	      strings added to various string arrays.  (The string array Push()
	      method makes its own copy of the incoming string, so calling code
	      should not duplicate the string on the array's behalf.)
	    - Simplified some csStringArray::Push() invocations in
	      win32/loadlib.cpp.
	- Eric Sunshine eliminated compilation warning in csengine/meshobj.cpp.
	- Philip Wyett rolled back cal3d plugin to pre Steven Geens Morph
	  target changes. These changes were exclusively in the cal3d CVS only
	  and experimental whereas CS requires the stable 0.9 cal3d release.
	- Eric Sunshine modified configure.ac so that the user now has more
	  control over the CPU-specific optimizations selected by the
	  configuration script.	 Previously, by default, configuration
	  attempted to utilize the maximum optimizations possible for the host,
	  but this resulted in unportable executables and plugins (for
	  instance, the project built for an Intel 686 would not necessarily
	  work on 586 hardware).  The user could select only to enable all
	  optimizations or to disable optimizations altogether.	 Now, however,
	  the --enable-cpu-specific-optimizations option accepts "no",
	  "minimum" (or "min"), and "maximum" (or "max").  The "minimum" option
	  selects optimizations which are likely to be supported by reasonably
	  modern hardware, thus resulting in fairly portable executables.  This
	  is the default optimization setting.	The "maximum" option applies
	  the highest optimizations supported by the host platform and
	  produces the least portable executables.  Use this option only if you
	  do not care about portability.  The "no" option (same as
	  --disable-cpu-specific-optimizations) disables all CPU-specific
	  optimizations.
30-Aug-2003
	- Old_Belge added the morph target support to sprcal3d.
	- Eric Sunshine augmented configure.ac so that it emits the appropriate
	  libbfd linker flags to LIB.EXE and APPLICATION.LFLAGS.  unix.mak and
	  cssys/Jamfile are no longer responsible for inserting these flags
	  into the build process.  This fixes a problem where applications
	  built with the GNU make system failed to link because the libraries
	  were specified in the wrong order (they were listed far too early in
	  the link invocation).
	- Anders Stenberg reimplemented the PicoGUI video driver. Now it should
	  be hardware accelerated and generally cleaner. Logical operations
	  aren't supported yet though, and there are some redraw issues.
	- DeSigna fixed up an exit crasher in PGUI plugin caused by a
	  reference held past DestroyApplication.
	- Anders Stenberg reenabled pixmap drawing with csPixmap derivates in
	  the new renderer, which was disabled.
	- Philip Wyett added test for PGSERVER.AVAILABLE in user.mak, so that
	  the Pico plugin is not built unless the library is on the build box.
	  Also added test to Pico test app 'pgtest', so that if the plugin
	  associated is not built the test app will also not be built.
	- Jorrit fixed uninitialized variables in the xmlread plugin in case
	  of an xml declaration. Some of the shader xml files use this and
	  this could cause crashes with walktest (which uses xmlread) and
	  the new renderer.
	- Philip Wyett added CSTOOL to the spr3d makefile as a dependency.
	  This fixes the unresolved symbols of csAnonRenderBuffer error at
	  runtime, which prevents the spr3d plugin loading when in conjunction
	  with the new renderer.
	- Anders Stenberg fixed pico->pico internal drawing in pgserver.
	- Anders Stenberg fixed pico->pico internal drawing in pgserver
	  for real this time. Includes a very nasty, but unfortunately
	  necessary hack in the pgserver plugin.
	- res fixed a problem with library loading error reporting on Win32:
	  under certain circumstances, csPrintLibraryError() popped strings
	  from an empty string array, which triggers an assertion.
	- res augmented SCF to emit an error in case a symbol couldn't be
	  retrieved from a library.
	- Andreas Busch renamed CS_ZBUF_SPECIAL to CS_ZBUF_INVERT in python
	  and perl5 modules to match latest renderer changes.
	- res fixed the missing arguments to the SCF "symbol not found" errors.
	- res made the following changes:
	    - Added compilegroups "softcanvas" and "openglcanvas".
	    - Added a few more dependendies to walkall: aforementioned
	      softcanvas and openglcanvas and fontplex. When building with NR
	      enabled, walkall will also depend on glrender3d, the shader and
	      the renderloop plugins instead of gl3d.
	    - Fixed a cut'n'paste error in softrender3d Jamfile.
	    - The library error reporting on Win32 missed newlines.
	    - cstool/csview.cpp and cstool/keyval.cpp unnecessarily included
	      iengine/sector.h.
	    - Made the type of the key in csHash<> templated as well and added
	      support for "key handlers" which compute the actual hash of a
	      key and compare two keys. Overriding key handlers makes strings
	      as keys possible, for example.
	    - Fixed an off-by-one error in csHash<>::Iterator.
	    - Changed the shader manager to emit a warning of no shader plugin
	      was found.
	    - In NR build, the sector doesn't cache the rendermeshes any more
	      or does culling. This is the responsibility of the renderstep
	      now. Note 1: The generic RS has been updated, but is still
	      rather unoptimized. Note 2: The stencil RS hasn't been updated
	      yet.
	- res removed cssys/general/printf.cpp from the VC libcssys source
	  file list. Win32 has it's own csPrintf() etc.
	- res added support for the "SetDllDirectory()" API on Win32. It
	  provides pretty much the functionality that the PATH patching
	  already, but a bit cleaner. It is only supported by very recent
	  Windowses, tho, and if not present, PATH is still patched like
	  before.
	- Anders Stenberg fixed pico update problem by updating all the time.
	- Anders Stenberg fixed a graphics2D implementation that dropped
	  alpha when blitting.
29-Aug-2003
	- renej added support for using CS from Java. SWIG is needed since
	  no generated files are in the CVS repository. Building is done
	  with a Makefile and an And build.xml. This is not for end-users
	  right now. A simple example is included, showing the event handler
	  written in Java extending the CS iEventHandler.
	- renej updated python scripting: initial support for easy extending
	  VARG functions by means of include/ivaria/pythvarg.i
	- Anders Stenberg changed 2 occurrences of "render3d" to "graphics3d"
	- Jorrit started the work of merging the old renderer and new renderer
	  branches (basically eliminating all CS_USE_NEW_RENDERER checks).
	  This includes the following:
	      - GetRenderMeshes() is now also present in old renderer but
		it is not used. All mesh objects now have an empty stub
		implementation for GetRenderMeshes().
	      - Moved over the render loop calls in iEngine to old renderer.
	      - Similar for iSector. Also moved iSectorRenderMeshList to
		old renderer.
	      - Made sure all the render loop headers compile with old
		renderer.
	      - Moved csFog from render3d.h to common part in graph3d.h.
	      - Moved csZBufMode from render3d to common part in graph3d.h.
	      - Moved csVertexAttrib from render3d to common part in
		graph3d.h.
	      - Moved G3D_FOGMETHOD to common part of graph3d.h.
	      - Moved all new renderer specific methods in iMeshWrapper
		to old renderer branch.
	      - Bugplug spider and shadow now work.
	      - Started work on documenting the API changes for the new
		renderer that are relevant for user applications.
	- Jorrit added a docs/todo_newrenderer.txt which should contain
	  all stuff that needs to be done for new renderer (in detail).
	- Jorrit made sure that the following mesh objects now compile
	  (although they will probably not work):
	      - Beziermesh: re-enabled all the csTriangle stuff. No idea
		why that was removed and fixed some other things.
		Also changed light->GetSquaredDistance() to
		GetInfluenceRadiusSq().
	      - All particle systems now compile (except rain).
	      - Haze mesh compiles.
	      - Null mesh loader compiles although I had to put a lot of
		NR specific code in comments. Apparently the null mesh loader
		has once worked with NR. Now it will not work anymore. No
		idea how to fix.
	      - Removed some NR specific stuff from csMeshObject which wasn't
		used and appeared to be left-overs from the past. This fixes
		the rain particle system.
	      - spr2d now compiles.
	      - stars now compiles.
	      - Disabled terrfunc and terrbig from the Jam build with
		new renderer enabled. There are a bit harder to fix right.
	- Jorrit fixed the loader plugin so that it recognizes <layer> and
	  <effect> again even with new renderer enabled. Just doesn't do
	  anything at this moment.
	- Jorrit changed Jamrules so that the list of static plugins is
	  extended with the new renderer plugins if new renderer is selected.
	- Jorrit fixed a bug with thing and the new
	  renderer. FillRenderMeshes() did not properly call Prepare() which
	  caused obj_normals not to be set in case smoothing was enabled.
	- Jorrit fixed all GetRenderMeshes() calls in meshes that don't yet
	  support the new renderer so that they at least set 'num' to 0
	  correctly. That way they will work with the new renderer (but
	  don't display anything).
	- Jorrit changed the loader so that it will now automatically create
	  and load ambient.xml and light.xml if the <shader> block is missing
	  in the world file. This is to support old world files. Note that this
	  is only really a temporary hack. We have to see what happens if
	  we load multiple world files and those shaders are already loaded.
	- Jorrit changed the loader so that a material will automatically use
	  'light' as the diffuse shader and 'ambient' as the ambient shader
	  if no shaders are otherwise mentioned.
	- Jorrit reverted a call to Prepare() in FillRenderMeshes() (thing
	  mesh plugin). This breaks the thing mesh for smoothed things (with
	  new renderer enabled) but it fixes it for all the rest :-)
	- Anders Stenberg now added the csplugin, jam and makefiles for new
	  software renderer, which were forgotten last time.
	- Jorrit worked around a strange thing with new renderer and the
	  XOR pattern image that is used in case a texture is not found. It
	  turns out that GetMipMapDimensions() was not working properly then
	  because the mipmap levels of the texture were not initialized. I
	  fixed this by testing in the thing plugin for the return value
	  of GetMipMapDimensions() and if it returns false I postpone init
	  to later (like what happens with materials that are not yet
	  prepared).
	- Eric Sunshine fixed the following build-time problems with the recent
	  changes to support BFD embedding of metainfo in plugins:
	    - Fixed totally broken makefile syntax in unix.mak.
	    - Fixed broken logic in unix.mak which caused wrong files to be
	      built.
	    - Moved Unix-specific makefile goop out of general mk/cs.mak and
	      into unix.mak where it belongs.
	- DeSigna made the following changes:
	  - Modified csGraphics2D::Initialize constructor used by
	    csGraphics2D::CreateOffscreenCanvas(), as it did not correctly
	    initialize the config accessor member. The font cache, loaded by
	    G2D, relies on this accessor to get its config.
	  - pgserver uses all the accelerated CS operations again.
	    Non-functional.
	- Eric Sunshine fixed configure.ac so that it emits XFREE86VM.CFLAGS
	  to Jamconfig (it was only emitting XFREE86VM.LFLAGS).	 This allows
	  the xextf86vm plugin to build correctly with Jam on platforms where
	  the X11 headers reside in /usr/X11R6/include.
	- Eric Sunshine fixed a lot of makefiles throughout the project which
	  were incorrectly using DO.PLUGIN rather than	DO.PLUGIN.PREAMBLE,
	  CORE, POSTAMBLE.
28-Aug-2003
	- Jorrit fixed the x2d plugin so it actually reports an error if the
	  'xwin' plugin cannot be found.
	- Jorrit also fixed the reporter so that it will use 'csPrintf'
	  to report the error if there are no listeners and the severity
	  is ERROR or BUG. That way error messages sent to the reporter
	  will not get lost even if the standard reporter listener didn't
	  have a chance yet to register itself to the reporter.
	- res made the following changes:
	    - Thing is more robust (i.e. no crash) is case the renderer
	      returns a 0 super ligthmap. (As Null3d does.)
	    - The Thing LM layouter did not honor a polygons 'lighting' flag.
	      It assumed all polys were lit.
	    - Fixed a misplaced call to a cleanup function Thing, causing
	      lightmap layouts to be discarded and recalculated way too often.
	    - Null3d now adjusts texture dimensions the same way Soft3d and GL
	      do.
	    - cslight now displays a text progress meter on the console, in
	      addition to the graphical meter.
	- Anders Stenberg changed most occurrences of "Render3D" to
	  "Graphics3D", including some "r3d" that were changed to "g3d".
	  Now filenames and makefile targets should be the only remnant of the
	  stupid "render3d" naming (which was my fault, sorry for that :)
	  Also added make- & jamfiles for new software renderer.
	- Anders Stenberg fixed a bug in new renderer where aspect wasn't
	  initialized before BeginDraw in WalkTest. Solved by setting default
	  aspect and center in iGraphics3D::Open based on canvas size. Note
	  that this isn't really a good solution[TM]. The apps should call
	  SetPerspectiveAspect/Center _before_ calls to BeginDraw.
27-Aug-2003
	- Eric Sunshine fixed problem in csHash where non-friend classes
	  csHash::Iterator and GlobalIterator were accessing protected csHash
	  members.
	- Jorrit did the following changes related to the new renderer:
	    - Renamed 'crystalspace.render3d.opengl' to
	      'crystalspace.graphics3d.opengl'.
	    - Added iCamera::GetHit() again. No idea why that was disabled.
	    - Added csFog to render3d.h.
	    - Enabled the fog stuff again in iSector. Support for this has
	      to be disabled elsewhere.
	    - Walktest now compiles and 'almost' runs using the new renderer.
	    - Fixed the ball mesh plugin so that it compiles again with new
	      renderer. Not sure that the fix is right. I had to add a
	      missing parameter to CreateRenderBuffer() and I guessed that
	      the correct value should be 'false' for index.
	    - Added 'nrall' target for jam to compile all that is specific
	      for the new renderer.
	    - Added iMaterialWrapper::SetTextureWrapper() for new renderer
	      too. This will set the diffuse texture and is a convenience
	      function.
	    - Enabled iEngine->CreateBaseMaterial() again which was disabled
	      for some bizare reason. This fixes bugplug again.
	    - Fixed the ball mesh object for real. The index parameter should
	      be 'true' for the triangle buffer.
	    - Fixed spr3d jamfile so that it links with cstool.
	    - Made sure the 'shaders' keyword and others for new renderer
	      also works with old renderer but simply do nothing.
	- Jorrit added stdpt, ieplex, motion, and gtreeldr to walkall target
	  for jam.
	- res changed csStringArray::CaseSensitiveCompareKey() and
	  CaseInsensitiveCompareKey() to not treat the key parameter as a
	  pointer to a string, but a string itself.
	- Anders Stenberg made sure all loaded shaders get prepared at
	  iEngine::Prepare ()
	- Eric Sunshine made the following changes:
	    - Augmented configure.ac so that pthread check uses -pthread at
	      link time (not just compile time).  If that fails, then it will
	      manually attempt to link against libc_r.a.  This should allow
	      pthread checking and utilization to work correctly on FreeBSD.
	    - Augmented Python, OpenAL, and mikmod checks in configure.ac so
	      that they utilizes results of pthread check.  Needed for FreeBSD.
	    - Augmented OpenAL check in configure.ac so that it also consults
	      /usr/local since this is not done automatically on FreeBSD.
	    - Rewrote the SDL check in configure.ac so that it employs
	      sdl-config rather than trying manually to guess appropriate
	      build flags.  This eliminates the problem where it assumed that
	      SDL headers existed in a directory named "SDL", which was
	      incorrect for at least some installations (where the header
	      directory might be named "SDL11", for instance).
	    - Fixed bug: Unix and MacOS/X makefiles were not respecting LDFLAGS
	      passed by user to configure script.
	    - Enabled SDL canvas in Jam build (if SDL available).  Previously,
	      this was unconditionally disabled, but it works now that
	      configure emits the proper SDL build flags.
	    - Fixed compilation errors in SDL canvas.
	- Oktal moved bfdplugins.cpp from cssys/general to cssys/unix, and
	  modified cssys/Jamfile and unix.jam so that external projects making
	  use of the CS Jam build system won't have BFD storing metadata in
	  their plugins unless they specifically ask for it in their own
	  project Jamfiles.
	- Oktal added BFD metadata storage functionality to the GNU make build
	  system.
	- Oktal updated fonteng.cpp in the PicoGUI server plugin to keep up-to-
	  date with changes to the CS iFont interface.
	- res made the following changes:
	    - The DS3D plugin passed some parameters as csRef<>s. Changed to
	      just pointers.
	    - Changed the DS3D coop level to 'priority'. That's the highest in
	      DX8+ anyway, and is a bit 'nicer' than 'exclusive' for older
	      DirectXs.
	    - Thing's SLM layouting strategy has been changed; now, the
	      factory does the layouting once, and the mesh objects reuse the
	      layout.
	    - Moved SLM dumping from Thing to renderer.
	    - Enhanced bugplug's "debug command" feature; it now accepts
	      a tag as a target name as well.
	    - Changed non-PO2 resizing of the renderers: instead of blindly
	      scaling up(GL) resp. down(SW), the direction with the least
	      quality loss is guestimated and chosen. Also, both renderers
	      share that code; it's important that non-PO2 textures are resized
	      to the same dimensions on all renderers, otherwise lightmapping
	      won't work correctly across renderers.
	    - Some NR plugins still had "render3d." in their class IDs; changed
	      them to "graphics3d."
	    - Lightmaps can now be transfered to glrender3d.
	    - Typo fix in glfontcache.h.
	    - Changed csHash<>::GlobalIterator so that it's actually useable.
	    - Fixed VFS crashes: in csArchive, an array was a PDelArray<>,
	      however, items were removed from this array and inserted into
	      other arrays. The deletion of the data in the process caused
	      trouble.
	- res fixed some makefiles to allow compilation from non-source root
	  directories.
	- res fixed the glrender3d Jamfile to link against the "render3d
	  common" stuff.
26-Aug-2003
	- Philip Wyett eliminated warning suggesting adding parentheses
	  around truth value in csGLShaderFFP::LoadLayer (...);.
25-Aug-2003
	- Jorrit moved GlyphMetrics and BitmapMetrics out of iFont and
	  added 'cs' in front of them. The reason is that SWIG seems to have
	  problems with the embedded structures.
	- Eric Sunshine fixed bug in bfdplugins.cpp.  csGetPluginMetaData()
	  was leaking `buf' if errors occurred.
	- Jorrit added iBallState, iGeneralFactoryState, and iGeneralMeshState
	  to include/ivaria/cspace.i so the python plugin supports them.
	- Eric Sunshine upgraded Doxygen comments for cscmdPreProcess,
	  csProcess, cscmdPostProcess, or cscmdFinalProcess so that they
	  mention that CSMASK_FrameProcess is needed to receive these
	  pseudo-events.
	- Eric Sunshine upgraded the cal3d check in configure.ac so that it
	  checks for the very recent version required by CS.
	- Matze fixed a small bug in vfs so that it doesn't crash if vfs.cfg is
	  missing.
	- Eric Sunshine eliminated compilation warning from dynavis.cpp.
	- Eric Sunshine fixed csfgen so that it once again compiles following
	  Jorrit's change to iFont & BitmapMetrics.
	- Eric Sunshine fixed SDL check in configure.ac so that works correctly
	  for platforms on which SDL requires pthread.
	- Anders Stenberg did the following changes to the new renderer:
	    - Changed materials in to store textures in variables instead, and
	      updated to shader manager to fetch the textures as variables
	      instead of from the material directly. This allows to specify
	      textures at other scopes than the material.
	    - Updated the new renderer to give an example of the new
	      functionality by creating a "standardtex fog" fog lookup
	      texture in the shader manager scope. Note that we cannot yet
	      duplicate the old fog system though.
	    - Updated texture cache to use the CS_TEXTURE_NOMIPMAPS flag. This
	      should be done in a nicer way though.
	    - Updated texture handler to implement GetCanvas correctly for
	      textures.
	    - Removed "mtex" shader plugin and added "fixed" instead, which
	      contains a (slightly cleaned up) copy of mtex fragment program,
	      plus a fixed function vertex program. Currently it does nothing,
	      but will eventually have similar functionality as Quake 3
	      shader scripts.
	    - Updated all shaders to compy to the plugin changes.
	    - Fixed an error in the glshader_arb makefile.
	    - Made handling of mixing general and conventional attributes
	      ("attribute 3" vs "color") in shaders more safe. Note that
	      since some attribute aliasing properties are undefined in
	      the extension specification, shaders should preferably not mix.
	- Jorrit removed iPolygonTexture::RecalculateDynamicLights() and
	  DynamicLightsDirty(). They no longer need to be public as the
	  renderers no longer call them (thing calls this). This also means
	  the functions no longer have to be virtual and this is an
	  optimization.
	- Jorrit also avoided a few other virtual calls in csThing itself
	  by adding special none-virtual versions of normally virtual calls
	  (i.e. GetLightMapFast()).
	- Oktal added an overloaded SetLength() to csPDelArray which copies
	  the pointed-to object, not the pointer itsself, then converted all
	  csArray<csShaderVariable> instances in the new renderer shader
	  variable system to csPDelArray<csShaderVariable>.
	- Jorrit fixed a compile error in Oktal's latest csPDelArray change.
	- res added Jamfile and .csplugin files for glshader_fixed plugin.
24-Aug-2003
	- Luca added the CSTOOL library dependency to maya2spr makefile.
	- Luca reverted his latest commit because the cstool library is not
	  required by maya2spr.
	- Marten Svanfeldt commited a change to the cullers. Now
	  VisTest(iRenderView) takes an additional parameter, a callback to be
	  called for all visible objects. The visnr have also been made
	  internal to the culler (it is used to optimize culling). With the
	  current renderer/engine implementation this callback sets a number on
	  each mesh to be used when creating the rendering meshlist.
	- Oktal applied a patch to cssocket from Ladislav Foldyna:
	    - Adds an option called "loop" which controls whether multicast
	      packets are echoed back to the host which sent them.
	    - Adds ADD_MEMBERSHIP and DROP_MEMBERSHIP IGMP controls to the
	      sockets to make multicast work properly.
	    - Adds an overloaded function iNetworkConnection::Receive with
	      and extra output parameter, "from", which gives the packet's
	      originator's identifier, which makes multicast actually useful.
	- Marten Svanfeldt removed all traces of culling in new renderer/engine
	  for new renderer to make it compile with the above cullerchanges.
	  Note that it didn't work anyway. A new implementation is being
	  developed at the moment, but it will be a little while before it is
	  finished.
	- Oktal added stuff to the Jam build system that writes .csplugin data
	  into the headers of the plugins' shared object files themselves, on
	  platforms where configure detects libbfd and objcopy, which are both
	  parts of GNU bintools. And added code to cssys to read the .csplugin
	  data from the headers in order to locate SCF plugins.
	  This means no more ugly .csplugin files in the CS root directory on
	  most *nix systems.
	- Oktal added a couple of missing doxygen comments to hash.h and
	  make the csHash::Iterator and ::GlobalIterator copy constructors
	  public (bug found by res).
	- res made the following changes:
	    - Updated iFont to support Unicode characters. Also, glyph metrics
	      are now differentiated between glyph- and bitmap-specific
	      metrics. Glyph metrics are the same for mono and gray bitmaps,
	      but bitmap metrics aren't.
	    - Updated canvases (actually, font caches) for the iFont changes.
	    - Enhanced csfgen to output Unicode-enabled CSF fonts.
	    - Changed to built-in fonts to properly support Unicode.
	    - Enhanced the font multiplexer. Can multiplex on character level
	      and can be configured in which order fonts should asked for
	      glyphs.
	    - Added the GNOME fonts (Bitstream Vera families) and GNU Unifont
	      to the repository.
	    - Changed csHashMap::FindLargerPrime() to return the number passed
	      in if it's already a prime (and renamed the function to
	      FindNextPrime())
	    - csEvent constructs it's 'attributes' hash map a smaller size.
	      This should reduce it's memory requirements a bit.
	- res forgot to update makedep after removing the stdio aliases from
	  the Win32 port.
	- res made csHash<> a friend class of csHash<>:: Iterator and
	  GlobalIterator.
	- res fixed the GL font cache to properly display glyphs from mixed
	  font.
	- res updated csutil/hashmap.h. Oops.
	- res made the following changes:
	    - Fixed font caches to deal with font size changes.
	    - Added a FreeFont2 test to g2dtest.
	- res removed an 'unused variable' warning in the GL font cache.
	- res fixed the cssocket plugin. The recent changes added the use of
	  a IN_MULTICAST() macro. However, this macro is a WinSock2 addition.
	  Added a #definition for it (if not already present.)
22-Aug-2003
	- Oktal fixed a couple of typos in the Perl plugin, and fixed a bit of
	  const correctness in iScriptObject.
21-Aug-2003
	- Jorrit fixed a bug in the mesh-sphere intersection code (ODE). The
	  bug was that intersection with triangles used <0. But that means
	  something can slip between two triangles if you are unlucky. Fixed
	  this by using < SMALL_EPSILON instead. Also cleaned up the code a
	  lot.
	- Jorrit optimized ODE mesh-box intersection code using the polygon
	  tree.
	- Jorrit optimized ODE mesh-box and mesh-sphere by avoiding the
	  Normalize() on all polygon edges.
	- Jorrit did another optimization with ODE mesh-box and mesh-sphere
	  intersection routines.
	- Jorrit also optimized ODE mesh-cylinder and performed further
	  optimizations on the others.
	- Philip Wyett added test for PGSERVER.AVAILABLE to pgtest application
	  Jamfile.
	- Oktal removed iMaterialHandle from the list of types that can be
	  stored by csShaderVariable, and changed the way in which it stores
	  csRGBpixel (the four int members are stored as floats in csVector4.)
	- Oktal added functions to iScriptObject to retrieve the pointer from
	  an object which stores only an interface pointer.
	- Oktal reversed the inheritance override order in csSymbolTable:
	  now parent tables' symbols override the children's symbols of the
	  same name.
	- Oktal added a GetSymbols() method with no parameters to csSymbolTable
	  which returns an array containing all the symbols in the table, and
	  fixed const correctness in the class.
	- Oktal added a GetChildren() method to csSymbolTable which returns
	  a copy of the array of child tables.
20-Aug-2003
	- Jorrit moved the engine sequence manager documentation out of
	  the xml format description. Also extended that documentation with
	  recent new features. This completes the documentation about
	  the engine sequence manager.
	- Jorrit made the bugplug hit code a tiny bit more efficient.
	- Jorrit added an howto with code explaining how to select objects
	  with the mouse.
	- Eric Sunshine fixed bug in csTypedObjectIterator where pure virtual
	  method GetRequestedInterface() was called by constructor.
	- Troy in odedynam: Fixed longstanding memory leak with float arrays.
	  Altered iDynamicSystem::CreateBody to prevent extra references from
	  being created (thanks to Eric Sunshine on this one).
	- Troy in ivaria/dynamics.h added comments to iDynamicSystem
	  'AttachCollider' methods so they appear in API docs.
	- Keith fixed sprcal3d for missing iLODControl and added a better
	  error message on missing name attribute in <animation> tag.
	- DeSigna changed all instances of type unsigned in the picogui plugin
	  to uint32.
	- DeSigna changed all instances of uint32 in the picogui plugin to
	  __u32.
19-Aug-2003
	- Jorrit fixed a bug in the new optimization in odedynamics where
	  the transform of the object was ignored.
	- Eric Sunshine fixed scfSharedLibrary constructor so that it invokes
	  csPrintLibraryError() if the plugin fails to load.  This error
	  reporting was accidentally dropped with all of the recent SCF
	  implementation changes.
	- res made the following changes:
	    - Removed the unmaintained and hardly used ddraw8 canvas plugin.
	    - Updated win32/csosdefs.h to provide the LONG_PTR type on older
	      Platform SDKs.
	- Troy in odedynam set limit of geoms array to 1 for rigidbodies
	- Oktal added iterators to csHash.
18-Aug-2003
	- Jorrit fixed a bug with destruction of hierarchical factories.
	  The problem was that it was trying to remove objects from
	  structures that were already destructed.
	- Jorrit fixed a bad bug in csRefArray::Pop(). If the array was
	  the only one keeping a reference then calling Pop() would
	  destroy the object before there was a chance of putting the
	  pointer in a csRef. Solved by adding csPtr<T> Pop() to the
	  csRefArray subclass (this overrides csArray::Pop()).
	- Jorrit changed genmesh so that a SetTriangleCount() will no longer
	  destroy the old triangles but instead it will copy the old triangles
	  into the new triangle array (with corrected size).
	- Jorrit added a new csPolygonTree class (which coincidently has
	  exactly the same name as an old csPolygonTree we had in the past).
	  This will basically be a simple kdtree for polygons that I plan
	  to use to do a HUGE optimization of the ODE mesh->ball and other
	  mesh related tests.
	- Jorrit added csPolygonTree::IntersectBox() and IntersectSphere().
	- Jorrit did a huge optimization to the mesh->sphere collision
	  detection code in odedynamics plugin by using the new csPolygonTree.
	  There is still a huge memory leak (the trees are not cleaned up yet)
	  and also there is a strange error:
		ODE Message 3: LCP internal error, s <= 0 (s=0.0000e+000)
	  But otherwise things look very normal. I got a speed increase from
	  1 fps to 150 fps :-)
	- Jorrit fixed the bug with the internal ODE error. The problem was
	  duplicate polygons in the polygon tree intersection routines.
	- Matze removed the pointer sized integer types as it is very hacky and
	  unnatural to do arithmetics with pointers. (I couldn't imagine a case
	  where this would make real sense)
	- res changed winthread.cpp to use _beginthreadex() instead of
	  _beginthread(). _beginthreadex() acts a bit more like CreateHandle().
	  However, it also requires a manual CloseHandle(), which is done
	  at destruction time. Thus, threads that don't run any more should be
	  destructed as soon as possible.
	- Troy in odedynam, added DestroyGeoms() to RigidBody and
	  DynamicSystem destructors.  Allows rigidbodies to be removed from
	  system w/out crashing ODE.  Also added call to delete polytree,
	  taking care of memory leak from polytree optimization.
17-Aug-2003
	- Jorrit fixed a bug in csIntersect3::IntersectTriangle(). In
	  some cases it would fail to register a hit.
	- Eric Sunshine moved an MSVC6 specialization (added by Boyan) out of
	  csutil/array.h and into cssys/win32/csosdefs.h where it belongs.
	- Eric Sunshine fixed compilation erorr in shadervar.cpp.
	- Eric Sunshine eliminated compilation warning about unused variables
	  in glfontcache.cpp.
	- Eric Sunshine fixed glosx2d makefile and Jamfile so that the plugin
	  now links against csgeom.  This is necessary as a result of recent
	  changes (probably the recent work on the font caching machinery).
	- Troy in odedynam.cpp removed call to dGeomSetBody in
	  AttachColliderPlane to prevent 'non-placeable geom' error.
	- Eric Sunshine fixed csutil/symtable.cpp so that it compiles under
	  gcc 2.95.  Problem was that 'values.Push(s ? s->Val : 0)' was
	  considered ambiguous.	 Reported by Michael Herder.
16-Aug-2003
	- Jorrit added more features with references to parts of the
	  documentation.
	- Jorrit started some documentation about the engine sequence
	  manager.
15-Aug-2003
	- Jorrit did some documentation fixes on the new lod section.
	- Jorrit added support for <nullmesh> in factories too.
	- Jorrit fixed the lod formula for calculating m and a from d0 and
	  d1. Both in the documentation as in the code.
	- Jorrit fixed a bug in the static lod code.
	- Jorrit disabled the assembly routines in Dynavis on linux.
	  They don't appear to work (crash).
	- Troy in dynamics.h added brief comments to iRigidBody
	  AttachCollider methods to allow them to appear in API docs.
	- res improved 'detection' of what font cache has to be used for
	  software canvases.
	- res made the following changes:
	    - WriteString() now wraps WriteStringBaseline() on all canvas.
	    - The surrogate check macros in cssys/csunicode.h didn't honor
	      that characters can get wider than 16 bits.
	- Jorrit added the following commands to walktest console:
	    - varlist: list all variables currently defined in the engine and
	      their values.
	    - var: show one variable value.
	    - setvar: set a floating point value to a variable.
	    - setvarc: set a color value to a variable.
	    - setvarv: set a vector value to a variable.
	- res fixed the missing SetLimit() compile error in
	  apps/demosky/demosky.cpp.
	- res added dummies for the new LOD functions to
	  csIsoMeshFactoryWrapper.
	- res fixed compile errors on MSVC6 related to the new font caches.
	- Oktal removed iShaderVariable and moved csShaderVariable from
	  the new renderer plugin to the csgfx API, thus getting rid of
	  unneccessary virtual calls from it by making everyone access
	  them directly through csShaderVariable.
	  Then added more types for csShaderVariable to store:
	  iMaterialHandle, iTextureHandle, csVector2, csRGBpixel.
14-Aug-2003
	- Jorrit added iSharedVariableListener. With this interface you can
	  listen to a variable and get notified when its value changes.
	  Using iSharedVariable->AddListener() you can add listeners.
	- Jorrit added the ability to set LOD in iLODControl using variables
	  instead of constants.
	- Jorrit added references to other parts of the documentation for
	  most features mentioned in the feature list. That way the
	  feature list is a good starting point to find out how to do
	  something.
	- Troy altered csODERigidBody class altered to use 'spaces' instead
	  of geom groups. (geom groups are deprecated in ode now).  This
	  corrects problem with non-placeable geom error messages from debug
	  build of ode.
	- Matze fixed long standing bug in opengl renderer. It was incorrectly
	  scaling the screen rectangle for pixmaps which aren't po2.
	- Matze changed opengl texture manager to scale up instead of scaling
	  down when fixing non-po2 textures.
	- res removed the printf() & siblings aliasing from Win32 csosdefs.h.
	  Instead, csPrintf() now care about proper UTF-8 output.
	- Troy in odedynam, altered NearCallBack to set slip1 and slip2 to
	  SMALL_EPSILON.  slip1 & 2 are for simulating lateral car tire skid.
	  This inhibits this behaviour.	 Better (todo) will be to expose it
	  similar to softness.
	- Troy in physldr.cpp added softness parameter to ParseCollider &
	  ParseSystemColliderMesh.  Will add softness to remaining colliders
	  when i get tests built for them.
	- Jorrit added documentation about static lod.
	- res made the following changes wrt graphical text output:
	    - Started to work on a font cache for "software" canvases.
	    - Added anti-aliased text output to them.
	    - In general, the text writing logic has moved to the font caches.
	    - Fixed corruption of AA'ed glyphs with OpenGL canvases.
	- res replaced in wintools.cpp the usage of 'swprintf()', which
	  cygwin doesn't have, with 'wsprintfW()' from the Win32 API.
	- res fixed wintools.cpp so it compiles on VC again.
13-Aug-2003
	- res renamed the rlloader, rlsstd and rlsstencil plugins to less
	  cryptic rendloop_loader, rendstep_std and rendstep_stencil.
	  Don't forget to delete the old rl* plugin binaries.
	- Jorrit added the ability to define static lod for a hierarchical
	  mesh factory too. Using the same syntax. Using <meshref> or
	  iMeshFactoryWrapper->CreateMeshWrapper() you can create a
	  hierarchical mesh object that inherits the lod attributes
	  from the factory.
	- Jorrit added the ability to use <lodlevel> and <staticlod> for
	  factories too. Forgot that in the previous commit.
	- Jorrit added the ability to also set LOD distance with the following
	  notation:
	      <distance d0="..." d1="..." />
	  Internally this will still compute the 'm' and 'a' values. The
	  meaning of 'd0' is the distance at which lod will be 0 (lowest
	  detail possible) and 'd1' is the distance at which lod will be 1
	  (highest detail possible).
	- Matze fixed csArray::Iterator. The code was always assuming default
	  ElementHandler.
	- DeSigna made the following changes:
	    - Fixed pgserver plugin to compile ok on Linux.  There may still be
	      library problems, depending on pgserver build config.
	    - Fixed segfaulting problems at pgui plugin unloading (temp fix).
	    - Patched in changes suggested by Dentoid to increase frame update
	      speed.
	- res fixed the crash bug when using '-mode' cmdline parameter with
	  GL canvases.
12-Aug-2003
	- Jorrit fixed a compile error in the OpenGL Windows canvas after the
	  changes from res yesterday.
	- Jorrit fixed nullmesh so that the bounding box returned is actually
	  the box given to it and not calculated from the radius.
	- Jorrit fixed a bug in thing->GetPortalPolygon(). It would not
	  call Prepare() with the result that you could get crashes if
	  that function was called before the thing was ever rendered.
	- Jorrit added csArray::GetExtend(). This is the same as Get() except
	  that it will automatically grow the array if it is not big enough
	  to get the item.
	- Jorrit fixed a bug in the software renderer introduced yesterday. The
	  problem was that the DrawTriangleMesh implementation uses Get() and
	  assumed that the array would grow automatically.
	- Jorrit fixed another equivalent bug in DrawPolygonMesh for the
	  software renderer.
	- Jorrit added the <nullmesh> keyword in the parser. This is a
	  short-cut to create a null mesh. Use it like this:
	    <nullmesh>
		<min x="12.8" y="-1" z="11" />
		<max x="13.2" y="3" z="13" />
	    </nullmesh>
	  A null mesh is a mesh that is not visible. It is useful as a place
	  holder in a hierarchical mesh.
	- Jorrit completed implementation of static lod in the engine.
	  To use this you basically create a hierarchical mesh object with
	  the parent mesh using the null mesh (i.e. with 'nullmesh'). Here
	  is a pseudo-example:
		<meshobj name="lodobject">
		  <nullmesh>
		    <min x="12.8" y="-1" z="11" />
		    <max x="13.2" y="3" z="13" />
		  </nullmesh>
		  <staticlod>
		    <distance m="-.01" a=".7" />
		  </staticlod>
		  <meshobj name="lowdetail">
		    <lodlevel>0</lodlevel>
		    ...
		  </meshobj>
		  <meshobj name="mediumdetail">
		    <lodlevel>1</lodlevel>
		    ...
		  </meshobj>
		  <meshobj name="highdetail">
		    <lodlevel>2</lodlevel>
		    ...
		  </meshobj>
		</meshobj>
	  One of the important new keywords is <staticlod> which you use in the
	  parent mesh to indicate that this mesh is only going to render
	  the children that are in the right lod level. The other new
	  keyword is <lodlevel> which you use in the children to indicate
	  to which lod level they go. You can place multiple objects in the
	  same lod level. By doing that you can replace an entire forest
	  of trees with a single object.
	  The definition of the nullmesh is important. The bounding box
	  should be larger then all objects that are inside it.
	- DeSigna made SCF emit a proper diagnostic error message when
	  it cannot load a library, not just on symbol-loading
	  errors. Tested on Linux.
	- Jorrit fixed a bug in csMeshWrapper::GetSquaredDistance() (which
	  was previously in CheckImposterRelevant()). It would not calculate
	  the distance correctly as it was basing itself on a world space
	  bbox.
	- Jorrit removed unneeded SCF_QUERY_INTERFACE for iPolygonMesh
	  from odedynamics plugin.
	- res added the new fontcache.* files to the list of "common canvas
	  sources" in plugins/video/canvas/canvas.mak, fixing runtime errors
	  of GL plugins.
	- Jorrit fixed the glrender3d jamfile to also link with cstool.
	- res worked around compile problems in the fullscreen quad render
	  step.
	- Jorrit renamed iRender3D to iGraphics3D for the new renderer.
	- Jorrit removed a few ifdef's related to iRender3D vs iGraphics3D.
	- Jorrit removed all direct includes of ivideo/render3d.h. Please
	  use ivideo/graph3d.h instead. Keep in mind that ivideo/render3d.h
	  is going to be removed and merged back with igraph3d.h in the
	  (near?) future.
11-Aug-2003
	- Philip Wyett changed #include "cal3d/cal3d" to
	  #include <cal3d/cal3d.h> and dropped below other includes fixing
	  all the makedep warnings.
	- Philip Wyett removed caltocs due to lack of general support
	  and maintenance.
	- Jorrit added csGrowingArray::TransferTo().
	- Jorrit removed all usages of csStaticArray (only in thing and
	  bezier meshes). Instead they are now using csGrowingArray.
	  Also removed the actual csStaticArray class.
	- Jorrit changed csGrowingArray to inherit from csArray.
	- Jorrit changed engine to use csArray instead of csGrowingArray for
	  the render priorities.
	- Keith Fulton enabled new feature in sprcal3d.	 It now keeps the
	  iMaterialWrapper for each submesh in the model's calCoreMaterialId
	  member.  cal3d never uses these values, so it is ok.	This enables
	  the model to specify and use multiple materials (assigned
	  independently to each mesh).
	- Jorrit added csGrowingArray::GetArrayCopy().
	- Jorrit removed csIntArray and replaced the usage of it with
	  csGrowingArray<int> (in mdltool.cpp). Also fixed a big bug in
	  that code. It was taking the address of the array and after that
	  simply deleting the array.
	- Jorrit removed the usage of csBitSet in the engine for the new
	  renderer. When the number of bits is not too high (as is the case
	  for render priorities) one should simply use an array of bool
	  instead of csBitSet. This is a lot more efficient.
	- Jorrit similarly replaced csBitSet with csArray<bool> in csinput.h.
	- Jorrit removed csBitSet since nothing is now using it. If you really
	  need a bit array then use csBitArray instead.
	- Jorrit renamed csGrowingArray to csDirtyAccessArray.
	- Jorrit updated the documentation with regards to the csGrowingArray
	  change.
	- Jorrit fixed a bug in the csTypedObjectIterator class. It would
	  often return 0 in the Next() method even if there were more objects.
	- res made the following changes:
	    - Leak fixes. After the recent array changes, csStringArray
	      allocates a copy of a Push()ed string. However, in some places
	      was still code like "stringarray.Push (csStrNew (string));",
	      causing leaks.
	    - More leak fixed. After the recent changes to the event system
	      (event queue IncRef()s events), in some places code like
	      "eventqueue.Push (new csEvent ());" wasn't updated, causing
	      leaks.
	    - Fixed a bug in the UTF transformer that caused the last char to
	      be cut off.
	    - Typo fix in csunicode.h.
	    - Win32 port won't try to change the console codepage to UTF-8
	      anymore. Problem with the UTF-8 codepage is that it requires
	      a "TrueType" console font, but default is "Raster".
	    - The yellow warning boxes used to display a trailing '\n'
	      character (appearing as a small note when using csfont font
	      server.)
	    - Tweaked csSubRectangles2 a bit more.
	    - Updated documentation in reporter.h.
	    - csReport() prints "WARNING: " etc. in front of messages if
	      falling back to the console.
	    - Added a new, almost-from-scratch font cache, currently only for
	      OpenGL. Instead just putting all glyphs of a font onto a texture
	      (not that practical when fonts with a wider range of supported
	      Unicode glyphs are used), the new system is more "cache-like"
	      and dynamically adds glyph images to the texture and removes
	      the least recently used glyphs when the max. allowed space
	      doesn't suffice when a new glyph is to be added.
10-Aug-2003
	- Peter Amstutz added a check to "scan.cpp" of the software
	  renderer so that it would not defer a null pointer (and hence crash)
	  when rendering polygons that have a null lightmap.
	- Keith Fulton committed 2 more fixes to maya2spr for very simple
	  sprites.
	- Eric Sunshine made the following changes:
	    - Fixed bug: csArray::DefaultCompareKey() was comparing a void*
	      against a T (the type with which the template was instantiated).
	      Clearly, this was bogus.
	    - Fixed bug: csStringArray::FindSortedKey() was not supplying a
	      meaningful default comparison function.  It was just comparing
	      based upon the address in memory at which the string was stored.
	      Now, by default, it compares via strcmp(), though this can be
	      overriden by the caller.
	- Jorrit started work on static lod. Not functional yet.
	- Jorrit removed Section() out of the private part of csPDelArray.
	  As Eric points out, csArray::Section() is perfectly safe for
	  csPDelArray because it returns a csArray and not another
	  csPDelArray.
	- Philip Wyett changed sprcal3d plugin to link with cal3d lib and
	  not the ode lib under MSVC as it was previously.
	- Philip Wyett add sprcal3d and it's loader plugin(s), to default
	  MSVC build - required.mak.
9-Aug-2003
	- Philip Wyett moved int j out of 'for' loop within
	  csSpriteCal3DMeshObject::DetachCoreMesh () and fixed compile error.
	  Also for the second time changed instances of NULL for 0!
	- Philip Wyett changed some executable names to match their target
	  name under the make build and MSVC. Jam build did not require these
	  changes as it is correct already. 'perl5tst' is now 'perl5test' and
	  'netmntst' is now 'netmantest'. Also made these changes in CS/ root
	  .cvsignore and also added 'partedit' and 'uninst'.
	- Philip Wyett removed 'testapp', which jorrit added by accident in a
	  large recent commit.
8-Aug-2003
	- Philip Wyett changed instances of NULL for 0 in sprcal3d plugins.
	    - Added 3ds2lev and makedep to CS/ root .cvsignore.
	    - Changed instances of NULL to 0 in fullquad.cpp.
	- Jorrit added another initializer to csArray copy constructor.
	- Jorrit fixed a compile problem in csdemo that only occurs on
	  some older versions of gcc.
	- Eric Sunshine moved definition of csSkinSlice above csSkin in
	  csskin.h so that csSkinSlice in known before it is used in template
	  instantiation.
	- Jorrit greatly simplified iLODControl. Removed all functions
	  that were not used anyway. Changed SetLOD() to set a distance
	  based function.
	- Jorrit also modified the loader to accept new <distance> keyword.
	  So you can now say in a mesh object:
	      <lod>
		  <distance m="-.025" a="1"/>
	      </lod>
	  The 'm' and 'a' values are used in the function:
		lod = m*distance+a
	  The result is capped to [0,1]. 0 is worst quality, 1 is best.
	  So in this case it means that if the object is (for example)
	  10 units away then lod will be equal to 1.25 (or 1 capped which
	  means highest quality). If the object is 30 units away then lod will
	  be equal to 0.25.
	- Jorrit changed the 3D sprite plugin to actually support these lod
	  settings now. So it is now possible to control lod for a sprite
	  based on distance. This is not very flexible yet. In future a lod
	  manager will be added for increased flexibility (i.e. basing lod
	  levels on hardware capabilities and desired speed).
	- Keith Fulton added cal3d submesh attach and detach to viewmesh.
	  Enhanced sprcal3d object and factory to enumerate submeshes,
	  name them, attach certain ones by default on instance creation,
	  and update CS render objects as they are created and deleted.
	- Keith Fulton added csMenu->GetCheck() to allow the calling
	  application to determine what menu items are currently checked
	  and not checked.
	- Eric Sunshine resolved circular forward-reference problems between
	  awsListRow and awsListRowVector which arose following migration to
	  csArray<>.
	- Jorrit changed csStringArray<char*,...> to
	  csStringArray<const char*,...>.
	- Jorrit made copy constructor, assignment operator and Section()
	  in csPDelArray private so that people cannot mistakenly use those.
	- res further worked on NR materials & shader variables. Changes
	  include:
	    - Creation of material handles from texture handles fixed.
	    - Added a generic implementation for iShaderBranch.
	    - Enhanced the default shader variable implementation so "casting"
	      takes place. E.g. you can set the value as a single float, but
	      requesting a Vector3 will work (in this case, all components
	      have the same value.)
7-Aug-2003
	- Jorrit did the following array related changes:
	    - Added Put() to csArray.
	    - Added a protected csArray::InitRegion(). This function will
	      re-initialize a region in the array WITHOUT properly destructing
	      the previous contents! This is needed by some subclasses (like
	      csPDelArray) in order to implement GetAndClear() and Extract().
	    - csArray now has a second template argument to specify an
	      ElementHandler. That way you can use csArray with specialized
	      item constructors and destructors. By default csArray will
	      still work as before.
	    - Made csPDelArray a subclass of csArray using a specialized
	      element handler.
	    - Re-implemented csRefArray as a subclass of csArray. Instead of
	      being defined as csArray<csRef<T> > it is now defined as
	      csArray<T*, csRefArrayElementHandler<T*> >. The element handler
	      will now do IncRef() and DecRef(). This is more efficient
	      then letting csRef do it as csRef does some additional and
	      unneeded tests.
	- Jorrit changed csRef<iImage> to iImage* in the arguments to
	  iImageVector. Additionally changed the csRef<iImage>& return
	  to csRef<iImage>.
	- Keith added some new enhancements to the cal3d wrapper and viewer.
	  viewmesh now divides cal3d animations by looping and non-looping
	  types, and dynamically updates the list of animations to remove
	  from the blend set.
	- Jorrit also changed csStringArray to inherit from csArray by
	  using csArray<char*, csStringArrayElementHandler> as superclass.
	  There is one problem which I couldn't solve yet. For some reason,
	  functions like Put and Push don't accept const char* pointers.
	  So you have to cast to (char*) to use Put and Push. Solutions
	  to this would be welcome. I don't understand why it doesn't work
	  as csArray::Push() is declared as follows:
		int Push (T const& what)
	  with T equal to char*. Sidenote: changing the Push() to this:
		int Push (const T& what)
	  didn't help.
	- Jorrit merged csArrayBase with csArray so that only csArray
	  remains.
	- Jorrit fixed a compile error in viewmesh with the array changes.
	- Jorrit fixed a compile error in freefnt2 with the array changes.
	- Fixed a bad bug in the copy constructor of csArray. It would not
	  initialize capacity to 0 which could cause very bad results
	  and crashes in CS.
	- res started to change NR materials to store parameters (e.g. diffuse
	  value) in shader variables.
6-Aug-2003
	- Jorrit fixed a compile error in freefnt2 font server related to the
	  csRefArray->csArray change.
	- Eric Sunshine patched mk/install.mak to ensure that the `uninst'
	  object file directory exists at "make install" time.
	- res updated the new renderer to respect the recent array changes.
5-Aug-2003
	- Jorrit fixed metaball.mak. Was missing a CSUTIL dependency after
	  CSSYS.
	- Jorrit fixed makefiles for GIF and PNG image loaders.
	- Jorrit fixed makefile for BMP image loader.
	- Boyan fixed errors in broadcasting in iNetworkSocket2.
	- Jorrit made the following array change: There is now an element
	  handler defined for every array class (csArray, csPDelArray,
	  csRefArray, and csStringArray). This element handler contains
	  three static functions, one to create elements, one to destroy
	  elements, and one to initialize a new region of memory.
	  csArrayBase is given an additional parameter in the template
	  section to indicate this element class and will use that to create
	  and destroy elements. By doing this I managed to move the following
	  functions to csArrayBase:
	      - DeleteAll()
	      - Truncate()
	      - Empty()
	      - SetLength()
	      - TransferTo()
	      - SetCapacity()
	      - ShrinkBestFit()
	      - DeleteIndex()
	      - DeleteRange()
	      - Delete()
	  Thusly a lot of duplicate code got removed. I plan to move a lot
	  more to csArrayBase so that the sub-classes of csArrayBase will
	  contain only the really different functionality.
	- Keith Fulton added support for animation action wrappers in cal3d
	  plugin and augmented viewmesh to allow user to set/clear/blend
	  both anim cycles and anim actions.  With a nicer GUI, viewmesh
	  would now come close to duplicating the functionality of the
	  "official" cal3d cally demo.
	- Jorrit did more array changes:
	    - Moved code of copy constructors to csArrayBase. Needed to
	      complete the 'Construct' methods for all element handlers.
	    - Added various assignment operators using the same new code.
	    - Moved destructor (DeleteAll() call) to csArrayBase.
	- Jorrit optimized csRefArray considerably. Still slower than
	  csArray<csRef<T> > though so we will probably ditch csRefArray
	  in favor of the latter. Most likely csRefArray will remain as
	  a subclass of csArray<csRef<T> > in order to provide a more efficient
	  Push(T*) that avoids the extra IncRef() that happens with
	  csArray<csRef<T> >.
	- Jorrit made csRefArray a subclass of csArray (using
	  csArray<csRef<T> >). This greatly cleans up a lot of code and
	  also improves speed.
	- res further worked on the Jam msvcgen. Now, metadata is added to the
	  generated .rc file as well.
	- res worked around the makedep compile problems on MinGW: in case a
	  "CS_NO_STDIO_REPLACEMENTS" macro is defined, Win32 csosdefs.h won't
	  so the stdio aliasing alias.
	- res updated some comments in the bindoc plugin and removed some
	  leftover debug stuff.
	- res added <cs-config> tags around the UPCASE make macro(or how is
	  it called?)
	- res made the following changes:
	    - Removed some leftover super LM code from the old GL renderer.
	    - In the Thing SLM stuff some arrays of structs were replaced
	      with arrays of pointers to resp. structs to avoid some
	      unnecessary copying of data.
	    - Fixed some problems in csSubRectangles2 rectangle allocation
	      that caused problems when reclaiming allocated rectangle
	      space.
	    - Added a small debug aid to csBlockAllocator: a #define at
	      compile time causes freed objects to be overwritten with a
	      certain byte value.
4-Aug-2003
	- Oktal added the following to csutil:
	    - A template class, csHash<T>, intended to replace csHashMap soon.
	      It is 1 to 3 times faster than csHashMap, depending on the data.
	      It currently lacks an iterator companion class, but that will be
	      easy to add, and the GetAll() function provides much of that
	      functionality already.
	    - A csTree<T> class, which is a binary tree.
	    - In csArray, csPDelArray and csRefArray, added default sorting
	      callbacks DefaultCompare, DefaultCompareKey and DefaultSort.
	- Anders Stenberg changed pico plugin to use pico's internal
	  framebuffer drawing. Now pico handles all drawing (to a
	  memory framebuffer), and CS just relays this to the real
	  framebuffer. This means we get perfect(?) output, although no
	  acceleration from CS. This could/should be upgraded later.
	- Philip Wyett added sprcal3d and it's loader to 'user.mak'. Also
	  made both these and the jam builds test for 'HAS_CAL3D' to
	  ensure that they are only compiled on systems where configure
	  has detected libcal3d etc.
	    - Added newline to end of 'plugins/csparser/prstex.cpp'.
	    - Added 'ODE.AVAILABLE' test to physics loader plugin jamfile.
	      This brings it into line with make build. There is no need for
	      it's loader, if the odedynam plugin isn't being built.
	    - Manually updated cs_pyth.cpp and cspace.py after recent
	      changes.
	- Jorrit added a new csArrayBase<T> class. This class will handle
	  (when it is fully ready) all common tasks of all array classes
	  (csArray, csPDelArray, csRefArray, csGrowingArray, csStringArray,
	  ...). Currently only a few common tasks are handled and only
	  csArray and csPDelArray inherit from csArrayBase.
	  Inheritance of csArrayBase is private so that subclasses of
	  csArray and others cannot get access to the protected members.
	  In order to let users of csArray and others access the public
	  members of csArrayBase the C++ 'using' keyword is used to transfer
	  some of the public members as public members of the array classes.
	  Work in progress...
	- Jorrit did the following array related changes:
	    - csRefArray now also inherits from csArrayBase.
	    - Moved Find() to csArrayBase.
	    - Added Truncate() to csRefArray and csPDelArray.
	    - csStringArray now also inherits from csArrayBase.
	- Jorrit removed the recently added DefaultSortCompare() from csArray.
	  The default implementation provided there made no sense (i.e.
	  casting the offset in the array to integer
	  will do exactly nothing) and there is no other sensible default
	  sorting that can be used for csArray in general.
	- Jorrit also removed DefaultSortCompare() for csPDelArray. Doesn't
	  make sense to sort pointers.
	- Jorrit also removed DefaultCompare() and DefaultCompareKey for
	  csPDelArray. Doesn't make sense to compare pointers.
	- Jorrit removed all DefaultCompare() functions from csRefArray.
	  Doesn't make sense to compare pointers.
	- Jorrit moved Sort() implementations to csArrayBase. Only
	  csRefArray has its own implementation.
	- Jorrit added csArray::Empty() to csRefArray, csPDelArray, and
	  csStringArray.
	- Jorrit moved const Get() and [] operator implementations to
	  csArrayBase.
	- Eric Sunshine reverted Paul Garceau's CS_WCHAR_T_SIZE-related hack
	  to csunicode.h which was addressing the symptom rather than the
	  cause.  We need to determine the actual problem (if there is one),
	  and instead address that.
3-Aug-2003
	- Paul G. implemented a very nasty (and hopefully very temporary) hack
	  for csunicode.h to define CS_WCHAR_T_SIZE appropriately for
	  Win32/COMP_GCC platform (Mingw).
	- Jorrit removed iAwsParmList->AddBasicVector() and GetBasicVector().
	  These functions were not used in CS and I think they are not safe
	  (i.e. should use SCF parameter and not csBasicVector). And
	  csBasicVector is being removed.
	- Jorrit replaced pointer to sink inside SinkMap (for awsSinkManager)
	  with a csRef to do proper ref counting.
	- Jorrit replaced pointer to slot inside SinkSignalMap (for
	  awsSinkManager) with a csRef to do proper ref counting.
	- Jorrit replaced pointer to sink inside SignalTriggerMap (for
	  awsSinkManager) with a csRef to do proper ref counting.
	- Jorrit replaced various occurrences of csBasicVector:
	    - Replaced 'awsParmsList' in aws with a csPDelArray<parmItem>.
	    - Replaced 'transitions' in awsManager with a
	      csArray<awsWindowTransition*>.
	    - Replaced 'hotspots' in awsListBox with a
	      csPDelArray<awsListHotSpot>.
	    - Replaced 'constants' in awsPrefManager with a
	      csPDelArray<constant_entry>.
	    - Replaced 'actions' in awsActionDispatcher with a
	      csArray<awsActionMap*>.
	    - Replaced 'sinks' in awsSinkManager with a csPDelArray<SinkMak>.
	    - Replaced 'triggers' in awsSinkManager with a
	      csPDelArray<TriggerMap>.
	    - Replaced 'slots' in awsSinkManager with a
	      csPDelArray<SlotSignalMap>.
	    - Replaced 'stmap' in awsSinkManager with a
	      csPDelArray<SignalTriggerMap>.
	    - Replaced 'textures' in awsTextureManager with a
	      csPDelArray<awsTexture>.
	    - Replaced 'lights' in csIsoGrid with a csRefArray<iIsoLight>.
	    - Replaced 'dynamiclights' in csIsoGrid with a
	      csRefArray<iIsoLight>.
	    - Replaced 'Edges' in Cloth with a csPDelArray<Constraint>.
	    - Replaced 'fields' in Cloth with a csPDelArray<Constraint>.
	    - Replaced 'Shear_Neighbours' in Cloth with a
	      csPDelArray<Constraint>.
	    - Replaced 'shear_fields' in Cloth with a csPDelArray<Constraint>.
	- Jorrit fixed a bug in awsSinkManager::RemoveSink(). That function
	  was trying to find an iAwsSink inside the sinks basic vector but
	  that vector only contains SinkMap instances.
	- Jorrit replaced csRGBVector with csArray<csRGBcolor>.
	- Jorrit replaced awsListRowVector with csPDelArray<awsListRow>.
	- Jorrit removed all includes from csvector.h from all CS sources.
	- Jorrit added csArray::Sort().
	- Jorrit finally removed csVector and csBasicVector.
	- Jorrit replaced a lot of 'if (bla) delete bla' with 'delete bla'.
	  C++ guarantees that 'delete' will check on null pointer so there is
	  no need to add another test.
	- Luca replaced some call to Delete (int) (which no longer exists)
	  with DeleteIndex (int) in the source code of the csSoundRenderDS3D
	  class.
	- Eric Sunshine fixed compilation problems with partedit on MacOS/X.
	- Anders Stenberg & Oktal did various changes and fixes to the pico
	  plugin. It still shouldn't and can't be used, since it pretty much
	  doesn't work at all. Something resembling almost sensible output
	  should now be possible to achieve though.
	- Anders Stenberg added better pixel format handling in csGraphics3D,
	  since it was needed for the abuse pgserver puts it through.
	- Paul G. modified Win32 platform macro definitions to be more
	  readable without changing macro functionality.
	    - CS_IMPLEMENT_PLATFORM_APPLICATION
	    - CS_IMPLEMENT_PLATFORM_PLUGIN
2-Aug-2003
	- Jorrit renamed csPDelArray::Delete(int) to DeleteIndex() to conform
	  more to the API used by csArray.
	- Jorrit renamed csRefArray::Delete(int) to DeleteIndex() to conform
	  more to the API used by csArray.
	- Jorrit renamed csStringArray::Delete(int) to DeleteIndex() to conform
	  more to the API used by csArray.
	- Jorrit renamed csGrowingArray::Delete(int) to DeleteIndex() to
	  conform more to the API used by csArray.
	- Jorrit modified the api documentation to reflect the pending removal
	  of csVector and csBasicVector. Also explained how to do most common
	  transitions.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'csLoadedPluginVector' in the isometric loader with
	      a csPDelArray<csLoaderPluginRec>.
	    - Replaced 'animVector' in spr2d with a
	      csArray<csSprite2DUVAnimation*>.
	    - Replaced 'frameVector' in spr2d with a
	      csArray<csSprite2DUVAnimationFrame*>.
	    - Commented out 'pal_colors' in terrbig because it is not used.
	    - Replaced 'polygons' in thing with a csArray<csPolygon3D*>.
	    - Replaced 'static_polygons' in thing with a
	      csArray<csPolygon3DStatic*>.
	    - Replaced 'soVector' in arts renderer with a
	      csPDelArray<csArtsHandle>.
	    - Replaced 'ActiveSources' in eax renderer with a
	      csArray<csSoundSourceEAX*>.
	    - Replaced 'SoundHandles' in eax renderer with a
	      csArray<csSoundHandleEAX*>.
	    - Replaced 'Sources' in sound software renderer with a
	      csArray<csSoundSourceSoftware*>.
	    - Replaced 'SoundHandles' in sound software renderer with a
	      csArray<csSoundHandleSoftware*>.
	    - Replaced 'GLGlyphVector' in OpenGL canvases with a
	      csPDelArray<GLGlyphSet>.
	    - Replaced 'vStream' in csavi plugin with csRefArray<iStream>.
	    - Replaced 'StreamIdx' in csavi plugin with csArray<indexentry*>.
	    - Replaced 'StreamList' in csavi plugin with
	      csPDelArray<StreamIdx>.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'scfLibraryVector' in scf with
	      csPDelArray<scfSharedLibrary>.
	    - Replaced 'scfClassRegistry' in scf with csPDelArray<scfFactory>.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'csHintManager' in csws with csArray<void*>.
	    - Replaced 'csAccVector' in csws with csPDelArray<csAccElement>.
	    - Replaced 'sequences' in csdemo with csPDelArray<NamedSequence>.
	    - Replaced 'paths' in csdemo with csPDelArray<csNamedPath>.
	    - Replaced 'pathForMesh' in csdemo with csPDelArray<PathForMesh>.
	    - Replaced 'meshRotation' in csdemo with csPDelArray<MeshRotation>.
	    - Replaced 'engine_views' in cswseng with csArray<ceEngineView*>.
	    - Replaced the CS_DECLARE_TYPED_VECTOR define in map2cs so that
	      it now uses csArray<T> instead of csVector.
	    - Replaced 'generic' in md32spr with csArray<md3Model*>.
	    - Replaced 'csTokenVector' in cs2xml with csPDelArray<csTokenDesc>.
	    - Replaced 'things' in levtool with csPDelArray<ltThing>.
	    - Replaced 'thing_nodes' in levtool with
	      csPDelArray<ltDocNodeWrap>.
	    - Replaced 'planes' in levtool with csPDelArray<ltPlane>.
	    - Replaced 'thing_plugins' in levtool with csPDelArray<csString>.
	    - Replaced 'plane_plugins' in levtool with csPDelArray<csString>.
	    - Replaced 'csRecordVector' in walktest with
	      csPDelArray<csRecordedCamera>.
	    - Replaced 'busy_entities' in walktest with csArray<csWalkEntity*>.
	    - Replaced 'busy_vector' in walktest with csArray<csWalkEntity*>.
	- Jorrit replaced various occurrences of csBasicVector:
	    - Replaced 'texlayers' in csShaderGLMTEX with csArray<mtexlayer*>.
	    - Replaced 'techniques' in csShader with
	      csArray<iShaderTechnique*>.
	    - Removed unused 'pluginlist' in
	      csGLRender3D::eiShaderRenderInterface.
	    - Replaced 'vertex_constants' in csOpenGlEffectPassData with
	      csPDelArray<csOpenGlVPConstant>.
	    - Replaced 'variables' in csEffectDefinition with
	      csArray<efvariable*>.
	- Jorrit Completely removed iEffectDefinition->GetAllVariableNames()
	  since it can not work because it returns private data that
	  the caller is not able to interprete. It wasn't used anyway.
	- Jorrit marked several places in the new renderer (around the
	  vectors that were replaced) with @@@ to indicated bad memory
	  management (possible memory leaks). Please investigate.
1-Aug-2003
	- Jorrit changed csPDelArray::Sort() to use a new
	  csArraySortCompareFunction typedef instead of csArrayCompareFunction.
	  The reason is to avoid confusion.  csArrayCompareFunction is given
	  pointers to the objects themselves (pointers) while the
	  csArraySortCompareFunction is given pointers to pointers to the
	  objects (i.e. pointers inside the array to sort).
	- Jorrit extended csArray::InsertSorted() with 'equal_index' parameter
	  like was done yesterday with csPDelArray.
	- Jorrit renamed csArraySortCompareFunction to
	  csPDelArraySortCompareFunction and csArrayCompareFunction to
	  csPDelArrayCompareFunction.  Also added csArrayCompareFunction which
	  is specific to csArray.  So csArray no longer has to include
	  "parray.h".
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'csPluginList' for csPluginLoader with a
	      csPDelArray<csPluginLoadRec>.
	    - Replaced 'csPluginsVector' in csPluginManager with a
	      csPDelArray<csPlugin>.
	    - Replaced 'csGridRow' in csSparseGrid with a
	      csPDelArray<csGridRowEntry>.
	    - csRegionTree2D::FindRegion() now uses csArray instead of
	      csVector.
	- Jorrit added csPDelArray::FindKey().
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'csConstraintVector' for csws layouts with a
	      csPDelArray<csLayoutConstraint>.
	    - csSkin now inherits from csPDelArray<csSkinSlice> instead of
	      csVector.
	    - Replaced 'csWSTexVector' for csws with a
	      csPDelArray<csWSTexture>.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'TabVector' in awsTabCtrl with a csPDelArray<awsTab>.
	    - Replaced 'awsComponentVector' in awscomp.h with a
	      csArray<iAwsComponent*>.
	    - Replaced 'eventVector' in awsMultiLineEdit with a
	      csPDelArray<mlEvent>.
	    - Replaced 'TabVector' in awsNotebookButtonBar with a
	      csPDelArray<tabEntry>.
	    - Replaced 'csFontDefVector' in csFreeType2Font with a
	      csPDelArray<GlyphSet>.
	    - Replaced 'csFontVector' in csFreeType2Server with a
	      csRefArray<csFreeType2Font>.
	- Jorrit added csRefArray::FindKey().
	- Jorrit made the typedefs for compare and compare key functions
	  for csPDelArray and csArray local to the class. That way they
	  can use the correct type instead of just void*. This was already
	  done by csRefArray and cleans up the API considerably.
	- Jorrit added csArray::FindKey().
	- Eric Sunshine made the following changes:
	    - Overhauled the wchar_t checking and configuration since it was
	      quite broken on MacOS/X.	Now checks for presence of <wchar.h>,
	      wchar_t, and wcslen(); and fakes up missing items as necessary.
	    - Removed unportable `#include <wchar.h>' from csutil/util.cpp.
	    - Replaced usage of csVector with csArray in OSXDynamicLibrary.cpp.
	- Eric Sunshine elminated bogus `inline' from DEL2D_FUNC() macro in
	  common/OSXDelegate2D.h, OSXDelegate2D_CGBlit.h, and
	  OSXDelegate2D_OpenGL.h which prompted compilation warning.
	- Eric Sunshine eliminated compilation warnings from old OpenGL
	  renderer regarding invalid conversion from int* to GLint*.
	- res added CS_USE_FAKE_WCHAR_TYPE to the list of predefined Doxygen
	  macro names so the documentation for csUnicodeTransform is correct
	  again.
	- res updated the example in the csWtoC documentation.
	- Eric Sunshine altered the behavior of OSXDelegate so that it no
	  longer forcibly sets itself as the NSApplication's delegate.
	  Instead, it now registers manually to receive the notifications in
	  which it is interested.  This makes OSXDelegate friendlier to
	  projects which need to use their own NSApplication delegate.	(The
	  next step is to figure out how to alter OSXDelegate so that it no
	  longer requires a custom NSApplication subclass.  Eliminating this
	  requirement will make it much more friendly to external OSX-specific
	  projects.)
	- Keith Fulton added a new sprcal3d plugin, with a sprcal3dldr plugin
	  to load them.	 Functionality is only partially implemented, but
	  cal3d models are loadable and viewable in viewmesh at least.
31-Jul-2003
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'vTex' in OpenGL texture manager with
	      csArray<csTextureOpenGL*>.
	    - Replaced 'vClients' in csVertexBufferManager with
	      csArray<iVertexBufferManagerClient*>.
	- Jorrit removed csArrayCompareKeyFunction. It is not needed
	  and the same as csArrayCompareFunction.
	- Jorrit added csPDelArray::Sort().
	- Jorrit extended csPDelArray::InsertSorted() with an optional
	  equal_index parameter. This integer will be set to the index
	  of a possible duplicate value (or -1 if none). This is similar
	  to csVector::InsertSorted().
	- Jorrit replaced various occurrences of csVector:
	    - Replaced VfsVector in csVFS with a csPDelArray<VfsNode>.
	    - Replaced ArchiveEntryVector in csArchive with a
	      csPDelArray<ArchiveEntry>.
	- Oktal changed iEventQueue::Post() and iEventOutlet::Post() so they
	  always IncRef() the iEvent they are passed. This means that after
	  calling Post(), the iEvent's reference count will be 2, so the
	  caller must DecRef() the iEvent (give up their reference).
30-Jul-2003
	- Anders Stenberg brought the variable system for the new renderer
	  back up and running, now using Oktal's symbol table which should
	  make variable lookups a lot faster.
	- Anders Stenberg added two new render steps. "target" and
	  "fullscreenquad". (Apparantly I somehow failed to add them
	  last time I claimed to do so.)
	- Jorrit replaced the 'flags' vector in ParsePortal (syntax services)
	  with a uint32 flags.
	- Jorrit replaced the return vector of iImageIO->GetDescription()
	  with an csArray (typedef csImageIOFileFormatDescriptions). Changed
	  all image loading plugins accordingly.
	- Jorrit replaced the basic vector return in
	  iAwsKeyContainer::Children() with a const csRefArray<iAwsKey>.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced TabOrder in awsComponent with csArray<iAwsComponent*>.
	    - Replaced vClipped in awsMultiLineEdit with
	      csPDelArray<csString>.
	    - Replaced vText in awsMultiLineEdit with csPDelArray<csString>.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'visobj_vector' in Dynavis with
	      csPDelArray<csVisibilityObjectWrapper>.
	    - Replaced 'vector' in csDynVisObjIt with
	      csArray<iVisibilityObject*>.
	    - Replaced 'vistest_objects' in Dynavis with
	      csArray<iVisibilityObject*>.
	    - Replaced 'visobj_vector' in Frustvis with
	      csPDelArray<csFrustVisObjectWrapper>.
	    - Replaced 'vector' in csFrustVisObjIt with
	      csArray<iVisibilityObject*>.
	    - Replaced 'vistest_objects' in Frustvis with
	      csArray<iVisibilityObject*>.
	    - Replaced 'DeleteCallbacks' in csfont with
	      csRefArray<iFontDeleteNotify>.
	    - Replaced 'DeleteCallbacks' in freefnt2 with
	      csRefArray<iFontDeleteNotify>.
	    - Replaced 'fontservers' in fontplex with csRefArray<iFontServer>.
	    - Replaced 'layers' in haze with csPDelArray<csHazeLayer>.
	    - Replaced 'particles' in csParticleSystem with
	      csRefArray<iParticle>.
	- res removed csVector from the Win32 WaveOut plugin.
	- Jorrit replaced various occurrences of csVector:
	    - Replaced 'frames' in csSpriteAction2 with
	      csArray<csSpriteFrame*>.
	    - Replaced 'delays' in csSpriteAction2 with csArray<int>.
	    - Replaced 'displacements' in csSpriteAction2 with csArray<float>.
	    - Replaced 'frames' in csSprite3DMeshObjectFactory with
	      csPDelArray<csSpriteFrame>.
	    - Replaced 'actions' in csSprite3DMeshObjectFactory with
	      csPDelArray<csSpriteAction2>.
	    - Replaced 'sockets' in csSprite3DMeshObjectFactory with
	      csPDelArray<csSpriteSocket>.
	    - Replaced 'polytxts' in csLightingPolyTexQueue with
	      csArray<csPolyTexture*>.
	    - Replaced 'sector_cb_vector' in csPortal with
	      csRefArray<iPortalCallback*>.
	    - Replaced 'portal_cb_vector' in csPortal with
	      csRefArray<iPortalCallback*>.
	    - Replaced 'framevec' in perfstat with csPDelArray<FrameEntry>.
	    - Replaced 'statvec' in perfstat with csPDelArray<StatEntry>.
	- res improved the doxygen documentation of the UTF converters.
	- res fixed a "assuming & on overloaded member function" error on
	  older GCCs.
	- Oktal made the following changes to csSymbolTable:
	    - Made it use iBase* instead of void* for symbol values, so it
	      now does reference counting.
	    - Reorganised it in order to get rid of an unneccessary hash
	      retrieve call (some speed-up in AddSymbol and DeleteSymbol).
29-Jul-2003
	- Jorrit made scfStringArray actually work by adding the needed
	  SCF_CONSTRUCT stuff.
	- Jorrit changed csFindSystemRoots() to return iStringArray instead
	  of iStrVector.
	- Jorrit changed iVFS->FindFiles() and MountRoot() to return
	  iStringArray.
	- Jorrit removed all other usages of csStrVector (viewmesh, demo,
	  iAwsParmList, win32/loadlib.cpp, csws cspFileDialog, input console,
	  and OpenGL renderer).
	  In case of iAwsParmList the csStrVector was also
	  replaced with the more correct iStringArray (i.e. SCF interface).
	- Jorrit removed all other usages of iStrVector and scfStrVector
	  (csScanPluginsDir and related, iSCF (QueryClassList)).
	- Jorrit finally removed csStrVector, iStrVector, and scfStrVector.
	- Jorrit also fixed the python plugin for all latest changes.
	- Jorrit renamed FindSortedKey to FindSorted in csStringArray
	  and iStringArray.
	- Jorrit performed the next bunch of csVector removal:
	    - Replaced csEventQueue::EventOutlets with
	      csArray<csEventOutlet*>.
	    - Replaced csEventQueue::EventCords with csRefArray<csEventCord>.
	- res added some utility functions to convert between UTF encodings.
	- res changed the Win32 port to assume UTF8 strings for console output
	  and window titles and such.
	- res fixed a bug where WGL extensions weren't always initialized
	  properly.
	- res removed the unused DirectInput keyboard handling code.
	- res augmented configure to check the sizeof(long). This is used
	  to determine whether the platform is a 32 or 64 bit environment.
	- res added types to cstypes.h which are (un)signed integers with the
	  same size as a pointer. They are intended in existing cases where
	  pointers are casted to ints/longs (it appears that long on 64-bit
	  MSVC is still 32 bits large, so it can't be used. Tho I'm not sure.)
	- res augmented configure to check the sizeof(wchar_t).
	- Oktal added overloaded constructors to csHashIterator and
	  csGlobalHashIterator that allow them to be initialized from const
	  hashmaps, and added methods to them for the manipulation of
	  iterators initialized from const hashmaps.
	- Reed Hedges added csInitializer::SetupVFS, and changed
	  csInitializer::SetupConfigManager to use that function.
	- res committed some forgotten files and fixed some cut'n'paste and
	  similar stupid errors.
	- Andrew Craig added missing #include<wchar.h> in csutil/util.cpp
28-Jul-2003
	- Jorrit removed several csVector's throughout CS:
	    - Replaced 'render_priorities' in the engine with csStringArray.
	    - Replaced 'references' in csSector with csArray<iReference*>.
	    - Replaced 'FinishTimes' in csAnimationTemplate with
	      csArray<csTicks>.
	    - Replaced 'ConfigFiles' in csConfigAccess with
	      csArray<iConfigFile*>.
	    - Replaced 'Iterators' in csConfigFile with
	      csArray<csConfigIterator>.
	  This is only the start.
	- Jorrit performed the next bunch of csVector removal:
	    - Replaced 'Removed' in csConfigManager with a
	      csRefArray<iConfigFile>.
	    - Replaced 'Iterators' in csConfigManager with a
	      csArray<iConfigIterator*>.
	    - Replaced 'tags' in csObjectRegistry with a csStringArray.
	    - Replaced 'registry' in csObjectRegistry with a csArray<iBase*>.
	    - Replaced 'objects' in csObjectRegistryIterator with a
	      csRefArray<iBase>.
	- Jorrit performed the next bunch of csVector removal:
	    - Replaced 'fifo' in csTreeNode with a csArray<csTreeNode*>.
	    - Replaced 'children' in csTreeNode with a csArray<csTreeNode*>.
	    - Replaced 'ModalInfo' in csApp with a csArray<csModalInfo*>.
	    - Replaced 'clipchildren' in csComponent with a
	      csArray<csComponent*>.
	    - Replaced 'vViews' in csGrid with a csArray<csGridView*>.
	    - Replaced 'vRegionStyles' in csGrid with a csArray<csGridCell*>.
	- Jorrit added csStringArray::FindSortedKey() with only one argument.
	  This will use default case sensitive key find.
	- Jorrit removed some usages of csStrVector:
	    - Replaced 'del' in csArchive.
	    - Replaced 'Names' in csCommandLineParser.
	    - Replaced 'Values' in csSpinBox.
	- Jorrit added iStringArray. This is an SCF interface for
	  csStringArray. csStringArray does not directly implement this
	  interface though. Instead there is scfStringArray which embeds
	  an csStringArray and implements iStringArray. This is similar
	  to iStrVector and the idea is that iStringArray will completely
	  replace iStrVector.
27-Jul-2003
	- Philipp Aumayr added Cubemap and Texture3d Parser/Loader
	- Marten Svanfeldt made a few changes related to new renderer
	    - Some cleanup of code not used anymore in libcsengine, sector.cpp
	      and related headerfiles.
	    - Fixed some uninitialized variables in csRenderMesh
	    - Added a check for VBO before trying to use it in DeactivateBuffer
	- Keith Fulton changed thing.cpp so that deallocation of lightmaps
	  doesn't crash the system when using a null renderer.
	- Keith also committed a fix to csutil/list.h to fix an obvious bug
	  there.
	- Jorrit cleaned up the public header files of AWS. Performed
	  proper indentation, added missing doxygen comments, fixed several
	  wrong doxygen comments, added missing LGPL notice, added missing
	  include protector, replaced normal pointer with csRef.
	- Jorrit did some Doxygen comment cleanups in include/ivideo.
	- Jorrit moved all X-Windows specific include files from include/ivideo
	  (xextf86vm.h, xextshm.h, and xwindow.h) to the new directory
	  plugins/video/canvas/xwindowcommon. These include files are common
	  to all canvas implementations that use X-Windows but they don't
	  need to be public.
	- Jorrit did more Doxygen and indentation cleanups in include/ivideo.
	- Jorrit cleaned up various include files in csutil.
	- Jorrit made the assignment operator and copy constructor of
	  csArray<T> more efficient.
	- Jorrit made the copy constructor of csRefArray<T> more efficient.
	- Jorrit clarified the documentation in csFlags since people often
	  seem to be confused about that class. Also replaced 'unsigned'
	  with 'uint32' to store the flags.
	- Jorrit marked csPArray<T> as deprecated.
	- Jorrit cleaned up several include files in include/imesh.
	- Jorrit cleaned up several include files and Doxygen commments
	  in include/ivaria.
	- Jorrit replaced all usages of the deprecated csPArray<T> with
	  csArray<T*>. Also removed csPArray<T>.
	- Jorrit added InsertSorted() and FindSortedKey() to csArray<T>.
	- Luca changed the behaviour of awsRadButton::OnKeypress,
	  awsCheckBox::OnKeypress and awsCmdButton::OnKeypress. Now those
	  methods return true iff the key event is really "eaten". Before
	  they were returning always true, even if the key event was not used
	  at all.
	- Luca has fixed the method csQuaternion::GetEulerAngles accordingly
	  to the patch provided by Troy Chard (troy.chard@shaw.ca).
	- Jorrit cleaned up several include files in include/cstool.
26-Jul-2003
	- Wouter Wijngaards fixed the partedit awssink.cpp file, removed
	  'static' from enums and put initializers for a constructor
	  in declaration order to remove compiler errors and warnings.
25-Jul-2003
	- Norman Kraemer fixed pythmod_setup.py for cases with no lib entries
	  between the enclosing '--'.
	- Andrew Craig added in missing include for va_start in stringarray.h.
	- Keith Fulton added a FormatPush member to stringarray.h.
	- Eric Sunshine made the following user manual-related changes:
	    - Continued updating the user manual to reflect recent SCF changes.
	    - Started updating the user manual to reflect the recent changes as
	      to how user-specific settings are managed (i.e. retirement of
	      user.cfg).
	    - Updated a lot of extremely out-of-date information in
	      texinfo/internal, and removed a bunch of obsolete information.
	- Norman Kraemer fixed his fixes to pythmod_setup.py and changed
	  cspython.mak to pass the location of CS libaries to the python
	  dist package.
	- Norman also removed a few dozen warnings about using char as array
	  index in the software renderer.
24-Jul-2003
	- Reed Hedges made some minor updates to the AWS "Quick Start" section
	  and API Changes appendix for the recent changes to AWS (15-Jul-2003).
23-Jul-2003
	- Eric Sunshine fixed memory trashing bugs in Win32 implmentation of
	  csLoadLibrary().  When composing its error messages, it was
	  allocating insufficient memory to contain the composed strings.  In
	  all cases, it failed to take the terminating null byte into account.
	  In some cases, it was just wildly miscalculating the necessary
	  allocation size.
	- Eric Sunshine disabled "keyboard grabbing" by default in the
	  X-windows (xwindow) canvas since it seems generally to cause more
	  problems for people than it solves.  For instance, it prevents people
	  from using hot-keys intended for the window manager (which is
	  external to CS).  In the future, however, it might be useful to
	  provide an API for controlling this behavior at run-time since it is
	  reasonable that games might want to avoid losing keyboard focus
	  during some intense action sequence when the user accidentally hits
	  some incorrect batch of keys.	 Note that the API for this feature,
	  once properly generalized to be platform-neutral, does not belong in
	  iGraphics2D; but rather in some input- or keyboard-related interface.
	- Eric Sunshine fixed bug reported by Daniel Fryer <dfryer@uvic.ca>
	  where csEngine::CreateBlackTexture() was leaking a csImageMemory
	  instance upon each invocation.
	- Eric Sunshine removed invalid reference to non-existent
	  partedit/Jamfile from apps/tools/Jamfile.
	- res added the forgotten partedit/Jamfile and re-added it to
	  apps/tools/Jamfile.
	- Eric Sunshine removed all remnants of the old monolithic
	  system-driver (csSystemDriver, SysSystemDriver, etc.).  This finally
	  completes the task which began about two years ago.
	- Eric Sunshine eliminated compilation warning in OSXMenu.m which arose
	  when AppKit upgrade changed NSMenu to deal with id<NSMenuItem> rather
	  than NSMenuItem*.
	- Andrew Craig added a NULL check in the Thing plugin where it was
	  trying to use a SuperlightMap object that the null renderer does not
	  create.
	- Andreas Busch fixed 686 processor family reporting in new and old
	  software renderer for higher processors like P4 (e.g. family 15,
	  which resulted in "1586 CPU detected" message).
22-Jul-2003
	- Philip Wyett fixed inconsistent swig -I flag in make build and
	  aligning it with jam build.  cs_pyth.cpp will now be identical
	  whether make or jam built.
	- Keith Fulton added /apps/tools/partedit particle system editor.  This
	  is still unfinished but should at least run.	Code was by Peter
	  Holko, who is still working on it.
	- Eric Sunshine reverted Phil's change to win32.cpp where he removed an
	  invocation of CreateSolidBrush().  Instead, Eric patched
	  pythmod_setup.py, cspython.mak, and win32gcc.mak so that the _cspace
	  Python module is linked against gdi32.lib, which is where
	  CreateSolidBrush() is located.  (This is untested.  If you still
	  experience trouble, please attempt to satisfy the link requirements
	  by editing the makefiles or pythmod_setup.py, rather than disabling
	  code in win32.cpp.)
	- Eric Sunshine reverted Keith Fulton's change to csStringArray
	  SetLength() in which Keith shifted to the caller the responsibility
	  of freeing the strings.  This silently broke existing client code by
	  introducing memory leaks.  Moreover, his change was semantically
	  incorrect.  csStringArray must be responsible for managing its own
	  storage (after all, this is one of the tenets of encapsulation).
	  This burden should not be placed upon clients.  Also fixed the actual
	  problem, which I assume Keith was attempting to address with his
	  change, which was that Pop() and Extract() were returning
	  already-deleted strings.
	- res made the following changes wrt Jam build:
	    - Tweaked msvcgen Jamconfig a bit. The VC project generation still
	      has some issues, but it's already usable.
	    - A couple of Jamfile tweaks & fixes all over the place (missing
	      newlines, missing external libs and such.)
	    - Added a new compile group 'walkall'.
	    - Added a Jamfile for partedit.
	- Eric Sunshine corrected `hbox' warnings reported by TeX.
	- res fixed a problem with the C compiler flags for the VC project
	  cflags when using the FreeType2 external lib. The "/I" command line
	  parameter was errorneously treated like a path to a file. Luckily
	  the MSC compiler also accepts "-I" style parameters.
21-Jul-2003
	- Oktal added missing doxygen comment at the top of csSymbolTable.
	- Philip Wyett removed CVS conflict data from gl_render3d.cpp.
	- Jorrit removed a comment about csPDelArray<T> being deprecated from
	  the documentation.  csArray<T> nor csRefArray<T> can provide the
	  functionality given by csPDelArray<T>.
	- Jorrit fixed the include file in the collision detection howto and
	  also replaced the use of SCF_QUERY_INTERFACE for the iPolygonMesh
	  with the proper usage of GetObjectModel().
	- Jorrit added a few references towards individual HOWTO's from the
	  rest of the documentation.
	- Jorrit replaced all occurrences of NULL in the documentation with 0.
	  This same replacement has been done on the source code some time ago.
	- Jorrit fixed the ensocket documentation to use csRef.
	- Jorrit replaced several NULL occurrences with 0 throughout the CS
	  sources.
	- Philip Wyett removed some old LUA link related code from win32 gcc
	  makefile.
	- Philip Wyett fixed ds3d linking on Win32 GCC.	 This method works for
	  both MinGW and Cygwin.
	- Philip Wyett performed a temp removal and replace with null on win32
	  wc.background colour in cssys.  This allows pythmod to successfully
	  build with Cygwin.
	- Keith Fulton fixed csStringArray to handle item removal without
	  crashing.
20-Jul-2003
	- Jorrit forgot to link the new howto into the howto chapter.
	- Jorrit fixed a small note about curves in the thing mesh object
	  documentation.
	- Jorrit added a new howto about creating a thing mesh.
	- Jorrit added the beginnings for the genmesh mesh object
	  documentation.
	- Jorrit removed mention of the meshobjects implementing iPolygonMesh
	  from the mesh object documentation. The mesh objects still do that
	  but that's supposed to be secret :-)	The real method is to use
	  the iObjectModel now.
	- res made the following changes:
	    - Committed some files he forgot the last time.
	    - Added copy constructors for csPArray<> and csRefArray<>.
	    - Some doc updates in csgfx/gradient.h and memimage.h.
	- res added some #includes missing in new renderer builds to
	  csengine/engine.cpp.
	- Oktal added to csMaterial::AddChild() in new renderer: it now calls
	  iShaderWrapper::SelectMaterial() on the child before adding it.
	- Oktal fixed crash in csSymbolTable::SetParent() by adding bounds
	  checking to the symbols hashmap iterator.
	- Oktal moved csSymbolTable from csgfx to csutil.
19-Jul-2003
	- Jorrit added howto about adding game data to Crystal Space objects in
	  map files.
	- Oktal finished implementing the new renderer shader variable system.
	  The API is now fully implemented, and there are no compile errors
	  (except possibly the shader plugin .cpp's, which I can't test since
	  I don't have a proper GL installation.)
	- Anders Stenberg fixed a few compile errors Oktal introduced.
	- res moved superlightmap generation from the renderer to the thing
	  plugin.
	- res moved csEngine:: methods from engine/renderloop.cpp to
	  engine.cpp.
	- Oktal made the following changes to the shader variable system:
	    - Rewrote the SelectMaterial-related code to index materials based
	      on their pointer address instead of their index in the txtmgr's
	      array of material handles.
	    - Added an overloaded function iShaderBranch::GetSymbolTable(int)
	      to get an extension symbol table without selecting it.
	    - Rewrote the implementations of iShaderBranch::AddChild to make it
	      add children to all symbol tables, not just the selected one.
	- Oktal implemented no-op GetSymbolTable(int) in csMaterial (fixed
	  new renderer compile error).
18-Jul-2003
	- Anders Stenberg fixed compile errors introduced by Oktal.  New
	  renderer should compile, although variable functionality is crippled.
	  (Results in lighting failure.)
	- Keith Fulton committed some additional accessor functions to iPath
	  and csPath.
	- Jorrit added a new csRadixSorter class. This class implements the
	  radix sort algorithm which is O(n) but only works on integers.
	  It needs up to 4 passes to sort a table of integers. I did some
	  benchmarks to compare radix with qsort. Here are some results:
	    - 100000 random numbers no greater than 65535: radix roughly 9
	      times faster.
	    - 100000 random numbers: radix roughly 6 times faster.
	    - 100000 almost sorted numbers: radix roughly 3 times faster.
	    - 100000 almost equal numbers: radix roughly 2 times slower.
	  So in almost all cases radix clearly beats qsort.
	- Jorrit reverted a change Peter Amstutz did 7-July.  He then changed
	  the thing plugin so that the normal is automatically recomputed when
	  needed.  However it seems that that is not working properly for some
	  reason.  With that fix enabled the rotating cubes in the mirrored
	  room (flarge) no longer work properly.  Need to further investigate
	  for a good fix.
17-Jul-2003
	- Philip Wyett fixed broken glrender3d makefile. OBJ.GLRENDER3D should
	  have had OUT.GLRENDER3D not DIR.GLRENDER3D.
	- Jorrit committed a patch from Anders Reggestad to the spiral particle
	  system.  Here is his log: This is more or less a complete rewrite of
	  the not working spiral system thats currently in CS.	The old system
	  have big problems with bbox, and when outside view for a period of
	  time the whole thing will explode when entering view again.
	  (Particle systems isn't updated when out of view, nice
	  optimalization, but fatal for the old spiral system.) Rewrote the
	  system to rebuild when reentering view (Like done in the fountain and
	  explotion system).  Added some new parameters to control the look of
	  the system.  Anders was also so nice to update the documentation for
	  his changes.	If only everyone would do that!
	- Philip Wyett fixed rlsstencil makefile and rlsstencil.csplugin is now
	  cleaned correctly.
	- Oktal fixed the compile errors in the new renderer shader variable
	  system, and recommitted it. The API is in place but not fully
	  implemented.
	- Oktal fixed bug in material.h: #ifdef instead of #ifndef.
16-Jul-2003
	- Anders Stenberg made the following new renderer additions and fixes:
	    - Made AWS work.  (Added some stub functions to comply with
	      interface definition.  Seems like it works.)
	    - Added CLAMP and NOFILTER flags to textures, as well as loader for
	      them in csparser.
	    - Added several return value checks, to avoid some cases of broken
	      level/shader leading to crash.  (Still lots of cases left.  Need
	      to do some _real_ error checking/reporting here.)
	    - Added a flag to CreateRenderBuffer to specify that a render
	      buffer is to be used for indices, and updated affected mesh
	      plugins.
	    - Disabled VBO support by default, since no nvidia cards seem to
	      cope with it.  (Driver bug or wrong implementation?)
	    - Made shaders check if an appropriate renderer is the current one.
	      (i.e. GL shaders won't load if the software renderer is used.)
	    - Fixed broken loading of variables.  (Maybe stupid since it will
	      soon be totally replaced, but I needed it for some tests.
	    - Fixed bug with transform not beeing updated in some cases where
	      it should.
	    - Added "rendertarget" and "fullscreenquad" render steps.
	- Anders Stenberg added software implementation of new renderer.
	  (Pretty much just a hack to use a copy of the old renderer. No
	  makefiles included, so someone who knows what they're doing should
	  create some.)
	- Philip Wyett changed an ASSERT () call to CS_ASSERT () in
	  'gl_renderbuffer.h'.
	- Philip Wyett added a note to disable 'Video.OpenGL.Caps.Stencil' in
	  'opengl.cfg' if not supported by the users hardware or they are
	  experiencing crashes.	 Also added the ATI Radeon (r100) owners
	  running Linux (DRI) as a known case where this should be done.
15-Jul-2003
	- Christopher Nelson removed the procedural texture support from
	  AWS entirely.	 This means that a user must do all the construction
	  work if they intend to use custom canvases.
13-Jul-2003
	- Keith Fulton changed csPath to inherit from SCF interface iPath.
12-Jul-2003
	- Boyan added SetBroadcast and SetBroadcastOptions in iNetworkSocket2
	- Jorrit applied a fix to the fountain bounding box creation
	  code as supplied by Anders Reggestad.
11-Jul-2003
	- Jorrit added a convenience csPolygonMeshCube class which represents
	  an easy way to make a cube collider.
	- In addition Jorrit did the following:
	    - Simplified walktest a bit by using this new csPolygonMeshCube
	      class. So it no longer has to make dummy cube things for the
	      actor.
	    - Also use csPolygonMeshCube in csparser instead of the custom
	      cube mesh that was implemented there.
	- Jorrit renamed csPolygonMeshCube to csPolygonMeshBox. It is a box,
	  not a cube.
	- Eric Sunshine performed project-wide spelling corrections:
	    convenience --> convenience
	    convenient	--> convenient
	- res fixed a bug in the GetLongPathName() replacement for Win9x/NT:
	  an array was allocated on the stack at runtime, but was almost
	  immediately overwritten, causing the function to not work at all.
	  The issue was unnoticed as the behaviour didn't occur with MSVC.
10-Jul-2003
	- Jorrit added a test in csColliderWrapper::Collide() so that
	  csColliderWrapper can be used in cases where there is no
	  collider. This means one can use csColliderWrapper to remember
	  the fact that there is no collider.
	- Eric Sunshine augmented the -fvtable-thunks check in configure.ac so
	  that it is also performed on Cygwin since this flag is needed with
	  the 2.x compiler on Cygwin.  (Previously, it was performed only for
	  Mingw).
	- Jorrit fixed two wrong message id's in the csparser. It was
	  complaining about 'addon' while it had nothing to do with that.
	- Eric Sunshine fixed cssys/win32/csosdefs.h so that CS_WIN32_ARGC and
	  CS_WIN32_ARGV are defined always (previously they were not defined
	  for Cygwin).	This fixes problem on Cygwin where win32.cpp was
	  utilizing these macros.
	- Eric Sunshine fixed the default plugin install macro in install.mak
	  so that it only installs the .csplugin file if present.  This is a
	  convenience for platforms which bundle the meta-information directly
	  into the plugin module rather than maintaining it in a separate
	  .csplugin file.  It allows such platforms to utilize the default
	  macro rather than creating a custom one.  This also fixes the
	  "install" target for Windows, since meta-information is bundled into
	  the .dll on Windows.	Finally, as a side-effect, it fixes the problem
	  where installation of the Python plugin _cspace.so (.dll) caused the
	  "install" target to fail because no .csplugin file was present (lack
	  of .csplugin is correct since this is a Python plugin, not a CS
	  plugin).  This is not a "clean" solution to the _cspace.so problem,
	  and we should devise a better one, but it works well enough for the
	  interim.
	- res fixed a memory leak in csPluginPaths::AddOnce().
	- res fixed a memory leak when using csStringHashIterator - upon
	  construction a new csGlobalHashIterator was created, but not deleted
	  on destruction (more exactly, csStringHashIterator lacked a
	  destructor.)
	- Reed Hedges fixed csXWindow::SetTitle() so that it actually sets the
	  window title on each invocation, whereas in the past it only worked
	  correctly if it was called before the window was created.
9-Jul-2003
	- Jorrit fixed PlaceMesh() so that it now uses
	  engine->GetNearbyObjects(). That makes it a lot more efficient
	  then the old implementation which simply traversed all objects
	  in the current sector.
	- Jorrit added iMeshWrapperIterator to iterate over meshes.
	- Jorrit added three new functions to iEngine: GetNearbyMeshes()
	  and two versions of GetVisibleMeshes(). These functions complement
	  the already existing GetNearbyObjects() and GetVisibleObjects().
	  Instead of returning an iObjectIterator they return an
	  iMeshWrapperIterator. This avoids the need to do SCF_QUERY_INTERFACE
	  to get the iMeshWrapper in the code using the iterator so this
	  can be a significant optimization.
	  The Get...Objects() functions will not be removed because in the
	  future they will also return lights.
	  Side note: GetVisibleObjects() and GetVisibleMeshes() are not
	  implemented yet.
	- Jorrit changed PlaceMesh() so it uses GetNearbyMeshes() now.
	- Jorrit changed Walktest collision detection code so it uses
	  GetNearbyMeshes().
8-Jul-2003
	- Jorrit reverted the change to glrender.mak that was made yesterday.
	  This change breaks compilation of the OpenGL plugin.	With revision
	  1.52 of glrender.mak it was not able to find rule to build object
	  files for files from renderer/common.
	- Jorrit fixed win32.cpp for cygwin so that it uses the correct argc
	  and argv (i.e. with two underscores instead of one).
	- Eric Sunshine reverted the reversion of glrender.mak and applied a
	  small patch so that it can build files from the renderer/common
	  directory.  Also patched gl_render3d.mak.
	- res worked around the 'double keypad key event' problem on Win32.
	  Upon reception of a 'keydown' message for such keys, CS enqueues a
	  key event; however, Windows generates another message containing the
	  keycode translated to a character.
	- res attempted to update & fix cs-config on Win32.
	- res fixed a usage of GetLongPath() in instpath.cpp. Replaced it with
	  a call to csExpandPath().
7-Jul-2003
	- Peter Amstutz changed iDataBuffer so that it can be instructed
	  not to delete the underlying buffer when iDataBuffer is freed.
	- Peter Amstutz fixed csPolygon3DStatic so that the object plane
	  (polygon normal) is updated if necessary when GetObjectPlane()
	  is called.
	- Eric Sunshine removed some errant DecRef() invocations from the
	  "pixmap" how-to which were pointed out by Jacob Gostylo
	  <jgostylo@users.sourceforge.net>.
	- Eric Sunshine upgraded glrender.mak and gl_render3d.mak so that they
	  store their build files in distinct subdirectories of $(OUT).	 This
	  works around conflicts caused by both modules having source files of
	  the same name.
	- res fixed a copy'n'paste bug in the rain mesh object, pointed out
	  by Jochen Munch <powermonk@users.sourceforge.net>
	- Eric Sunshine fixed bug in msvcgen.pl where the prefixes specified
	  via --strip-root were not being applied to the value of the
	  %metafile% pseudo-variable.
5-Jul-2003
	- Boyan removed circular reference between ds3d render and listener
	  which prevent to unload ds3d plugin.
	- Marten added so that NR use gl*Pointer when there are no
	  glAttributePointer extension available.
	- res added a home-grown GetLongPathName() surrogate for older Windows
	  versions, where it's unsupported.  This was pointed out by Paul G.
4-Jul-2003
	- res committed fixes from Oktal for some circular #include
	  dependencies in the new renderer.
	- res fixed a wrong #include in anonrndbuf.cpp.
	- res fixed a typo in syspath.h, slightly changed a few comments
	  there, and also fixed a comment in gradient.h.
	- res added a missing pair of quotes to the crystal.fgd "light" entry.
	- res fixed the map2cs mechanism for removal of polys with certain
	  textures. This didn't work with Hammer maps due to a
	  lowercase/uppercase mismatch.
	- res fixed a bug in map2cs where 'invisible' (and thus unused)
	  textures nevertheless appeared in texture & material list.
3-Jul-2003
	- Jorrit removed obsolete bindings for radiosity commands for Walktest
	  and added 'r' key to record movements on/off and 'shift-r' to play
	  the recording.
	- Eric Sunshine made the following documentation-related changes:
	    - Continued updating user manual to reflect latest SCF changes.
	    - Fixed a significant number of Texinfo mark-up problems in
	      walktest.txi.
	    - Updated extremely outdated information about configuration and
	      configuration files in user manual.
	    - Corrected several mark-up bloofles in various .txi documents.
	    - Eliminated TeX `hbox' warnings.
	- res enhanced bugplug with a command to send debug commands to
	  arbitrary plugins. Syntax is: debugcmd <classID> <command>
	- res fixed a spelling error in bugplug.
	- Duhprey did the following:
	    - Softness generalization patch (soft_cfm contact is now handled
	      the same was as friction and elasticity)
	    - Plane direction patches (invert A and C, as well as B) planes are
	      not consistent and still need some work.
	    - Revert the MeshSphere collider, those optimizations aren't
	      general.
	    - Fix the collision callback to work when 1 body is static.
2-Jul-2003
	- Eric Sunshine fixed some spelling errors in the user manual pointed
	  out by Vincent Knecht <vince@iefr.ath.cx>: existance -> existence
	- Eric Sunshine applied a patch to snapshot.py from Just van Rossum
	  <just@letterror.com> which allows it to work correctly when project
	  subdirectory names contain spaces.
	- Anders Stenberg made the following changes:
	    - Made sure NextFrame is called when rendering with new renderer.
	    - Fixed a bug where xorpat assumed width == height.
	- DeSigna made the following changes:
	    - Added a pair of MemoryMapWindow() functions, allow mapping parts
	      of files, mapping in read/write files and re-using file handles
	      for multiple windows into the same file.
	    - MemoryMapFile() was modified to work with these new functions.
	- Duhprey made a Speed improvement to PreCompute in terrbig
	- res updated the Win32 memory mapping for "window mapping".  However,
	  the new stuff is still untested, as it isn't used yet anywhere.
	- res fixed some doxygen issues in csshlib.h, sysfunc.h, syspath.h.
	- DeSigna patched in the walktest documentation contributed by Marten
	  <martin@cyber-dog.freeserve.co.uk>.  The old documentation remains in
	  CVS until some parts are transplanted.
1-Jul-2003
	- HangDude made the following changes:
	    - Moved anonrndbuf.h from csutil to cstool (on Jorrit's request).
	    - Added LGPL notice.
	    - Updated genmesh because of that change.
	- res fixed rlsstencil.mak which got messed up when the plugin name was
	  changed.
	- Matze moved CFLAGS from mk/jam/variant.jam to Jamrules to not enforce
	  external projects to the same flags as CS is using
	- Anders Stenberg made the following changes:
	    - Fixed a bug in stdrep where it assumed that the renderer was in
	      2d mode.
	    - Added console output to r3dtest. Can be toggled with TAB.
29-Jun-2003
	- Luca fixed the inconcistency of properties read and written by
	  Set/GetProperty in the awsScrollBar class. He updated the texinfo
	  docs about scrollbar's properties too. He also fixed a bug in the
	  aws documentation about the signalComponentCreated (called wrongly
	  signalCreated).
	- Eric Sunshine regenerated the configure script since the last commit
	  made by Matze broke the Bison and Swig version checks.  This
	  corruption seems to have been caused by an old progver.m4 macro file
	  in Matze's CS/mk/autoconf directory or in some other location
	  searched by Autoconf by default.
28-Jun-2003
	- DeSigna fixed a small logic error in csGetKeyDesc(), where a ?:
	  conditional had its values the wrong way round.
	- JTarbox fixed it so the fast_mem_copy code is only active with a MSVC
	  less then version 7.
	- res fixed Win32 csosdefs.h to use fast_mem_copy only on MSVC.	 The
	  recent changes caused that fast_mem_copy was used on VC < 7 _and_
	  non-VC platforms.
27-Jun-2003
	- Jorrit fixed a bug in genmesh where it would not initialize normals
	  to 0 if <autonormals/> was not used.	The result would be
	  unpredictable lighting behaviour.  Now genmesh will initialize the
	  normals to 0.	 This means that at least the behaviour is consistent:
	  if you don't use <autonormals/> and you don't specify normals
	  manually you'll get NO lighting at all.
	- res augmented r3dtest to accept a map to load as a command line
	  parameter.
	- res renamed stencil.csplugin to the correct rlsstencil.csplugin.
	- Eric Sunshine eliminated compilation warning from csprocessorcap.h.
	- Eric Sunshine fixed a problem with cspython.mak where it tried to
	  build cspython.dll when swigpythgen was invoked, in which case it
	  should only have re-generated the Swig output file.  Worse, when
	  attempting to build the .dll, it was using `ar', rather than
	  gcc/dllwrap.
	- Eric Sunshine eliminated several compilation warnings from
	  DirectSound 3D renderer.
	- Duhprey ported sprite3d to new renderer
	- Eric Sunshine converted sndds3d.mak and sndsoft.mak over to the new
	  format where object files and resources are placed in a
	  module-specific build directory.  This solves several problems where
	  glwin32, sndsoft, and sndds3d were confusing and mixing source and
	  object files.
	- Eric Sunshine fixed silly bug in csLoadLibrary() for MacOS/X.	 It was
	  supposed to transform the incoming .csplugin suffix on the pathname
	  with .csbundle, but instead uselessly replaced .csplugin with
	  .csplugin.
	- Anders Stenberg added support for pixmaps (DrawPixmap) to new
	  renderer.
25-Jun-2003
	- Oktal manually applied a patch to cssocket that was intended for
	  ensocket, submitted by Ladislav Foldyna.  The patch adds multicast
	  support.  I also added warnings that are triggered when deprecated
	  functions are called.
	- Oktal fixed the argv error in the Perl module by just having Swig
	  ignore the function that was causing trouble. This looks like some
	  sort of bug in Swig.
	  Also added csArray and csRefArray support, and removed the
	  typemap to convert csHashMapReversible to a native Perl hash type.
	- Jorrit did a minor change to emit again to properly change the
	  object model when some of the attributes change.
	- Philip Wyett removed the references in the docs that offered
	  people to contact me directly re MSVC related build issues and
	  updated authors info to indicate my current inactive status.
	- res fixed the sndds3d makefile to work on MinGW/MSYS.
	- Anders Stenberg commited a fix for AWS from Gersh fixing two window
	  flags both defined as 0x40.
24-Jun-2003
	- Oktal added an iGraphicsMemory interface with which to access
	  the csGraphicsMemory plugin.
	- Oktal finished off the new renderer shader variable system,
	  including factoring out the variable-related API calls from all
	  the shader-related interfaces into a single interface which they
	  all now inherit from.
	  It should now be ready for use, and I leave that to
	  Anders and Marten :-)
	- Jorrit attempted to fix the perl plugin but only partially succeeded.
	  Down to one error (with mingw/msys):
	    plugins/cscript/csperl5/cswigpl5.inc: In function
	    `void _wrap_scfInitialize(PerlInterpreter *, CV *)':
	    plugins/cscript/csperl5/cswigpl5.inc:4575: `argv' undeclared
	    (first use this function)
	- Jorrit removed support for lua in the pysimp application. Now it
	  only uses python. It is also no longer required to use a commandline
	  option.
	- Jorrit removed scripts/lua. This was a left-over from the past.
	- Jorrit removed a mention of the lua plugin from the documentation.
	- Jorrit fixed the emit mesh object in two ways:
	    - First it will now correctly de-init itself in case several
	      of the parameters are modified. That way you can update the
	      mesh realtime.
	    - Secondly there were some errors with ref counting for the
	      emitgen stuff. Replaced all with csRef's.
	- Philip Wyett corrected .csplugin filename in nmeshldr.mak, so
	  nullmeshldr.csplugin is cleaned correctly.
	- Jorrit did the following sequence manager related changes:
	    - Added four different operations (AddOperationSetVariable())
	      to the engine sequence manager with which you can set a variable
	      (or add to it).
	    - Added the 'setvar' command to sequences. With this you can
	      do the following:
	      <setvar var="v" value="3"/> set 'v' to value 3.
	      <setvar var="v" add="-2"/> subtract 2 from 'v'.
	      <setvar var="v" value_var="z"/> copy var 'z' to 'v'.
	      <setvar var="v" add_var="z"/> add var 'z' to 'v' (as float).
	      <setvar var="v" x="1" y="2" z="1"/> set vector 1,2,1 to 'v'.
	      <setvar var="v" red="0" green="0" blue="1"/> set 'v' to blue.
	    - These changes are totally untested!
	- Matze added an Iterator to csArray.
	- Luca (groton@gmx.net) fixed a bug in the awsList: the bug was that
	  the list box wasn't displaying the last item in some cases. I had to
	  modify in some places the source code of the awsScrollBar too:
	  I replaced in the awsScrollBar's source code many 'max - amntvis'
	  expressions with the expression 'max - amountVis + 1':
	  in fact if i have 10 item in my own listbox (ie the 'max' is 9),
	  and if the visible items are 5 (ie 'amntvis' is 5), then the correct
	  expression to get the max value for the index of the item displayed
	  in the first row is 'max - amntvis + 1', that is 5, with the previous
	  code that value was wrongly set to 4.
	- res slightly changed Win32 csGetPluginMetadata(): a .csplugin file
	  is looked for when the supplied file name has this extension.
	  Retrieving the resource from a .DLL is still tried in all cases.
	  This should make metadata retrieval a bit faster.
	- res fixed FR #759764 "Uninitialized members in partgen.cpp":
	  alphapersecond/alpha_now are now initialized to 0.0f resp. 1.0f.
	- Marten reverted Oktals addition of a new variablesystem to render3d.
	  It have alot of serve compilation-errors which should be fixed before
	  commiting.
23-Jun-2003
	- HangDude fixed metaballs for recent renderbuffer changes (changed
	  CS_BUF_INDEX / STATIC to CS_BUF_DYNAMIC)
	- Boyan did the following in AWS:
	    - Added iAwsComponent->GetFirstFocusableChild().
	    - Added awsWindow->SetFocusedChild and
	      awsWindow->GetFocusedChild().
	    - awsWindow now holds last focused child on Hide() If window shows
	      again WindowManager knows witch child need to be focused.	 If
	      there is no info about last focused child window calls
	      GetFirstFocusableChild and focus it.
	- Jorrit fixed formatting with the csQuaternion class.
	- Matze fixed 2 errors in the jam rules for .csplugin -> metadata.rc:
	  There was no dependency set from .csplugin->metadata.rc and the
	  generated file was not added to the clean target.
	- Oktal added loaders for the nullmesh object and factory, needed for
	  blend2cs and hierarchical meshes.
	- Eric Sunshine fixed the following problems with cspython.mak:
	    - Neglected to include swigpythgen and swigpythinst targets in
	      "make help" output.
	    - Neglected to install _cspace.so (_cspace.dll) via "make install".
	- Eric Sunshine fixed csGetPluginPaths() for Unix so that it respects
	  csGetAppDir() and csGetResourceDir() when composing the list of
	  directories to scan for plugin modules.
	- Matze added a workaround for bison 1.875 to aws
22-Jun-2003
	- HangDude converted metaballs to new renderer
	- Luca did the following:
	  - Fixed a bug in the label component of AWS: in fact the method
	    awsLabel::OnKeypress was returning always 'true', although the
	    event was not eaten at all; we must instead let it be passed
	    along to other listeners which could instead use and eat it.
	  - Fixed a bug when the glwin32 canvas is receiving WM_SIZE windows
	    message: in fact if the resizing flag is SIZE_MINIMIZED, then the
	    Height and the Width of the canvas was wrongly being set to 1!
	    Instead we have to preserve the current Height and Width values,
	    and just set the correct clipping rect to an empty region.
	    Besides, when we receive the WM_SIZE windows message, the old
	    behaviour was to 'return 0' wrongly, because we must instead
	    pass the message to the iWin32Assistant window procedure which
	    handles the WM_SIZE message as well (it can send to the CS event
	    queue messages like csevCanvasHidden and csevCanvasExposed).
	- Eric Sunshine made the following documentation-related changes:
	    - Began updating the documentation in the user manual to reflect
	      all of the recent SCF-related changes.
	    - Fixed a number of Texinfo markup errors and problems in perl.txi.
	    - Eliminated numerous overfull and underfull `hbox' warnings
	      reported by TeX.
	- Eric Sunshine removed the unused, obsolete, and deprecated top-level
	  <name> node from the .csplugin files.
	- res changed the plugin scanning process, now the scanning for plugin
	  files and the retrieval of metadata is split up.
	- res added a "special case" for static plugins when checking whether
	  a class is already registered; in particular, when the class already
	  registered is inside a static plugin, no message is emitted.
	- res removed csGetResourcePath() from winsyspath.cpp - it is in
	  resdir.cpp already.
	- DeSigna implemented awsWindow::foNoBorder, which existed as a name,
	  but unaccessable from skin definitions and unhandled in the code.
	- Eric Sunshine added cssys/general/resdir.cpp to
	  cssys/win32/win32gcc.mak, cssys/Jamfile (for Windows), and
	  msvcgen/win32.mak since Frank removed the csGetResourcePath()
	  implementation from winsyspath.cpp.
21-Jun-2003
	- Philip Wyett updated win32.mak to reflect changes/additions in
	  the general cssys library affecting MSVC port(s).
	- Philip changed all foo <= 63 to foo < 64 to add some
	  consistency and make for easier reading of the file.
	- Andrew Mann fixed a bug in the Win32 loadlib function
	  InternalScanPluginDir() that could cause double path delimeters
	  to be included in the full path and filename of a file.
	  Also fixed a bug in the same location that attempted to load all
	  plugins from the current working directory regardless of where
	  the plugin scan found them.
	- Philip Wyett initialized the un-initialized 'clipportal_dirty'
	  at construction in csGraphics3DOGLCommon.
	- Keith Fulton added iRegion->Add(iObject*) function to make
	  adding objects to regions cleaner and easier.
	  Also committed several compiler errors and warnings.
	- Wouter fixed the openglcommon DrawPixel operation, which now
	  uses floating point to address pixels. The same problem as for
	  DrawLine seems to exist, where whole y values are later rounded
	  up, shifting the result. The floating-point y value is slightly
	  perturbed so its no longer on-the-edge. This makes g2dtest
	  for opengl and software perform about the same on all clip tests.
	- Wouter fixed the normal cursor in the standard console output.
	- Wouter added two extensions to standard console to set colours.
20-Jun-2003
	- Marten fixed an error in the inline assembly in tcovbuf.cpp
	  which prevented it from compiling on msvc6
	- Jorrit fixed a compile error in thing with relation to the new
	  renderer.
	- Duhprey fixed missing new way to handle zbuf mode.
	- Jorrit reverted all const char related changes to csStringArray.
	  The way it is now prevents people from modifying the strings.
	  This needs to be redone but preferably by someone who TESTS
	  the changes!
	- Jorrit did the following region related changes:
	    - Removed the concept of the current region. The engine still
	      manages regions but no longer knows about the current region.
	    - Removed engine->SelectRegion(), engine->GetCurrentRegion(),
	      and engine->AddToCurrentRegion().
	    - Added engine->CreateRegion(). This function will create a region
	      and add it to the region list. If the region already exists
	      it will simply return a pointer to that.
	    - Removed support for the <region> keyword in map files.
	    - Added optional region parameter to iLoader->LoadLibraryFile().
	    - Replaced boolean resolveOnlyRegion parameter in
	      iLoader->LoadMapFile() with a pointer to the actual region
	      instead.
	    - Changed the parser to add all objects to the current region
	      itself.
	    - Sequences, triggers, and shared variables are also put in
	      regions now.
	    - The region code now supports removing sequences, triggers, and
	      shared variables too.
	- Wouter updated viewmesh to call ShineLights on the meshwrapper.
	  This lights thing objects correctly.
	- Philip Wyett added physics loader plugin to MSVC build process.
	- Jorrit updated the documentation to latest region related changes.
	- Jorrit re-added the bool resolveOnlyRegion parameter (curRegOnly) for
	  LoadMapFile(). Also added this for LoadLibraryFile(). This is used
	  in addition to the region parameter now. The region parameter on
	  its own only causes objects to be added to that region. The
	  curRegOnly parameter causes objects to be searched in only that
	  region (as opposed to all regions).
	  This fixes the -regions commandline option for walktest.
	- Jorrit added some init code back to the ball mesh. That code
	  caused 'top_mesh' to be uninitialized for some fields and this
	  caused weird things on various systems. For some weird reason
	  Marten removed this initialization code during the rewrite of
	  ball mesh to the new renderer.
	- Jorrit did some updates to the documentation to avoid the word
	  'region' where something else is meant.
	- Jorrit fixed iso loader after his latest changes.
	- Jorrit fixed motion loader after his latest changes.
	- Wouter fixed reference leaks in Aws for iGraphics2D/3D and font
	  manager.
	- Jorrit fixed a bug in the region code. It didn't remove lights.
	- Wouter added new method to iAws: GetKeyboardFocusedComponent.
	  It is useful when trying to determine if Aws is interested
	  in keyboard events.
	- Eric Sunshine reverted the reversion to stringarray.h, so that the
	  public API once again deals with (char const*), rather than (char*).
	  It is said that the earlier reversion was made because PlaneShift
	  modifies the strings stored in the array, however modifying (char*)
	  strings owned by some other object is highly dangerous and extremely
	  questionable behavior.  There are other much safer ways to accomplish
	  this.	 We should not allow the API of csStringArray to be corrupted
	  simply because some project employs dangerous coding practices.  (If
	  PlaneShift really insists upon relying upon this unsafe coding
	  practice, then it can use the manifestly unsafe const_cast<> to make
	  the returned strings non-const.  However, such practice is not
	  recommended.)	 Also reverted the earlier changes in revision 1.3
	  because they were incorrect.	Instead, fixed the actual problem (a
	  misplaced `const') which prompted the 1.3 changes.  (And, yes, the
	  present changes have been tested. :-)
	- Eric Sunshine eliminated a few instances of NULL which had crept back
	  into the project.
	- res made the following changes to the new renderer system:
	    - Index buffers aren't treated in a special way any more now.
	      Just your average vertex buffer.
	    - Changed the internal implementation of render buffers a bit.
	    - Renamed stencil shadow binary to 'rlsstencil' to fit in with the
	      other renderstep plugins.
	- Wouter added the option wfoNoDrag to aws windows, making the window
	  non-draggable. Fixed fs3dMask constant to fit available values.
	- res made the following changes to thing:
	    - Polys are now triangulized as single triangles instead of tri
	      fans. That makes it possible to store multiple poylgons in a
	      single rendermesh. Now one rendermesh per material is created.
	    - Index buffer now uses UNSIGNED_INT instead of INT. The latter
	      one doesn't seem to be liked by ATI's Cat3.4.
	- res added a Jamfile for the stencil shadow renderstep.
	- Eric Sunshine made the following changes:
	    - Renamed csGetAppPath() to csGetAppDir() to better reflect its
	      function.
	    - Added a new csGetAppPath() which returns the actual absolute path
	      to the executable (as opposed to csGetAppDir() which returns the
	      directory containing the executable).
	    - Added csGetResourceDir() as complement of csGetAppDir().	On many
	      platforms, the resource path is the same as the application path,
	      but this might not be true for all platforms.  For instance, on
	      MacOS/X, csGetAppDir() needs to return the directory in which the
	      .app wrapper is contained, however csGetResourceDir() needs to
	      return the Resources directory inside the wrapper.
	    - Added platform-specific csGetAppDir() and csGetResourceDir() for
	      MacOS/X.
	    - Updated the generic csGetPluginPaths() so that it includes the
	      result of csGetResourceDir() in the plugin path list.
	    - The above changes should allow the MacOS/X port to once again
	      locate its plugin modules.
	    - Fixed bug: In the case of a bare program name as argv[0] (as
	      opposed to an absolute or relative path), the default
	      csGetAppDir() in cssys/general simply returned the first
	      component of PATH which actually existed, rather than returning
	      the component of PATH which contained the application.
	    - Fixed bug: The default csGetAppDir() in cssys/general was always
	      using ';' as the path delimiter, even though that only works for
	      Windows.	Now uses ':' for Unix and Unix-like platforms.
	    - Fixed bug: The default csGetPluginPaths() in cssys/general was
	      attempting to prevent pushing "/" onto the plugin path list
	      (because "/" has ambiguous meaning under Windows), but was
	      instead actually preventing addition of any absolute path to the
	      list (that is, any path beginning with "/").
	    - Renamed iCommandLineParser::GetAppPath() to GetAppDir() to better
	      reflect its function.
	- Eric Sunshine disabled default recursion for now by the plugin
	  discovery code.  Many developers run their programs from within the
	  source tree, and the recursive scan of the source tree are needlessly
	  excessive.  In general, recursive scan during plugin discovery is
	  useful, but we need to think it out more before re-enabling it.
	- Philip Wyett removed '#include "csutil/string.h"' which does not
	  exist from appdir.cpp.
	- Wouter fixed off-by-one bugs in opengl 2d drawing. This causes
	  aws and csws to draw correctly (for me).
	  In gl3d the DrawPixmap routine is fixed to use the same
	  computation as glcommon2d is using.
	  Computation of a y location is gly = height - y.
	  The gly then has a range of 1..height. Still it is OK.
	  On opengl gly=0.0 is off screen. gly=height is also off screen.
	  Also, using gly=height-y gives results where absolute pixel
	  values (as seen with screenshots) are equal to the pixels
	  written by the software version. Thus height-y is used instead
	  of the height-y-1.
	  Closed three sf-bugs on this topic.
19-Jun-2003
	- HangDude did following:
	    - Added anonymous render buffer manager class, which can be used to
	      implement the anonymous render buffers for new renderer easily.
	    - "stream" to "renderbuffer" namechange in genmeshldr
	- Oktal made the following changes to the Perl plugin and module:
	    - Got rid of all the warnings in the Perl plugin and module,
	      some by fixing them and some by ignoring them with compiler
	      switches and pragmas.
	    - Added csString to those classes wrapped by Swig (same change
	      also made to Python module).
	    - Uncommented the plugin from user.mak.
	- Oktal fixed a typo and a missing #include in unix/instpath.cpp.
	- Duhprey did the following (new renderer):
	    - Added Shadow Volume step for custom renderloop, needs
	      speed optimiations
	    - Modified Light Iterator step to always do stencil write
	      (should be optimized out later when stencil writes aren't
	      needed)
	- Jorrit fixed various compile errors in csStringArray which were
	  introduced after the changes to char const*. These changes were
	  incomplete.
	- Philip Wyett commented out all MSVC project file related lines
	  in csperl5 plugin makefile, until time permits to investigate why it
	  hangs the nsvcgen process when run locally.
	- res fixed:
	    - Wrong parameters for *nix csGetPluginPaths().
	    - Stupid bug where the name of the .csplugin instead of. dll file
	      was returned as the plugin path on Win32.
	    - Matze wrote docu about per-user config on unix.
	    - Matze made the configure script abort if libz is missing.
	- Philip Wyett removed csperl5 plugin from CS build process.
	- Eric Sunshine eliminated incorrect statement in documentation of
	  iConfigManager in iutil/cfgmgr.h where it claimed that the dynamic
	  domain's iConfigFile could not be changed after construction.
	- res made the following changes:
	    - Split scfInitialize() into two versions, one with (argc, argv),
	      one with (csPluginPaths*) arguments.
	    - Improved 'context' handling a bit.
	    - Added iSCF->ScanPluginsPath() for convenience.
	    - Fixed general csGetAppPath () to return 0 on an empty argv[0].
	- res added the ability to load a single plugin and further improved
	  SCF factory 'contexts'.
	- res fixed Win32 csLoadLibrary() which has been messed up by himself.
	- Philip Wyett fixed a compile error in cmdline.cpp.
	- Marten made the following changes:
	    - Changed duhpreys shadowcode to use GetPolygonMeshShadows at
	      first, then fallback to GetPolygonMeshColldet.
	    - Added setting of PolygonMeshShadows in genmesh.
	    - Added stencil to user.mk
	- res started working on converting thing for NR. You already can see
	  something, but it's still rather crude and naive, tho.
18-Jun-2003
	- Jorrit added a new 'do_logo' command to walktest. Assigned 'l' key
	  to it. This command toggles the display of the logo.
	- Eric Sunshine updated the discussion of C++ templates in the
	  coding/portability section of the user manual to reflect the fact
	  that we do now allow templates, though with certain restrictions.
	- Marten removed the sc. discardingsystem for renderbuffers
	- Marten ported the ballmesh, nullmesh, simplecon and csconout to
	  new renderer.
	- res made the following changes:
	    - Added some documentation about per-user configs.
	    - Fixed csGetAppPath() on unix.
	    - On Win32, external .csplugin files are supported again (in
	      addition to embedded metadata.)
	    - SCF factories have internally a 'context' now. The 'context'
	      basically identifies the directory of a plugin and is used to
	      decide whether duplicate class ID will be reported or not.
	    - Eliminated a bit of redundant code and used more macros in
	      the GL extension manager to reduce it's bloat a bit.
	    - Renamed "win32/syspath.cpp" to "win32/winsyspath.cpp".
	- res fixed mdl2spr and nettut for the changed scfInitialize() syntax.
	- res restored the 'old' unix csGetPluginPaths ().
17-Jun-2003
	- Marten fixed an error with uninitialized extensions in render3d.
	- Marten fixed jamfiles for glshader_. They need to link to GL.
	- Philip Wyett updated cs_pyth.cpp and associated .py in cvs and also
	  fixed a typo in a csvector.h comment.
	- Eric Sunshine fixed a lot of const versus non-const char* problems in
	  csStringArray.  (Bug #755721)
	- Eric Sunshine fixed several problems recently introduced into
	  csLoadLibrary() in OSXDynamicLibrary.cpp:
	    - Compilation error: Incoming argument did not match variable name
	      used in code.
	    - Run-time failure: Was using a lot of hard-coded constants for
	      path dissection, but the constants were incorrect.
	    - Memory trashing: Was not allocating sufficient memory for the
	      working path buffer, thus corrupting memory beyond end of buffer.
	    - Memory leak: Was leaking the working buffer.
	- Eric Sunshine fixed library.jam so that it correctly resolves the new
	  csutil/cssys dependency.  There are now several layers of circular
	  dependencies between these two libraries.
	- Eric Sunshine applied a quick-patch to cs-config so that it should
	  now be able to handle the additional circular dependency between
	  csutil and cssys.  Perhaps Matze could apply a better fix, since he
	  probably has a better understanding of his own code.
	- Eric Sunshine eliminated unportable `test -e' from cs-config/Jamfile.
	- res changed the Win32 plugin paths to cause less recursive directory
	  scanning.
	- Oktal added macros to perlpost.i to allow users to implement
	  certain interfaces by writing classes in Perl, and made use of those
	  macros for iEventHandler and iAwsSink; it is easy to add more.
	- Oktal removed an old, unused line from libs/cssys/win32/loadlib.cpp
	  that was causing an error in Cygwin.
	- Oktal added a missing line to the macros in perlpost.i that showed
	  up as an error with certain versions of Perl, and added iEventPlug
	  to the list of interfaces which can be implemented in Perl.
	- res made the following changes:
	    - Added a few helpers to deal with native paths and plugin paths.
	    - All platforms now use the same plugin paths:
	      <app dir>, $CRYSTAL/lib, $CRYSTAL/crystal, $CRYSTAL
	      (where $CRYSTAL is the CS installation dir)
	- Marten renamed iStreamSource to iRenderBufferSource and GetBuffer to
	  GetRenderBuffer. In the classes the terms stream and renderbuffer are
	  mixed, from now on use just the term renderbuffer.
	- Oktal added reference counting to the interface implementation
	  wrapping macros for their internal Perl variable, and added a
	  paragraph to the documentation about same.
	- res fixed double compilation of cssys/win32/syspath.cpp with jam.
	- duhprey did the following:
	    - Quick fix to return current working directory instead of App's
	      full path
	    - Added #include "cssys/syspath.h" so vfs could find
	      csGetConfigPath
	- Oktal fixed a preprocessor directive in csprocessorcap.h,
	  it's "#elif" not "#else if".
	- res added the missing pluginpaths.cpp to MSVC libcssys.
	- res changed the plain "#elif" to "#elif defined()" in
	  csprocessorcap.h.
	- res fixed a couple of NR makefiles for proper MSVC project
	  generation.
	- res removed sysinit.cpp from Win32 cssys. Win32 has it's own version
	  of those functions.
	- Philip Wyett performed a minor cleanup in win32.mak and added
	  #include "cssys/syspath", fixing the compile error in the Python
	  plugin.
16-Jun-2003
	- Oktal separated a multiple-argument %ignore directive into several
	  single-argument ones, in perlpre.i, in order to support older
	  versions of Swig.
	- Jorrit made the <moveable/> option no longer required (it is now
	  deprecated).	The thing mesh object plugin will not automatically
	  detect if it is needed to switch to moveable or not.	So setting this
	  is no longer required.
	- Jorrit removed <moveable/> output from map2cs.
	- Jorrit removed mention of <moveable/> from documentation.
	- Jorrit fixed a bug in DeferUpdateLighting(). It was not correctly
	  transforming the bounding box of the object to world space.
	- Jorrit added a 'toggle_mmx' command to Dynavis. Assigned BugPlug
	  key '8' to that. This new command toggles the mmx capability on/off.
	- Jorrit replaced _X86_ with PROC_X86 in the tiled coverage buffer.
	- Jorrit replaced _X86_ with PROC_X86 in csProcessorCapabilities.
	- Jorrit fixed a bug in csNodeIterator. It was not working correctly
	  at all.
	- Marten made a few changes to buffers in render3d:
	    - Remade the buffer-management in render3d. The buffermanager is
	      removed and replaced by a CreateRenderBuffer in iRender3D.
	    - Removed VAR and VBO buffers
	    - Added VBO (vertex_buffer_object) based buffers.
	- Marten cleaned up code in gl_render3d and genmesh. Removed old
	  deprecated code and some general cleanup.
	- res made the following changes:
	    - Removed the csFindLoadLibrary() stuff. Plugins are now solely
	      loaded via native, fully qualified paths.
	    - Made storing the user config in "Documents & Setting" on Win32
	      the default.
	    - Some Jamfiles updated.
	- Oktal fixed a pointer arithmetic error in res's changes to cssys.
	- Philip Wyett fixed formatting in the MSVC 6 project plugin template.
	- res readded the VC6 templates as 'binary'.
15-Jun-2003
	- Boyan added property "Image" that can be set in AWS component "Image
	  View".
	- Oktal rearranged the documentation of the scripting language stuff in
	  the manual, and added Perl docs.
	- Oktal moved from cspace.i to pythpre.i the rename directive of
	  iDataBuffer::operator*() to iDataBuffer::asString(), and added a
	  Perl-specific wrapper for that method to perlpost.i.
	- Oktal changed /* in include/csutil/list.h to /** to fix the doxygen
	  comment, so that csList will be added to PubAPI.
	- Jorrit changed a comment for ThreadedLoadMapFile() to indicate that
	  it doesn't work yet.
	- Marten added the class csProcessorCapabilities to allow CS to query
	  processorspecific extensions and information.	 Some functions in this
	  class is processorspecific and some parts compilerdependant so we
	  must protect certain areas with #defines
	- Marten made these changes to dynavis
	    - Added a fix to csVisibilityObjectHistory to make it set reason on
	      initializationtime.  This fix a bug where bugplug/dynavis
	      segfault when trying to use the linedrawing debugging in dynavis.
	    - Made the inner XOR-filling loop in csCoverageTile::Flush use MMX
	      on machines which support MMX.  The loop is written twice, once
	      in MSVC and once in GCC inline assembly.	The reason for this is
	      speed.  It could have been written in NASM as a separate
	      function, but the overhead for the functioncall is too big.
	- res added a work around for a static linking problem to static.mak.
	- res renamed csScanPluginsDir() to csScanPluginDir(), added
	  csScanPluginDirs(), and implemented a general csGetPluginMetadata().
	- res removed the fopen() hack.
	- res added Jamfiles for the render loop loader/standard rendersteps
	  along with some minor compile fixes.
	- res updated the MSVC6 makefile templates.
	- res made the following changes to the MSVC warning suppression:
	    - added some missing descriptions of silenced warnings
	    - removed silencing of "unused variable" warning and turned
	      emission of "class has virtual functions, but destructor is not
	      virtual" on. This is the beginning of an attempt to have MSVC
	      emit the same warnings as GCC (as far as possible.) More tweaks
	      will follow over time.
	- res made some common functions 'intrinsic' on MSVC.
	- res fixed a few compiler warnings.
	- Philip Wyett eliminated link errors in many of the applications
	  under GNU Linux.
14-Jun-2003
	- Charlls put a temporal fopen() hack in
	  libs/cssys/general/scanplugins.cpp to fix some linking problems
	  under linux.
	- Jorrit got a fix from Arthur K. (nemerle@lsk.pl) for two memory
	  leaks in AWS.
	- res changed the way how SCF plugin scanning works:
	    - Moved scanning invocation to scfInitialize().
	    - A platform-dependent function, csScanPluginsDir(), returns
	      plugin filenames and metadata.
	    - Such a function is provided for Win32. For unix and MacOS/X,
	      the "old" function that scans for .csplugin files is used.
	- res made the following changes:
	    - The DirectDraw configure time test now also tests for
	      DirectSound, and thus changed the makefile var nomenclature to
	      "DirectX".
	    - Slight changed the way DLLs are loaded on Win32: now
	      LoadLibraryEx() is used with a flag which causes Windows to
	      first look for the actual file in the specified directory.
	    - On Win32, plugin metadata is now contained inside the DLL.
	- res worked around problems with static linking. Specifically, it was
	  assumed that a factory function is always only used for a single
	  class. This is not always the case (e.g. the bezier loader.)
13-Jun-2003
	- Oktal renamed the function AutoLoad slightly, to avoid conflict with
	  the Windows API identifier of the same name, in perlpost.i.
	- Oktal switched Cygwin build from using Winsock to Posix Sockets,
	  since Winsock was confusing Swig.
	- Oktal added #ifndef directives to math2d.h and plane.h in
	  include/csgeom, where those files define the same macros.
	- Eric Sunshine applied a fix to SRC.CSSYS and INC.CSSYS in cssys.mak
	  where it was prefixing an extra $(SRCDIR) to items from SRC.SYS_CSSYS
	  and INC.SYS_CSSYS which already mentioned SRCDIR.  Problem was
	  pointed out by Frank Richter.
	- Jorrit clarified a comment with iEngine->Prepare().
	- Jorrit added two versions iEngine->ForceRelight(). The first version
	  relights all lightmaps in the engine. The second version updates
	  the lightmaps for a given light (i.e. useful after adding
	  a static or pseudo-dynamic light).
	- Jorrit fixed a problem where the engine would always attempt
	  to read precalc_info even if reading from the cache was disabled.
	- Jorrit added a new 'addstlight' command to Walktest. This command
	  adds a static light and uses the new ForceRelight() function to
	  recalculate lighting. alt-l is assigned to this command by default.
	- Jorrit fixed thing so that initializing lighting again will actually
	  cause the lightmaps to be updated correctly.
	- Jorrit forgot to remove a parameter to the second version of
	  ForceRelight().
	- Jorrit added region parameter to ForceRelight().
	- Jorrit added iEngine->RemoveLight() to remove a pseudo-dynamic
	  static lights and also automatically update all lightmaps. In case
	  of a static light this will not update the lightmaps unless
	  ForceRelight() is called later.
	  NOTE! Currently not implemented yet!
	- Jorrit Extended iLightingInfo->InitializeDefault() with a new flag
	  telling the lighting sub-system if the lighting information should
	  be cleared or not. This allows correct handling when a single light
	  is added in case of genmesh and bezier curves.
	- Jorrit added iLightingInfo->StaticLightDisconnect() so that a light
	  can be removed.
	- Jorrit implemented iEngine->RemoveLight(). However since none
	  of the mesh objects correctly implement StaticLightDisconnect()
	  the function will not actually work even though it is fully
	  bugfree :-)
	- Jorrit added 'delstlight' command to walktest to delete a
	  static light. Also changed 'addstlight' to make the light
	  pseudo-dynamic so that removing it works correctly.
	- Eric Sunshine augmented the Jam system so that it now builds the
	  new renderer if --enable-new-renderer was specified with configure.
	- Matze fixed broken install_maps target in jam. And added a TODO.
	- Jorrit fixed thing so that removing a pseudo-dynamic light actually
	  works.
	- Matze fixed broken install_maps target in jam. And added a TODO
